@echo off

@rem save current directory
@set OLDDIR=%CD%

cd %DEPLOYMENTS_FOLDER%\..
rd /S /Q deploymentsLocal
mkdir deploymentsLocal
cd deploymentsLocal

echo Expanding VSS ear...
mkdir vss_ear.ear
cd vss_ear.ear
jar -xfv %MAVEN_REPO_LOC%\gov\va\vss\vss_ear\%VSS_VERSION%\vss_ear-%VSS_VERSION%.ear

echo Expanding VSS web war...
rename vss_web-%VSS_VERSION%.war vss.war
mkdir vss_web-%VSS_VERSION%.war
cd vss_web-%VSS_VERSION%.war
jar -xvf ..\vss.war
cd ..
del vss.war

cd ..

echo Deploying log4j config...
mkdir log4j
copy vss_ear.ear\vss_web-%VSS_VERSION%.war\WEB-INF\log4j\* log4j

echo Deploying properties...
mkdir properties
copy %VSS_CC_PATH%\properties\local\app.properties properties
copy %VSS_CC_PATH%\web\src\main\resources\messages_en.properties messages_en.properties

echo Copying VSS unattended ear...
copy %MAVEN_REPO_LOC%\gov\va\vss\vss_unattended_ear\%VSS_VERSION%\vss_unattended_ear-%VSS_VERSION%.ear .
rename vss_unattended_ear-%VSS_VERSION%.ear vss_unattended_ear.ear

echo Copying VSS help...
copy %MAVEN_REPO_LOC%\gov\va\vss\vss_help\%VSS_VERSION%\vss_help-%VSS_VERSION%.war .
rename vss_help-%VSS_VERSION%.war vsshelp.war

@rem restore current directory
chdir /D %OLDDIR%

echo Deployment complete.