package gov.va.shared.persistence;

import java.time.ZonedDateTime;
import java.util.Collection;

import gov.va.shared.model.AppUser;

public interface AppUserDAO extends AppSortedDAO<AppUser> {

	int updateFieldsWithoutVersionCheck(long appUserID, boolean incrementVersion, Long lastVisitedVAFacilityId,
			ZonedDateTime accountLockDate, Integer failedLoginCount, String hashedPassword);

	Collection<AppUser> findByCriteria(String activeDirectoryName, String userDn, boolean preinitialize);

	AppUser findByUsername(String activeDirectoryName, boolean preinitialize);

	AppUser findRequiredByUsername(String username, boolean preinitialize);

}
