package gov.va.vss.service.batch;

import java.time.ZonedDateTime;

import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.JobExecutionListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import gov.va.vss.model.jobExecution.JobExecutionResult;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionResultDAO;
import gov.va.vss.service.batch.tasklet.AbstractTasklet;

@Component
public class JobExecutionResultCompletionListener implements JobExecutionListener {

	@Autowired
	private JobExecutionResultDAO jobExecutionResultDAO;
	@Autowired
	private JobExecutionResultService jobExecutionResultService;

	@Override
	public void beforeJob(JobExecution jobExecution) {
	}

	@Override
	public void afterJob(JobExecution jobExecution) {
		Long resultId = (Long) jobExecution.getExecutionContext()
				.get(AbstractTasklet.JOB_CONTEXT_ATTR_JOB_RESULT_ID);
		JobExecutionResult result = null;
		if (resultId != null) {
			result = jobExecutionResultDAO.findRequiredByPrimaryKey(resultId);
			result.setEndTime(ZonedDateTime.now());
			result = jobExecutionResultService.saveOrUpdate(result);
		}
	}

}
