package gov.va.vss.service.batch;

import java.time.ZonedDateTime;

import gov.va.vss.model.jobExecution.JobExecutionResult;
import gov.va.vss.model.jobExecution.JobExecutionResultItem;
import gov.va.vss.model.lookup.JobExecutionType.JobExecutionTypeValue;

public interface JobExecutionResultItemService {

	JobExecutionResultItem saveOrUpdate(JobExecutionResultItem item);

	JobExecutionResultItem saveOrUpdateInNewTransaction(JobExecutionResultItem item);

	int deleteByCriteria(Long jobExecutionResultId, ZonedDateTime olderThanDate, JobExecutionTypeValue type,
			Long referenceJobExecutionId);

	/**
	 * Convenience method to create a new result with the specified fields and
	 * save it. The specified JobExecutionResult must be attached.
	 * 
	 * @param result
	 * @param start
	 * @param end
	 * @param successful
	 * @param message
	 * @param ex
	 * @return
	 */
	JobExecutionResultItem saveItemResult(JobExecutionResult result, ZonedDateTime start, ZonedDateTime end,
			boolean successful, String message, Exception ex);

	/**
	 * Convenience method to create a new result with the specified fields and
	 * save it in a new transaction. The specified JobExecutionResult must be
	 * attached.
	 * 
	 * @param result
	 * @param start
	 * @param end
	 * @param successful
	 * @param message
	 * @param ex
	 * @return
	 */
	JobExecutionResultItem saveItemResultInNewTransaction(JobExecutionResult result, ZonedDateTime start,
			ZonedDateTime end, boolean successful, String message, Exception ex);

}
