package gov.va.vss.web.jobResults;

import static gov.va.vss.util.DateUtil.TWO_DIGIT_MILITARY_DATE_TIME;

import java.time.ZonedDateTime;

import org.springframework.format.annotation.DateTimeFormat;

import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.vss.model.lookup.JobExecutionType;

public class JobResultsSearchForm {

	private boolean includeStationlessJobs = false;
	private boolean includeStationSpecificJobs = false;
	private VAFacility stationCode;
	private JobExecutionType jobExecutionType;
	@DateTimeFormat(pattern = TWO_DIGIT_MILITARY_DATE_TIME)
	private ZonedDateTime startDate;
	@DateTimeFormat(pattern = TWO_DIGIT_MILITARY_DATE_TIME)
	private ZonedDateTime endDate;

	public boolean isIncludeStationlessJobs() {
		return includeStationlessJobs;
	}

	public void setIncludeStationlessJobs(boolean includeStationlessJobs) {
		this.includeStationlessJobs = includeStationlessJobs;
	}

	public boolean isIncludeStationSpecificJobs() {
		return includeStationSpecificJobs;
	}

	public void setIncludeStationSpecificJobs(boolean includeStationSpecificJobs) {
		this.includeStationSpecificJobs = includeStationSpecificJobs;
	}

	public VAFacility getStationCode() {
		return stationCode;
	}

	public void setStationCode(VAFacility stationCode) {
		this.stationCode = stationCode;
	}

	public JobExecutionType getJobExecutionType() {
		return jobExecutionType;
	}

	public void setJobExecutionType(JobExecutionType jobExecutionType) {
		this.jobExecutionType = jobExecutionType;
	}

	public ZonedDateTime getStartDate() {
		return startDate;
	}

	public void setStartDate(ZonedDateTime startDate) {
		this.startDate = startDate;
	}

	public ZonedDateTime getEndDate() {
		return endDate;
	}

	public void setEndDate(ZonedDateTime endDate) {
		this.endDate = endDate;
	}

}
