
<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${TARGET_OBJECT_MANIPULATION_PROHIBITED}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<script type="text/javascript">
	var wasFullNamePopulated = ("${command.organization.fullName}".length > 0);

	$(function() {
		$("#submitButton").click(submitForm);

		$("#displayNameInput").change(function() {
			if (!wasFullNamePopulated) {
				$("#fullNameInput").val($("#displayNameInput").val());
			}
		})

		$("#displayNameInput").autocomplete({
			source : function(request, response) {
				var theVal = $.trim($("#displayNameInput").val())
				if (theVal == '') return
				
				var ajaxParms = []
				ajaxParms.push({name: 'wt', value: 'json'})
				ajaxParms.push({name: 'omitHeader', value: 'true'})
				ajaxParms.push({name: 'fl', value: 'name'})
				ajaxParms.push({name: 'fl', value: 'scope'})
				ajaxParms.push({name: 'fl', value: 'id'})
				ajaxParms.push({name: 'q', value: 'name:' + theVal.match(/\S+/g).join(' name:')})
				
				$.ajax({
					url : "${solrBaseURL}/organizations/select/",
					data : $.param(ajaxParms),
					dataType : 'jsonp',
					jsonp : 'json.wrf',
					success : function(data) {
						var docs = JSON.stringify(data.response.docs)
						var jsonData = JSON.parse(docs)
						response($.map(jsonData, function(value, key) {
							return {
								label : value.name,
								// replace this with value.id if needed
								value : value.name
								// , category : value.scope == 'L' ? 'Local' : 'National',
							}
						}))
					},
					error: commonAjaxErrorHandler
				})
			},
			minLength : 1
		})

	<c:if test="${command.organization.id != null && command.organization.inactive == 'true' }">
		// When editing an inactive org, the record is readonly except for the Status field
		$('.organizationInputFields input', '#appContainerDiv').not(".keepEnabledForInactive").attr(
			'disabled', 'disabled')
		$('.nacInputFields input', '#appContainerDiv').attr(
			'disabled', 'disabled')
		$('#organizationForm select', '#appContainerDiv').each(
				function() {
					var selectedVal = $(this).find("option:selected").val();
					if (selectedVal == "-1" || selectedVal == "") {
						$(this).replaceWith("None")
					} else {
						$(this).replaceWith(
								escapeHTML($(this).find("option:selected")
										.text()))
					}
				})
		$('.requdIndicator', '#appContainerDiv').remove()
	</c:if>
	
	
	<c:if test="${command.organization.scope == 'LOCAL'}">
		$("#nacRadioButtonId1").attr("disabled", "disabled");
		$("#nacRadioButtonId2").attr("disabled", "disabled");
		$("#nacExecutiveMemberRadioButtonId1").attr("disabled", "disabled");
		$("#nacExecutiveMemberRadioButtonId2").attr("disabled", "disabled");
		$("#nacStatusSelect").attr("disabled", "disabled");
		$("#ajrMonthSelect").attr("disabled", "disabled");
	</c:if>

	<c:if test="${command.organization.scope == 'NATIONAL'}"> 
		if (${command.organization.onNationalAdvisoryCommittee == 'false'}) {
			setupNACFields("false");
		}
	</c:if>
	
	$("input[name='organization.onNationalAdvisoryCommittee']:radio").on('change', function() {	
		setupNACFields($(this).val());
	}) 
})

function setupNACFields(isNACVal) {
	if (isNACVal == "true") {
		$("#nacExecutiveMemberRadioButtonId1").prop("disabled", false);
		$("#nacExecutiveMemberRadioButtonId2").prop("disabled", false);
		$("#nacStatusSelect").prop("disabled", false);
		$("#ajrMonthSelect").prop("disabled", false);
	} else {
		$("#nacExecutiveMemberRadioButtonId2").prop('checked', true);
		$("#nacExecutiveMemberRadioButtonId1").prop("disabled", true);
		$("#nacExecutiveMemberRadioButtonId2").prop("disabled", true);
		$("#nacStatusSelect").val("-1");
		$("#nacStatusSelect").prop("disabled", true);
		$("#ajrMonthSelect").prop("disabled", true);
	}

}

function submitForm(evt) {
	if (evt != null) {
		doubleClickSafeguard($(evt.currentTarget));
	}
	
    if (!validate()) return;
    
    $('#organizationForm').submit();
}

function validate() {
       var errors = new Array();
 
      if ($("input[name='organization.onNationalAdvisoryCommittee']:checked").val() == "true") {
    	   if ($('#nacStatusSelect').val() == "-1") {
    		   errors.push("Membership Status is required for NAC Members.");
    	   }
        }
       
       if (errors.length > 0) {
          displayAttentionDialog("Please correct the following errors: <ul><li>"
                       + errors.join("</li><li>") + "</li></ul>");                   
       }

       return errors.length == 0;
}

</script>

<style>
.ui-autocomplete-category {
	font-weight: bold;
	padding: .2em .4em;
	margin: .8em 0 .2em;
	line-height: 1.5;
}
</style>

<form:form method="post" action="${home}/organizationSubmit.htm"
	id="organizationForm">
		<div class="organizationInputFields">
			<fieldset>
				<legend>Organization</legend>
					<table>
						<tr>
							<td class='appFieldLabel' nowrap>Scope:</td>
							<td></td>
							<td style="text-align: left"><c:out value="${command.organization.scope}"/>
							<c:if test="${command.organization.scope == 'LOCAL'}">
								<c:out value=" -- ${command.organization.vtkInstitution.name} (${command.organization.vtkInstitution.stationNumber})"/>
							</c:if>
							</td>
						</tr>						
						
						<tr>
							<td class='appFieldLabel' nowrap>Code:</td>
							<td></td>
							<td style="text-align: left">
							<c:if test="${command.organization.code != 0}">
								<c:out value="${command.organization.code}"/></td>
							</c:if>
						</tr>

						<tr>
							<td class='appFieldLabel' nowrap><label for='displayNameInput'>Display
									Name: <span class="invisibleRequiredFor508">*</span>
							</label></td>
							<td style="padding: 4px; text-align: left"><span
								class='requdIndicator'>*</span></td>
							<td style="text-align: left"><app:input id="displayNameInput" path="organization.name"
									size="35" maxLength="35" /> <app:errors path="organization.name"
									cssClass="msg-error" /></td>
						</tr>
						
						<tr>
						<td class='appFieldLabel' nowrap><label for='fullNameInput'>Full
								Name: <span class="invisibleRequiredFor508">*</span></label></td>
						<td style="padding: 4px; text-align: left"><span
								class='requdIndicator'>*</span></td>
						<td style="text-align: left"><app:input id="fullNameInput" path="organization.fullName"
								size="85" maxLength="255" /> <app:errors
								path="organization.fullName" cssClass="msg-error" /></td>
					</tr>
	
					<tr>
						<td class='appFieldLabel'><label for='abbreviationInput'>Abbreviation:</label></td>
						<td></td>
						<td style="text-align: left"><app:input id="abbreviationInput"
								path="organization.abbreviation" size="6" maxLength="6" /> <app:errors
								path="organization.abbreviation" cssClass="msg-error" /></td>
					</tr>
	
					<tr>
						<td class='appFieldLabel'><label for='typeSelect'>Type:
							<span class="invisibleRequiredFor508">*</span></label></td>
						<td style="padding: 4px; text-align: left"><span
								class='requdIndicator'>*</span></td>
						<td style="text-align: left"><app:select id="typeSelect" path="organization.type"
								itemLabel="name" itemValue="id">
								<form:option value="-1" label="-- Select --" />
								<form:options items="${allTypes}" itemValue="id" itemLabel="name" />
							</app:select> <app:errors path="organization.type" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel'><label for='statusRadio'>Status:
								<span class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><form:radiobutton id="statusRadioId1" cssClass="keepEnabledForInactive"
								path="organization.inactive" value="false" />Active 
							<form:radiobutton  id="statusRadioId2"  cssClass="keepEnabledForInactive"
								path="organization.inactive" value="true" />Inactive 
							<app:errors
								path="organization.inactive" cssClass="msg-error" /></td>
					</tr>

			</table>
		</fieldset>
	</div>
	<div class="nacInputFields">
		<fieldset>
			<legend> National Advisory Committee </legend>
			<table>
				<tr>
					<td class='appFieldLabel' nowrap>Member? <span
						class="invisibleRequiredFor508">*</span>
					</td>
					<td style="padding: 4px; text-align: left"><span
						class='requdIndicator'>*</span></td>
					<td style="text-align: left"><form:radiobutton id="nacRadioButtonId1"
							path="organization.onNationalAdvisoryCommittee" value="true" />Yes
						<form:radiobutton id="nacRadioButtonId2"
							path="organization.onNationalAdvisoryCommittee" value="false" />No
						<app:errors path="organization.onNationalAdvisoryCommittee"
							cssClass="msg-error" /></td>
				</tr>

				<tr>
					<td class='appFieldLabel' nowrap>Executive Member?</td>
					<td></td>
					<td style="text-align: left"><form:radiobutton id="nacExecutiveMemberRadioButtonId1"
							path="organization.nacExecutiveMember" value="true" />Yes <form:radiobutton
							id="nacExecutiveMemberRadioButtonId2"
							path="organization.nacExecutiveMember" value="false" />No <app:errors
							path="organization.nacExecutiveMember" cssClass="msg-error" /></td>
				</tr>

				<tr>
					<td class='appFieldLabel'>Membership Status:</td>
					<td></td>
					<td style="text-align: left"><app:select id="nacStatusSelect"
							path="organization.nacMembershipStatus">
							<form:option value="-1" label="-- Select --" />
							<form:options items="${allNacStatuses}" itemValue="id"
								itemLabel="membershipStatus" />
						</app:select> <app:errors path="organization.nacMembershipStatus"
							cssClass="msg-error" /></td>
				</tr>

				<tr>
					<td class='appFieldLabel'>Annual Joint Review (AJR) Month:</td>
					<td></td>
					<td style="text-align: left"><app:select id="ajrMonthSelect"
							path="organization.annualJointReviewMonth">
							<form:option value="" label="-- Select --" />
							<form:options items="${allMonths}" itemValue="value" />
						</app:select> <app:errors path="organization.annualJointReviewMonth"
							cssClass="msg-error" /></td>
				</tr>
			</table>
		</fieldset>
	</div>

	<div align="center">
		<c:if test="${not TARGET_OBJECT_MANIPULATION_PROHIBITED}">
			<a id="submitButton" class="buttonAnchor keepEnabledForInactive" href="#">Submit</a>
		</c:if>
		<a id="cancelFormButton" class="buttonAnchor keepEnabledForInactive"
			href="${most_recent_breadcrumb}">Cancel</a>
	</div>

</form:form>
