<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript">
	$(function() {
		$("#submitFormButton").click(submitForm)
		refreshStaffTable()
	})
	
	var staffList = new Object()
	
	function refreshStaffTable() {
		staffList = new Object()
		
		$.ajax({
			url : ajaxHomePath + '/voluntaryServiceStaff',
			dataType : 'json',
			data : {
				// serviceParametersId: '${command.serviceParameters.id}'
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				/* array of rows */
				
				var rArray = new Array()
				var curDate = new Date()
				for (var i = 0; i < response.length; i++) {
					staffList[response[i].id] = response[i]
					
					/* array of columns for current row */
					rArray[rArray.length] = new Array(												
						escapeHTML(response[i].appUser.lastName + ", " + response[i].appUser.firstName),
						escapeHTML(response[i].staffTitle ? response[i].staffTitle.title : ''),
						escapeHTML(response[i].vavsLeadership ? 'Yes' : 'No'), 
						escapeHTML(response[i].vavsStartDate), 
						escapeHTML(response[i].vavsStartDate), 
						'<div style="margin:0 auto; text-align:center"><a href="javascript:showStaffDetailsPopup(' + response[i].id + ')"><img src="'+ imgHome + '/edit_18x18.png" border="0" hspace="5" aligh="center"/></a>'  +
						'<a href="javascript:deleteStaff(' + response[i].id + ')"><img src="'+ imgHome + '/permanently_delete_18x18.png" border="0" hspace="5" aligh="center"/></a></div>')
					  }

				/* generated by inc_jqueryTable.jsp, see below */
				staffRefreshData(rArray)
		    }
		})
	}
	
	function deleteStaff(staffId) {
		var fullObj = staffList[staffId]
		$.ajax({
			url : ajaxHomePath + '/deleteServiceStaff',
			dataType : 'json',
			data : {
				serviceStaffId: staffId
			 },
			
			error : commonAjaxErrorHandler,
			success : function() {
				/* generated by inc_jqueryTable.jsp, see below */
				refreshStaffTable()
		    }
		})
	}  
	
	function submitForm(evt) {
		if (!validate())
			return
		if (evt != null)
			doubleClickSafeguard($(evt.currentTarget))
		$('#serviceParametersForm').submit()
	}

	function validate() {
		var errors = new Array()

		if ($('#phoneId').val() != '' && !validatePhone($('#phoneId').val())) {
			errors.push("You must enter a valid primary phone number.");
		}
		
		if ($('#secPhoneId').val() != '' && !validatePhone($('#secPhoneId').val())) {
			errors.push("You must enter a valid alternate phone number.");
		}
		
		if ($('#faxId').val() != '' && !validateFax($('#faxId').val()))
			errors.push("You must enter a valid fax number.");

		if ($('#operCostId').val() != '' && !validateNumeric($('#operCostId').val()))
			errors.push("You must enter a nonleading 0 numeric number for operating costs.");
		
		if ($('#staffCostId').val() != '' && !validateNumeric($('#staffCostId').val()))
			errors.push("You must enter a nonleading 0 numeric number for staff costs.");
		
		if (errors.length > 0)
			displayAttentionDialog("Please correct the following errors: <ul><li>"
					+ errors.join("</li><li>") + "</li></ul>");

		return errors.length == 0
	}
</script>

<style>
div.serviceParametersInputFields {
	min-width: 600px;
}
</style>

<c:if test="${TARGET_OBJECT_MANIPULATION_PROHIBITED}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<form:form method="post" action="${home}/serviceParametersSubmit.htm"
	id="serviceParametersForm">
	<div class="serviceParametersInputFields">
		<fieldset>
			<br>
			<legend> Service And Contact Information </legend>
			<div class="leftHalf">
				<table>
					<tr>
						<td class='appFieldLabel' nowrap><label
							for='serviceTitleInput'>Service Title:<span
								class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="text-align: left"><span class='requdIndicator'>*</span></td>
						<td><app:input size="30" id="serviceTitleInput"
								path="serviceParameters.serviceTitle" /> <app:errors
								path="serviceParameters.serviceTitle" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Primary Phone:</td>
						<td></td>
						<td><app:input path="serviceParameters.primaryPhone"
								id="phoneId" cssClass="phoneextmask" size="20" /> <app:errors
								path="serviceParameters.primaryPhone" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel'>Fax Number:</td>
						<td></td>
						<td><app:input path="serviceParameters.faxNumber" id="faxId"
								cssClass="faxmask" size="20" /> <app:errors
								path="serviceParameters.faxNumber" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel'>Chief's Immediate Supervisor:</td>
						<td></td>
						<td><app:input path="serviceParameters.chiefManager"
								size="30" maxlength="30" /> <app:errors
								path="serviceParameters.chiefManager" cssClass="msg-error" /></td>
					</tr>
				</table>
			</div>

			<div class="rightHalf">
				<table>

					<tr>
						<td class='appFieldLabel'><label for='serviceTypeSelect'>Service
								Type:</label></td>
						<td><app:select id="serviceTypeSelect"
								path="serviceParameters.vtkVoluntaryServiceType"
								itemLabel="name" itemValue="id">
								<form:option value="-1" label="-- Select --" />
								<form:options items="${allServiceTypes}" itemLabel="name"
									itemValue="id" />
							</app:select> <app:errors path="serviceParameters.vtkVoluntaryServiceType"
								cssClass="msg-error" /></td>

					</tr>
					<tr>
						<td class='appFieldLabel'>Alternate Phone:</td>
						<td><app:input path="serviceParameters.secondaryPhone"
								id="secPhoneId" cssClass="phoneextmask" size="20" /> <app:errors
								path="serviceParameters.secondaryPhone" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel'>Mail Stop:</td>
						<td><app:input size="11" maxlength="6"
								path="serviceParameters.mailStop" /> <app:errors
								path="serviceParameters.mailStop" cssClass="msg-error" /></td>
					</tr>
				</table>
			</div>
		</fieldset>
	</div>
	<div class="clearCenter"></div>
	<div class="serviceParametersInputFields">
		<div class="leftHalf">
			<fieldset>
				<legend>VAVS Information</legend>

				<table>
					<tr>

						<td class='appFieldLabel' nowrap><label
							for='isVAVSCommitteeInput'>VAVS Committee:<span
								class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="text-align: left"><span class='requdIndicator'>*</span></td>
						<td><form:radiobutton
								path="serviceParameters.isVAVSCommittee" value="True" />Yes<form:radiobutton
								path="serviceParameters.isVAVSCommittee" value="False" />No</td>
						<td><app:errors path="serviceParameters.isVAVSCommittee"
								cssClass="msg-error" /></td>
					</tr>
				</table>

				<table>
					<tr>
						<td class='appFieldLabel'>VAVS Information Last Reviewed:</td>
						<td></td>
						<td><app:input path="serviceParameters.lastUpdated"
								disabled="true" /> <app:errors
								path="serviceParameters.lastUpdated" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap><label
							for='updateLastRevDateInput'>Update VAVS Last Reviewed
								Date:<span class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="text-align: left"><span class='requdIndicator'>*</span></td>

						<td><form:radiobutton path="changeLastReviewedDate"
								value="True" />Yes<form:radiobutton
								path="changeLastReviewedDate" value="False" />No</td>
						<td><app:errors path="changeLastReviewedDate"
								cssClass="msg-error" /></td>
					</tr>
				</table>
			</fieldset>
		</div>

		<div class="rightHalf">
			<fieldset>
				<legend>Costs</legend>
				<table>
					<tr>
						<td class='appFieldLabel'>Operating Costs $:</td>
						<td><app:input size="15" maxlength="14"
								path="serviceParameters.operatingCosts" cssClass="monetaryInput" id="operCostId" /> <app:errors
								path="serviceParameters.operatingCosts" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel'>Staff Costs $:</td>
						<td><app:input size="15" maxlength="14"
								path="serviceParameters.staffCosts" cssClass="monetaryInput" id="staffCostId" /> <app:errors
								path="serviceParameters.staffCosts" cssClass="msg-error" /></td>
					</tr>
				</table>
			</fieldset>
		</div>
	</div>

	<div class="clearCenter">
		<c:if test="${not TARGET_OBJECT_MANIPULATION_PROHIBITED}">
			<a class="buttonAnchor" id="submitFormButton" tabIndex="0">Submit</a>
		</c:if>
		<a id="cancelOperationBtn" class="buttonAnchor"
			href="${most_recent_breadcrumb}">Cancel</a>
	</div>

</form:form>
<p>

<div class="serviceParametersInputFields">
	<fieldset>
		<legend>VAVS Staff Members</legend>

		<div align="center">
			<sec:authorize
				access="hasAnyAuthority('${PERMISSION_ORG_CODE_NATIONAL_CREATE}, 
										 ${PERMISSION_ORG_CODE_LOCAL_CREATE}')">
				<a class="buttonAnchor" id="createButton"
					href="javascript:showStaffDetailsPopup()">Assign Staff</a>
				</sec:authorize>
		</div>
		<table class="formatTable" id="staffList" border="1"
			summary="List of Staff">
			<thead>
				<tr>
					<th width="15%">Name</th>
					<th width="30%">Title</th>
					<th width="15%">VAVS Leadership Board</th>
					<th width="15%">Start Date</th>
					<th width="15%">End Date</th>
					<th width="10%">Actions</th>
				</tr>
			</thead>
			<tbody>
			</tbody>
		</table>
	</fieldset>
</div>

<jsp:include page="/WEB-INF/jsp/shared/inc_jqueryTable.jsp">
	<jsp:param name="dataTableId" value="staffList" />
	<jsp:param name="refreshDataMethod" value="staffRefreshData" />
</jsp:include>

<%@ include file="/WEB-INF/jsp/serviceParameters/serviceStaffDetail.jsp"%>

