<%@ include file="../shared/inc_header.jsp"%>

<jsp:include page="/WEB-INF/jsp/shared/inc_appUserSearchPopup.jsp">
	<jsp:param name="uniqueSearchPopupId" value="staffSearch" />
	<jsp:param name="resultCallbackMethod" value="ldapCallback" />
</jsp:include>

<script type="text/javascript">
$(function() {
	$("#staffDetailsDialog").dialog({
		autoOpen : false,
		modal : true,
		width : 800,
		height : 580,
		closeOnEscape : false,
		draggable : true,
		resizable : true,
		buttons : {
			'Cancel' : function() {
				$(this).dialog('close')
			},
			'Submit' : submitStaffDetails
		}
	})
	
	$("#staffDetailsDialog").show()
	/*
	 * Required to solve 508 issue not reading dialog box title. It is also
	 * required to disable dialog animation to enable this functionality
	 */
	$('#staffDetailsDialog').focus()
	
	$(['#staffVavsStartDate', '#staffVavsEndDate', '#staffRetirementEligibleDate',
	   '#staffRetirementEstimateDate']).each(function(index, o) {
		$(o).enableDatePicker({
			showOn : "button",
			buttonImage : imgHome + "/calendar.gif",
			buttonImageOnly : true
		})
		$(o).mask("${TWO_DIGIT_DATE_MASK}")
	})
	
})

function ldapCallback(userObj) {
	$("#newStaffUserName").val(userObj.username)
	$("#staffLastName").text(userObj.lastName)
	$("#staffFirstName").text(userObj.firstName)
	$("#staffTitle").text(userObj.title)
	$("#staffDepartment").text(userObj.department)
	$("#staffOffice").text(userObj.office)
	$("#staffTelephoneNumber").text(userObj.telephoneNumber)
	$("#staffEmail").text(userObj.email)
	$("#staff    Name").val('')
	$("#staffId").val('')
	$(".staffDetailsDisplay").show()
}

function showStaffDetailsPopup(staffId) {
	var hasStaffId = (typeof staffId !== 'undefined')
	
	$(".staffDetailsDisplay").toggle(hasStaffId)
	$("#staffSearchButton").toggle(!hasStaffId)
	
	if (hasStaffId) {
		 var fullObj = staffList[staffId]
			
		$("#staffId").val(staffId)
		$("#staffLastName").text(fullObj.appUser.lastName)
		$("#staffFirstName").text(fullObj.appUser.firstName)
		$("#staffTitle").text(fullObj.appUser.title)
		$("#staffDepartment").text(fullObj.appUser.department)
		$("#staffOffice").text(fullObj.appUser.office)
		$("#staffTelephoneNumber").text(fullObj.appUser.telephoneNumber)
		$("#staffEmail").text(fullObj.appUser.email)
		$("#staff    Name").val(fullObj.nickName)
		$("#staffNamePrefix").val(fullObj.namePrefix)
		$("#staffVavsRole").val(fullObj.staffTitle ? fullObj.staffTitle.id : '')
		$("#staffGrade").val(fullObj.grade)
		$("#staffVavsStartDate").val(fullObj.vavsStartDate)
		$("#staffVavsEndDate").val(fullObj.vavsEndDate)
		$("#staffRetirementEligibleDate").val(fullObj.retirementEligibleDate)
		$("#staffRetirementEstimateDate").val(fullObj.retirementEstimateDate)
		$("input[name=vavsLeadership][value=" + (fullObj.vavsLeadership ? "Yes" : "No")
		                              + "]").prop("checked", true)
		$("#staffComment").val(fullObj.comment)
	}
	
	$("#staffDetailsDialog").dialog('open')
	if (!hasStaffId) {
		
		$("#staffLastName").text('')
		$("#staffFirstName").text('')
		$("#staff    Name").val('')
		$("#staffNamePrefix").val('')
		$("#staffVavsRole").val('')
		$("#staffGrade").val('')
		$("#staffVavsStartDate").val('')
		$("#staffVavsEndDate").val('')
		$("#staffRetirementEligibleDate").val('')
		$("#staffRetirementEstimateDate").val('') 
		/*
		$("input[name=vavsLeadership][value=" +  "No")
		                              + "]").prop("checked", true)
		$("#staffComment").val('') */
		popupAppUserSearch('staffSearch')
	}
}
	
function submitStaffDetails() {
	var myServiceStaffId = $("#staffId").val()
	var myUsername = $("#newStaffUserName").val()
	
	/* Run some validations - CPB */
	if (myServiceStaffId == '' &&  myUsername == '') {
		displayAttentionDialog('Please search and select a staff user.')
		return
	}
	
	var myStaffVavsRole = $("#staffVavsRole").val()
	if (myStaffVavsRole == '') {
		displayAttentionDialog('Please select a VAVS role.')
		return
	}
	
	var myVavsLeadership = $("input[type='radio'][name='vavsLeadership']:checked").val()
	if (!myVavsLeadership) {
		displayAttentionDialog('Please select a VAVS leadership option.')
		return
	}
	
	/* If validations pass, submit to server - CPB */
	$.ajax({
		url : ajaxHomePath + '/voluntaryServiceStaffCreateOrUpdate',
		method: 'POST',
		dataType : 'json',
		data : {
			serviceStaffId: myServiceStaffId,
			newStaffUserName: myUsername,
			nickName: $("#staff    Name").val(),
			staffNamePrefix: $("#staffNamePrefix").val(),
			staffGrade: $("#staffGrade").val(),
			staffVavsRole: myStaffVavsRole,
			staffVavsStartDate: $("#staffVavsStartDate").val(),
			staffVavsEndDate: $("#staffVavsEndDate").val(),
			staffRetirementEligibleDate: $("#staffRetirementEligibleDate").val(),
			staffRetirementEstimateDate: $("#staffRetirementEstimateDate").val(),
			staffIsVavsLeadership: myVavsLeadership,
			staffComment: $("#staffComment").val()
		},
		error : commonAjaxErrorHandler,
		success : function(response) {
			$("#staffDetailsDialog").dialog('close')
			/* generated by inc_jqueryTable.jsp, see below */
			refreshStaffTable()
	    }
	})
}
</script>

<div id="staffDetailsDialog" style="display: none" title="Staff Details">
	<input type="hidden" id="staffId" value="" /> <input type="hidden"
		id="newStaffUserName" value="" />


	<div id="staffSearchButton"
		style="text-align: center; margin: 0 auto; display: none">
		<a class="buttonAnchor"
			href="javascript:popupAppUserSearch('staffSearch')">Search</a>
	</div>

	<div class="serviceStaffInputFields staffDetailsDisplay">
		<fieldset>
			<div class="leftHalf">
				<legend>Staff Information</legend>
				<table>
					<tr>
						<td class='appFieldLabel' nowrap>Last Name:</td>
						<td></td>
						<td><span id="staffLastName"></span></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>First Name:</td>
						<td></td>
						<td><span id="staffFirstName"></span></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Middle Name/Initial:</td>
						<td></td>
						<td><span id="staffLastName"></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Job Title:</td>
						<td></td>
						<td><span id="staffTitle"></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Department:</td>
						<td></td>
						<td><span id="staffDepartment"></td>
					</tr>
				</table>
			</div>
			<div class="rightHalf">
				<table>
					<tr>
						<td class='appFieldLabel' nowrap>    name:</td>
						<td></td>
						<td><input type="text" id="staff    Name" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Salution:</td>
						<td></td>
						<td><input type="text" id="staffNamePrefix" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Office:</td>
						<td></td>
						<td><span id="staffOffice"></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Business Phone:</td>
						<td></td>
						<td><span id="staffTelephoneNumber"></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Email Address:</td>
						<td></td>
						<td><span id="staffEmail"></td>
					</tr>
				</table>
			</div>
		</fieldset>

		<fieldset class="staffDetailsDisplay">
			<legend>Voluntary Service</legend>
			<table>
				<tr>
					<td class='appFieldLabel' nowrap>VAVS Role:<span
						class="invisibleRequiredFor508">*</span></td>
					<td><span class='requdIndicator'>*</span></td>
					<td colspan="4"><select id="staffVavsRole">
							<option value="">Please select...</option>
							<c:forEach items="${allStaffTitles}" var="title">
								<option value="${title.id}"><c:out
										value="${title.title}" /></option>
							</c:forEach>
					</select></td>
				</tr>
				<tr>
					<td class='appFieldLabel' nowrap>Grade:</td>
					<td></td>
					<td><input type="text" id="staffGrade" value="" /></td>
					<td width="15" rowspan="3">&nbsp;</td>
					<td class='appFieldLabel' nowrap>VAVS Leadership Board?<span
						class="invisibleRequiredFor508">*</span></td>
					<td><span class='requdIndicator'>*</span></td>
					<td><nobr>
							<input type="radio" name="vavsLeadership" id="vavsLeadershipYes"
								value="Yes" />Yes <input type="radio" name="vavsLeadership"
								id="vavsLeadershipNo" value="No" />No
						</nobr></td>
				</tr>
				<tr>
					<td class='appFieldLabel' nowrap>VAVS Start Date:</td>
					<td></td>
					<td><input size="12" id="staffVavsStartDate" /></td>
					<td class='appFieldLabel' nowrap>VAVS End Date:</td>
					<td></td>
					<td><input size="12" id="staffVavsEndDate" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel' nowrap>Date Eligible for Retirement:</td>
					<td></td>
					<td><input size="12" id="staffRetirementEligibleDate" /></td>
					<td class='appFieldLabel' nowrap>Estimated Date of Retirement:</td>
					<td></td>
					<td><input size="12" id="staffRetirementEstimateDate" /></td>
				</tr>


			</table>
		</fieldset>
	</div>
	<div class="serviceStaffInputFields">
		<fieldset class="staffDetailsDisplay">
			<legend>Comments</legend>
			<textarea rows="5" cols="118" id="staffComment"></textarea>
		</fieldset>
	</div>
</div>