<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript" src="${jsHome}/jquery.quicksearch.js"></script>

<%-- Option 1 for Multi-select from http://loudev.com/#demos --%>
<link type="text/css" rel="Stylesheet" href="${cssHome}/multi-select.css" />
<script type="text/javascript" src="${jsHome}/jquery.multi-select.js"></script>

<%-- Escaping XML here for good practice since we use the raw EL expressions later --%>
<c:set var="reportParamId" value="${fn:escapeXml(param.reportParamId)}" />
<c:set var="reportParamPrompt"
	value="${fn:escapeXml(param.reportParamPrompt)}" />
<c:set var="quickSearchPrompt"
	value="${fn:escapeXml(param.quickSearchPrompt)}" />
<c:set var="selectListPopulatorURI"
	value="${fn:escapeXml(param.selectListPopulatorURI)}" />

<div id='${reportParamId}_container_div'>
    ${reportParamPrompt}: 
    (<a id='select-all-${reportParamId}' href='#'>Select All</a> \ <a id='deselect-all-${reportParamId}' href='#'>DeSelect All</a>)      
    <select multiple="multiple" id="${reportParamId}" name="${reportParamId}">      
    </select>    
 </div> 
 

 <script type="text/javascript">
	
	$(function() {
		
		
		
		function setSelectListItems(responseList) {
			
			$.each(responseList, function (i, itemInResponseList) {
				
			    $('#${reportParamId}').append($('<option>', { 
			        value: itemInResponseList.id,
			        text : itemInResponseList.displayName 
			    }));
			});
			enableMultiSelect();
		}
		
		
		function refresh() {
			//alert('server url for list refresh '+ajaxHomePath+"${selectListPopulatorURI}");
			$.ajax({
				//url : ajaxHomePath + "/assignedStations",
				url: ajaxHomePath+"${selectListPopulatorURI}",
				type : "GET",
				dataType : 'json',				
				error : commonAjaxErrorHandler,
				success : setSelectListItems
			})
		}
		
		refresh();
		
		function enableMultiSelect(){
			$('#${reportParamId}').multiSelect({
				
				  //Enabling quick search				
				  selectableHeader: "<input type='text' class='search-input' autocomplete='off' placeholder='${quickSearchPrompt}'>",
				  selectionHeader: "<input type='text' class='search-input' autocomplete='off' placeholder='${quickSearchPrompt}'>",
				  afterInit: function(ms){
				    var that = this,
				        $selectableSearch = that.$selectableUl.prev(),
				        $selectionSearch = that.$selectionUl.prev(),
				        selectableSearchString = '#'+that.$container.attr('id')+' .ms-elem-selectable:not(.ms-selected)',
				        selectionSearchString = '#'+that.$container.attr('id')+' .ms-elem-selection.ms-selected';

				    that.qs1 = $selectableSearch.quicksearch(selectableSearchString)
				    .on('keydown', function(e){
				      if (e.which === 40){
				        that.$selectableUl.focus();
				        return false;
				      }
				    });

				    that.qs2 = $selectionSearch.quicksearch(selectionSearchString)
				    .on('keydown', function(e){
				      if (e.which == 40){
				        that.$selectionUl.focus();
				        return false;
				      }
				    });
				  },
				  afterSelect: function(values){
				    this.qs1.cache();
				    this.qs2.cache();
				    var selectedValuesStr = values+'';
				    var selectedValues = selectedValuesStr.split(',');
				    
				    $('#${reportParamId} option').each(function(){
				    	if($.inArray($(this).attr('value'), selectedValues)>-1){
				    		$("#${reportParamId} option[value=" + $(this).attr('value') + "]").prop('selected', true);
				    	}
				    });

							    
				  },
				  afterDeselect: function(values){
				    this.qs1.cache();
				    this.qs2.cache();
				    var deSelectedValuesStr = values+'';
				    var deSelectedValues = deSelectedValuesStr.split(',');				    
				    
				    $('#${reportParamId} option').each(function(){
				    	if($.inArray($(this).attr('value'), deSelectedValues)>-1){
				    		$("#${reportParamId} option[value=" + $(this).attr('value') + "]").prop('selected', false);
				    	}
				    });
				
				  }			
				
			});
			
			$('#select-all-${reportParamId}').click(function(){
				  $('#${reportParamId}').multiSelect('select_all');
				  return false;
				});
			$('#deselect-all-${reportParamId}').click(function(){
				  $('#${reportParamId}').multiSelect('deselect_all');
				  return false;
			});
		}
		
		
	});
	
</script>

 <style>
 /** Quick search and multi select customizations **/
.ms-container .ms-selectable li.ms-elem-selectable, .ms-container .ms-selection li.ms-elem-selection{
	font-size: 9px;
}

.ms-container ul {
	margin:10px;
}

.search-input {
    margin-top: 10px;
}
 
 </style>
 