jQuery.fn.reverse = [].reverse
	
/*
 * Setting cache to false so that I   o s t fetch the content from the cache for
 * ajax requests (which it does by default on ajax get requests if response type
 * is jsonp or script)
 */
var csrfData = {}
csrfData[csrfParamName] = csrfValue

$.ajaxSetup({
  	cache:false,
  	data: csrfData
})

var militaryZonedDateTimeRegex = /^([0]\d|[1][0-2])\/([0-2]\d|[3][0-1])\/([2][01]|[1][6-9])\d{2}(\s([0]\d|[1]\d|[2][0-3])(\:[0-5]\d){1,2})*\s*$/;

suppressAjaxSpinner = false

$(function() {
	$("input:submit, a.buttonAnchor, a.submitAnchor, button").button()
	
	$("#spinner").hide()
	
	$(document).ajaxStart(function() {
			if (!suppressAjaxSpinner) {
				var topDomZIndex = $.topZIndex("div")
				$("#spinner").show()
				$("#spinner").css('z-index',topDomZIndex+1)
			}
		})
	$(document).ajaxStop(function() {
		$("#spinner").hide();
		$("#spinner").css('z-index','1')
		})
	$(document).ajaxError(function() {
		$("#spinner").hide();
		$("#spinner").css('z-index','1')
		})
		
	$(".confirm").easyconfirm()

	// Get all textareas that have a "maxlength" property.
    $('textarea[maxlength]').each(function() {
        // Store the jQuery object to be more efficient...
        var $textarea = $(this)
        // Store the maxlength and value of the field.
        var maxlength = $textarea.attr('maxlength')
        var val = $textarea.val()
        // Trim the field if it has content over the maxlength.
        $textarea.val(val.slice(0, maxlength))
        // Bind the trimming behavior to the "keyup" event.
        $textarea.bind('keyup', function() {
        	if ($textarea.val().length > maxlength) {
           		 $textarea.val($textarea.val().slice(0, maxlength))
        	}
        })
    })
    
	/* Wrap all selects whose current value is inactive - CPB */
	
	$('select.inactiveAppSelect').each(function() {
		var code = $(this).attr("inactiveAppLookupCode")
		/*
		 * If we're including the inactive value in the dropdown as a valid
		 * selection, don't wrap the select
		 */
		if ($(this).find("option[value='" + code + "']").length > 0)
			return
			
		var table = $('<table cellpadding="5" class="inactiveAppSelectWrapper"><tr>'+				
				'<td>' + $(this).attr("inactiveAppLookupName") + ' (inactive)</td>' +
			'</tr>' +
		'</table>')
		
		$(this).replaceWith(table)
	})
	
   // formats text input in fax input fields
   $(".faxmask").mask("999-999-9999", {autoclear: false});
   // formats text input in phone input fields
   $(".phoneextmask").mask("999-999-9999 ?x99999" , {autoclear: false});
  
})

function showAll(idArray) {
	$.each(idArray,
		function(index, item) {
			$(item).show()
		})
}

function hideAll(idArray) {
	$.each(idArray,
		function(index, item) {
			$(item).hide()
		})
}

function escapeHTML(theVal) {
	if (theVal == null) return null
	theVal = $('<div />').text(theVal).html()
	theVal = theVal.replace(/\"/g,"&quot;")
	theVal = theVal.replace(/\'/g,"&#39;")
	return theVal
}

function convertLinefeedToBR(str) {
	return str.replace(/[\r?\n]/g, '<br />')
}

(function($) {
	$.fn.outerHtml = function() {
	  return $('<div />').append(this.eq(0).clone()).html()
	}
})(jQuery);

(function($) {
 $.widget( "ui.dialog", $.ui.dialog, {
		 _setOption: function( key, value ) {
			// For title ensure that escapeHTML has been called before
			// setting it on the dialog
			 if (key=='title')  {
				value = escapeHTML(value);
			 }
			// call _super to call extended widget behavior
			 this._super( key, value );	
	  }
   })
})(jQuery)

$('.inner').wrap(function() {
  return '<div class="' + $(this).text() + '" />';
})

function doubleClickSafeguard(jqueryObjToDisable) {
	jqueryObjToDisable.button("option", "disabled", true)
	setTimeout(function() { jqueryObjToDisable.button("option", "disabled", false) }, 2000)
}

function doubleSubmitFormSafeguard(form) {
	// if(form.data.submitted) {
	// alert("Form is already submitted!");
	// return false;
	// } else {
	// form.data.submitted=true;
		return true;
	// }
}

function applyFocusToFirstActiveField() {
	// Focus on the first enabled, visible, input or textarea on the form
	var enabledVisibleInputsSet = $("#AppContainerDiv")
			.find(
					':input:enabled:visible, textarea:enabled:visible, select:enabled:visible')
					
	var anyDialogVisible = $(".ui-dialog").is(":visible");
	if (enabledVisibleInputsSet.size() > 0) {
		if (!anyDialogVisible) {
				enabledVisibleInputsSet.first().focus()
		}
	} else {
		$('#homeLink').focus()
	}
}

function validateEmail(email) {
	var emailcheck = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
	return emailcheck.test(email);
}

function validatePhone(phone) {
	var phoneCheck = /^\(?(\d{3})\)?[-]?(\d{3})[-]?(\d{4})[ ]?(x)?(\d{1,5})?$/;
	return phoneCheck.test(phone);
}

function validateFax(fax) {
	var faxCheck = /^\(?(\d{3})\)?[-]?(\d{3})[-]?(\d{4})[ ]?$/;
	return faxCheck.test(fax);
}

function validateNumeric(numeric) {
	numericNum=removeCommas(numeric);
	var numericCheck = /^[1-9]\d*(\.\d+)*$/;
	return numericCheck.test(numericNum);
}

function removeCommas(str) {
    while (str.search(",") >= 0) {
        str = (str + "").replace(',', '');
    }
    return str;
};

function getBoxEl(theHtml, addBorder) {
	var newEl = $("<div></div>")
		.css({'border' : addBorder ? '1px dashed black' : 'none',
			'text-align' : 'left',
			'padding' : '5px',
			'margin' : '2px',
			'display' : 'inline-block',
			'width' : '100%',
			'box-sizing' : 'border-box'
			}).html(theHtml)
	return newEl
}

function commonAjaxErrorHandler(jqXHR, textStatus, errorThrown) {
	var errorText = errorThrown
	var details = null
	if (jqXHR.status == 404 || jqXHR.status == 0) {
		errorText = 'The server is offline or could not be contacted.'
	} else if (jqXHR.status == 403) {
		errorText = 'Your request was denied, possibly due to a session timeout or server restart. Please logout and login again.'
	} else if (jqXHR.responseJSON) {
		var ar = jqXHR.responseJSON.ajaxResult
		if (ar) {
			errorText = ar.statusMessage
			details = ar.statusDetails
		}
	} else if (jqXHR.responseText) {
		details = jqXHR.responseText
	}
	
	if (errorText == null) errorText = 'Unknown error'
	
	displayAttentionDialog(errorText, details, 'Error')
}


function abbreviate(str, maxLen) {
	var oneThird = maxLen / 3
	var twoThirds = maxLen * 2 / 3
	if (str.length > maxLen)
	    return str.substr(0, twoThirds) + '...' + str.substr(str.length-oneThird, str.length);
	return str;
}