package gov.va.vss.persistence;

import org.junit.Assert;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.shared.test.AbstractDAOTest;
import gov.va.vss.model.AppUserVistaInfo;
import gov.va.vss.persistence.dao.AppUserVistaInfoDAO;
import gov.va.vss.persistence.dao.CustomizableAppDAO;

public class TestAppUserVistaInfoDAO extends AbstractDAOTest<AppUserVistaInfo> {

	@Autowired
	protected AppUserVistaInfoDAO appUserVistaInfoDAO;

	private AppUserVistaInfo createInstance() {
		VAFacility facility = vaFacilityDAO.findByStationNumber("442");
		AppUserVistaInfo result = new AppUserVistaInfo();
		result.setUser(user);
		result.setVAFacility(facility);
		result.setVistaId("1234567890TEST");
		result = appUserVistaInfoDAO.saveOrUpdate(result);
		return result;
	}

	@Override
	protected CustomizableAppDAO<AppUserVistaInfo> getDAO() {
		return appUserVistaInfoDAO;
	}

	@Override
	protected AppUserVistaInfo getInstanceToSave() {
		return createInstance();
	}

	@Override
	protected boolean testDelete() {
		return false;
	}

	@Test
	public void testFind() throws Exception {
		AppUserVistaInfo obj = createInstance();
		AppUserVistaInfo obj2 = appUserVistaInfoDAO.findByAppUserIdAndStationNumber(obj.getUser().getId(),
				obj.getVAFacility().getStationNumber());
		Assert.assertEquals(obj, obj2);
	}

}
