package gov.va.vss.persistence.lookup;

import org.junit.Test;

import gov.va.shared.model.lookup.sds.State;
import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.vss.model.lookup.VtkInstitution;
import gov.va.vss.model.lookup.VtkInstitutionType;
import gov.va.vss.model.lookup.VtkInstitutionType.VtkInstitutionTypeValue;
import gov.va.vss.model.lookup.VtkState;
import gov.va.vss.persistence.AbstractSortedDAOTest;
import gov.va.vss.persistence.dao.CustomizableSortedDAO;

public class TestVtkInstitutionDAO extends AbstractSortedDAOTest<VtkInstitution> {

	@Override
	protected CustomizableSortedDAO<VtkInstitution> getSortedDAO() {
		return vtkInstitutionDAO;
	}

	@Override
	protected VtkInstitution getInstanceToSave() throws Exception {
		VAFacility facility = createNewVAFacility("999_UT");
		State state = stateDAO.findStateByPostalCode("CO");
		VtkState vtkState = vtkService.getOrCreateForSDSState(state.getId());
		VtkInstitutionType type = vtkInstitutionTypeDAO.findByLookup(VtkInstitutionTypeValue.TIMEKEEPING);
		VtkInstitution newInstitution = VtkInstitution.createNew(facility, vtkState, type, null);
		return newInstitution;
	}

	@Test
	public void testFindBySDSFacility() throws Exception {
		vtkInstitutionDAO.findBySDSFacility(getFacility().getId());
	}

}
