package gov.va.vss.service.batch;

import java.util.Date;

import org.junit.BeforeClass;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.support.TransactionCallback;
import org.springframework.transaction.support.TransactionTemplate;

import gov.va.vss.AbstractWebAppTest;

public class AbstractBatchProcessTest extends AbstractWebAppTest {

	@BeforeClass
	public void cleanTestData() {
		new TransactionTemplate(tm).execute(new TransactionCallback<Object>() {
			public Object doInTransaction(TransactionStatus ts) {
				Date now = new Date();
				/*
				 * End any running batch processes, if necessary - CPB
				 */
				em.createNativeQuery("update CORE.BATCH_STEP_EXECUTION set END_TIME = :now where END_TIME is null")
						.setParameter("now", now).executeUpdate();
				em.createNativeQuery("update CORE.BATCH_JOB_EXECUTION set END_TIME = :now,"
						+ " status = 'COMPLETED', EXIT_CODE = 'COMPLETED'"
						+ " where END_TIME is null or status <> 'COMPLETED'").setParameter("now", now).executeUpdate();
				return null;
			}
		});
	}

}
