package gov.va.shared.model.core;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;

import javax.persistence.Transient;

import com.fasterxml.jackson.annotation.JsonAutoDetect;

/**
 * This class is a convenience superclass for all persistent objects that are
 * derived from other objects (i.e. objects mapped to views in the database). We
 * let the child classes define what type of ID column they have.
 * 
 * @author             
 */
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = NONE, isGetterVisibility = NONE)
public abstract class AbstractDerivedPersistent<T> extends AbstractBusinessKeyOwner<T> implements Persistent {
	private static final long serialVersionUID = -2441482181122221551L;

	@Transient
	@Override
	public boolean isPersistent() {
		return true;
	}
}
