package gov.va.vss.model.batchExample;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Currency;

import org.springframework.batch.item.ItemProcessor;

public class TickerPriceProcessor implements ItemProcessor<TickerData, TickerData> {

	@Override
	public TickerData process(TickerData ticker) throws Exception {

		Currency usd = Currency.getInstance("USD");
		Currency gbp = Currency.getInstance("GBP");
		BigDecimal openGBP = convertCurrency(ticker.getOpen(), usd, gbp);
		BigDecimal lastTradeGBP = convertCurrency(ticker.getLastTrade(), usd, gbp);

		ticker.setOpenGBP(openGBP);
		ticker.setLastTradeGBP(lastTradeGBP);
		System.out.println(openGBP);
		return ticker;
	}

	private static final BigDecimal GBP_RATE = new BigDecimal("0.638365784");

	public BigDecimal convertCurrency(BigDecimal amt, Currency from, Currency to) {
		return amt.multiply(GBP_RATE).setScale(2, RoundingMode.HALF_EVEN);
	}

}