package gov.va.vss.model.lookup;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;

import javax.persistence.Entity;
import javax.persistence.Table;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;
import org.hibernate.annotations.Immutable;

import com.fasterxml.jackson.annotation.JsonAutoDetect;

import gov.va.shared.model.lookup.AbstractLookup;
import gov.va.shared.model.lookup.LookupType;
import gov.va.vss.model.lookup.JobExecutionType.JobExecutionTypeValue;

@Entity
@Immutable
@Table(name = "STD_JOB_EXECUTION_TYPE", schema = "CORE")
@Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = NONE, isGetterVisibility = NONE)
public class JobExecutionType extends AbstractLookup<JobExecutionType, JobExecutionTypeValue> {
	private static final long serialVersionUID = 5598414554054024076L;

	public static enum JobExecutionTypeValue implements LookupType {
		// FIXVSS add when we have jobs
		LEIE(1);

		private long id;

		private JobExecutionTypeValue(long id) {
			this.id = id;
		}

		public long getId() {
			return id;
		}

	}

}
