package gov.va.vss.model.lookup;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;
import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.PUBLIC_ONLY;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;

import com.fasterxml.jackson.annotation.JsonAutoDetect;

import gov.va.shared.model.core.AbstractAuditedVersionedPersistent;

@Entity
@Table(name = "VtkVolunteerScheduleWorkdays", schema = "dbo")
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = PUBLIC_ONLY, isGetterVisibility = PUBLIC_ONLY)
public class WorkdaySchedule extends AbstractAuditedVersionedPersistent<WorkdaySchedule> {
	private static final long serialVersionUID = 6904844123870655771L;

	// -------------------------------------- Fields

	@NotBlank
	@Length(max = 1)
	private String code;
	@NotBlank
	@Length(max = 40)
	private String days;
	@NotBlank
	@Length(max = 8)
	private String appearsAs;

	// -------------------------------------- Business Methods

	// -------------------------------------- Common Methods

	@Override
	protected boolean requiredEquals(WorkdaySchedule oo) {
		return new EqualsBuilder().append(code, oo.getCode()).isEquals();
	}

	@Override
	protected int requiredHashCode() {
		return new HashCodeBuilder().append(code).toHashCode();
	}

	public String toString() {
		return getDays() + " (code " + getCode() + ")";
	}

	// -------------------------------------- Accessor Methods

	@Column(length = 1, nullable = false)
	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	@Column(length = 40, nullable = false)
	public String getDays() {
		return days;
	}

	public void setDays(String days) {
		this.days = days;
	}

	@Column(length = 8, nullable = false)
	public String getAppearsAs() {
		return appearsAs;
	}

	public void setAppearsAs(String appearsAs) {
		this.appearsAs = appearsAs;
	}

}
