package gov.va.vss.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.context.annotation.Profile;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.shared.persistence.lookup.sds.VAFacilityDAO;

@Service
@Profile(value = { "attended", "unattended" })
public class L2CacheSeeder implements ApplicationListener<ContextRefreshedEvent> {

	@Autowired
	private VAFacilityDAO vaFacilityDAO;

	@Override
	@Async
	public void onApplicationEvent(ContextRefreshedEvent event) {
		if (event.getApplicationContext().getParent() != null)
			return;

		List<VAFacility> all = vaFacilityDAO.findAll();
		for (VAFacility f : all) {
			f.getStationNumber();
			f.getCity();
		}
		vaFacilityDAO.findAllSorted();
		vaFacilityDAO.findAllThreeDigitStationsSorted();
		vaFacilityDAO.findAllActiveTreatingFacilities();
		
		System.out.println("Level 2 cache seeded.");
	}

}
