package gov.va.vss.service;

import gov.va.vss.model.Volunteer;
import gov.va.vss.service.validation.ServiceValidationException;

public interface VolunteerService {

	/**
	 * @param volunteer
	 *            The volunteer to save or update
	 * @return The updated volunteer after it's been persisted / updated
	 * @throws ServiceValidationException
	 *             If a business-level validation exception occurred during the
	 *             save/update process
	 */
	Volunteer saveOrUpdate(Volunteer volunteer) throws ServiceValidationException;

	/**
	 * Deletes the Volunteer with the specified volunteerId
	 * 
	 * @param volunteerId
	 *            The ID of the volunteer to delete
	 */
	void delete(long volunteerId);
}
