package gov.va.vss.service.scheduledJobs.cacheRefresh;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import gov.va.shared.model.Role;
import gov.va.shared.persistence.GrantableRoleDAO;
import gov.va.shared.persistence.lookup.RoleDAO;

@Component
public class GrantableRoleDAOCacheRefresher {

	@Autowired
	private RoleDAO roleDAO;
	@Autowired
	private GrantableRoleDAO grantableRoleDAO;

	@Scheduled(initialDelayString = "${cache.autoRefresh.startupDelayMillis}", //
	fixedDelayString = "${cache.autoRefresh.fixedDelayMillis}")
	public void refresh() {
		List<Role> allRoles = roleDAO.findAll(true);
		for (Role r : allRoles) {
			grantableRoleDAO.findGrantableRolesForRole(r.getId());
		}
	}

}
