package gov.va.vss.web.volunteer;

import gov.va.shared.model.lookup.sds.Gender;
import gov.va.shared.model.lookup.sds.State;
import gov.va.vss.model.NextOfKin;
import gov.va.vss.model.Volunteer;
import gov.va.vss.model.VolunteerStationProfile;

public class VolunteerCommand {

	// -------------------------------- Fields

	private Volunteer volunteer;

	/*
	 * SDS types that are populated on form submission, but that require
	 * conversion to legacy lookup types before storing in Volunteer object.
	 */
	private Gender gender;
	private State state;

	/* Station-specific fields */
	private VolunteerStationProfile stationProfile;

	private NextOfKin nextOfKin;

	// -------------------------------- Constructors

	public VolunteerCommand() {
	}

	public VolunteerCommand(Volunteer volunteer, VolunteerStationProfile stationProfile, Gender gender, State state) {
		this.volunteer = volunteer;
		this.stationProfile = stationProfile;
		this.gender = gender;
		this.state = state;
		this.nextOfKin = stationProfile.getNextOfKin();
		if (nextOfKin == null)
			nextOfKin = new NextOfKin(volunteer);
	}

	// -------------------------------- Accessor Methods

	public Volunteer getVolunteer() {
		return volunteer;
	}

	public void setVolunteer(Volunteer volunteer) {
		this.volunteer = volunteer;
	}

	public VolunteerStationProfile getStationProfile() {
		return stationProfile;
	}

	public void setStationProfile(VolunteerStationProfile stationProfile) {
		this.stationProfile = stationProfile;
	}

	public Gender getGender() {
		return gender;
	}

	public void setGender(Gender gender) {
		this.gender = gender;
	}

	public State getState() {
		return state;
	}

	public void setState(State state) {
		this.state = state;
	}

	public NextOfKin getNextOfKin() {
		return nextOfKin;
	}

	public void setNextOfKin(NextOfKin nextOfKin) {
		this.nextOfKin = nextOfKin;
	}

}
