<%@ include file="../../shared/inc_header.jsp"%>

<tiles:importAttribute name="widgetId" scope="page" />

<script type="text/javascript">
	(function() {
		var widgetId = "<c:out value="${widgetId}" />"

		var setSelectListItems = function(responseList) {
			$.each(responseList, function(index, item) {
				$('#' + widgetId).append($('<option>', {
					value : item.id,
					text : item.displayName
				}))
			})

			enableMultiSelect()
		}

		function enableMultiSelect() {
			$('#' + widgetId).multiselect({
				selectedText : function(numChecked, numTotal, checkedItems) {
					var selectedTextValue = '${selectedParamLabel}:'

					$.each(checkedItems, function() {
						selectedTextValue = selectedTextValue + '<br/>' + $(this).attr('title')
					})

					resetSelectedOptionsDiv()
					setItemsToSelectedOptionsDiv(selectedTextValue)

					return numChecked + ' of ' + numTotal + ' checked'
				},
				uncheckAll : function() {
					resetSelectedOptionsDiv()
				},
				click : function(event, ui) {
					if ($(this).multiselect("widget").find("input:checked").length == 0) {
						resetSelectedOptionsDiv()
					}
				}
			}).multiselectfilter()
		}
		
		function resetSelectedOptionsDiv() {
			$('#' + widgetId + '_selectedItems').html('')
			$('#' + widgetId + '_selectedItems').css('height', '0px');
		}

		function setItemsToSelectedOptionsDiv(selectedTextValue) {
			$('#' + widgetId + '_selectedItems').html(selectedTextValue)
			$('#' + widgetId + '_selectedItems').css('overflow-y', 'auto')
			$('#' + widgetId + '_selectedItems').css('margin-top', '20px')
			$('#' + widgetId + '_selectedItems').css('height', '100px')
		}

		registerWidget({
			initialize : function(initCompleteCallback) {
				$.ajax({
					url : ajaxHomePath + "/assignedStations",
					type : "GET",
					dataType : 'json',
					error : commonAjaxErrorHandler,
					success : function(responseList) {
						setSelectListItems(responseList)
						initCompleteCallback()
					}
				})
			},
			getParameters : function() {
				var theVal = $("#" + widgetId).val()
				return [ {
					displayName : "<c:out value="${widgetLabel}" />",
					paramName : "<c:out value="${widgetParamName}" />",
					paramValue : theVal || ''
				} ]
			},
			setParameters : function(paramObj) {
				var newVal = paramObj["<c:out value="${widgetParamName}" />"]
				if (!newVal || newVal == '') {
					$('#deselect-all-' + widgetId).click()
				} else {
					// ... TODO split newVal by comma and loop to select items
				}
			},
			changeEventSelectors : [ "#" + widgetId ]
		})
	})()
</script>

<c:out value="${widgetLabel}" />
<p />
<select multiple="multiple" id="${widgetId}"></select>