function jumpToVolunteer(id) {
	document.location.href = homePath + '/volunteerEdit.htm?id=' + id
}

function popupVolunteerSearch(uid) {
	$("#volunteerSearchNoResults" + uid).hide()
	$("#volunteerSearchResultsTable" + uid).hide()
	$('#volunteerSearchName' + uid).focus()
	volunteerAdvancedSearch(uid, false)
	$("#volunteerSearchDialog" + uid).dialog('open')
}

function initVolunteerSearchPopup(uid) {
	var parms = {
		buttons : [ {
			extend : 'collection',
			text : 'Export',
			buttons : [ 'copy', 'csv', 'excel', 'pdf', 'print' ]
		} ],
		"dom" : '<"top"fBi>rt<"bottom"pl><"clear">',
		"pagingType" : "full_numbers",
		"pageLength" : 10,
		"lengthMenu" : [ [ 10, -1 ], [ 10, "All" ] ],
		"stateSave" : false,
		"stripeClasses" : [ 'odd' ],
	}

	var theDataTable = $('#volunteerSearchResultsList' + uid).DataTable(parms)

	$("#volunteerSearchName" + uid).keypress(function(event) {
		if (event.which == 13) {
			submitVolunteerSearchForm(uid)
		}
	})

	$(".volunteerSearchLink" + uid).click(function(evt) {
		submitVolunteerSearchForm(uid)
	})

	$("#volunteerSearchDialog" + uid).dialog({
		autoOpen : false,
		modal : true,
		width : 950,
		height : 600,
		closeOnEscape : false,
		draggable : true,
		resizable : true,
		// zIndex: 200000,
		buttons : {
			'Cancel' : function() {
				$(this).dialog('close')
			}
		}
	})

	$("#volunteerSearchDialog" + uid).show()
	/*
	 * Required to solve 508 issue not reading dialog box title. It is also
	 * required to disable dialog animation to enable this functionality
	 */
	$('#volunteerSearchName' + uid).focus()
}

var volunteerSearchResults = new Object()

function submitVolunteerSearchForm(uid) {
	var theScope = $(
			"input[type='radio'][name='volunteerSearchScope" + uid
					+ "']:checked").val()

	$
			.ajax({
				url : ajaxHomePath + "/findVolunteers",
				type : "POST",
				dataType : 'json',
				data : {
					name : $("#volunteerSearchName" + uid).val(),
					code : $("#volunteerSearchCode" + uid).val(),
					address : $("#volunteerSearchAddress" + uid).val(),
					location : $("#volunteerSearchLocation" + uid).val(),
					phone : $("#volunteerSearchPhone" + uid).val(),
					email : $("#volunteerSearchEmail" + uid).val(),
					scope : theScope
				},
				error : commonAjaxErrorHandler,
				success : function(results) {
					$("#volunteerSearchNoResults" + uid).hide()
					$("#volunteerSearchResultsTable" + uid).hide()

					var resultMap = new Object()

					var table = $('#volunteerSearchResultsList' + uid)
							.DataTable()
					table.clear()

					for (var i = 0; i < results.length; i++) {
						resultMap['' + results[i].id] = results[i]

						var volunteerName = results[i].displayName;
						var volunteerNameEscaped = escapeHTML(volunteerName)
						var newRow = new Array()

						var contactInfoHtml = ''
						var hasMultipleStationProfiles = results[i].stationProfiles.length > 1
						for (var j = 0; j < results[i].stationProfiles.length; j++) {
							if (j > 0)
								contactInfoHtml += "<br>"
							contactInfoHtml += getVolunteerDashedBoxEl(
									results[i].stationProfiles[j].vtkInstitution,
									results[i].stationProfiles[j].contactInfo,
									theScope == 'national', hasMultipleStationProfiles)
									.outerHtml()
						}

						newRow[newRow.length] = '<a class="appLink" href="javascript:volunteerSearchPopupItemSelected(\''
								+ uid
								+ '\', '
								+ results[i].id
								+ ')">'
								+ volunteerNameEscaped + '</a>'
						newRow[newRow.length] = escapeHTML(results[i].dateOfBirth)
						newRow[newRow.length] = escapeHTML(results[i].sexMF)
						newRow[newRow.length] = contactInfoHtml
						newRow[newRow.length] = escapeHTML(results[i].identifyingCode)
						table.row.add(newRow)
					}

					volunteerSearchResults[uid] = resultMap

					if (results.length > 0) {
						$("#volunteerSearchResultsTable" + uid).show()
						rebuildTableFilters('volunteerSearchResultsList' + uid)

						/* Reset all filters every time they do a search */
						table.columns('.select-filter').every(function() {
							this.search('', true, false)
						})
					} else {
						$("#volunteerSearchNoResults" + uid).show()
					}
					table.draw()

					$('#volunteerSearchName' + uid).focus()
				}
			})
}

function volunteerAdvancedSearch(uid, isShow) {
	$('.advSearchFields' + uid).toggle(isShow)
	$('.simpleSearchFields' + uid).toggle(!isShow)
	$("#volunteerSearchScope" + uid + "Local").prop("checked", true)
}

function menuVolunteerSelectedCallback(volunteerObj) {
	jumpToVolunteer(volunteerObj.id)
}

function getVolunteerDashedBoxEl(volContactInstitution, volContactInfo,
		showStation, addBorder) {
	var theHtml = '<table width="100%">'
	theHtml += '<tr valign="top"><td nowrap width="99%">'

	var phoneHtml = "";
	if (volContactInfo.phone)
		phoneHtml = escapeHTML(volContactInfo.phone) + '<br>'
	var emailHtml = ""
	if (volContactInfo.email)
		emailHtml = escapeHTML(volContactInfo.email) + '<a href="mailto:'
				+ escapeHTML(volContactInfo.email)
				+ '"><img alt="Click to email '
				+ escapeHTML(volContactInfo.email) + '"' + 'src="' + imgHome
				+ '/envelope.jpg" height="14"'
				+ ' width="18" border="0" align="absmiddle"'
				+ ' style="padding-left: 4px; padding-right: 4px" /></a>'
	var addressHtml = ""
	if (volContactInfo.addressMultilineDisplay)
		addressHtml = escapeHTML(volContactInfo.addressMultilineDisplay)

	if (showStation) {
		if (volContactInstitution && volContactInstitution.vaFacility) {
			theHtml += '<b>'
					+ abbreviate(volContactInstitution.vaFacility.displayName,
							35) + '</b><br>'
		} else if (volContactInstitution) {
			theHtml += '<b>'
					+ abbreviate(volContactInstitution.displayName, 35)
					+ '</b><br>'
		}
	}

	theHtml += phoneHtml + emailHtml + '</td>' + '<td width="10">&nbsp;</td>'
			+ '<td width="1%" nowrap>' + convertLinefeedToBR(addressHtml)
			+ '</td></tr></table>'
	return getBoxEl(theHtml, addBorder)
}