package gov.va.vss.persistence;

import java.time.ZonedDateTime;
import java.util.List;

import org.junit.Assert;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.NationalOfficial;
import gov.va.vss.model.Organization;
import gov.va.vss.model.lookup.StdVAVSTitle.StdVAVSTitleValue;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.dao.NationalOfficialDAO;

public class TestNationalOfficialDAO extends AbstractTransactionalWebDAOTest<NationalOfficial> {

	@Autowired
	private NationalOfficialDAO nationalOfficialDAO;

	@Override
	protected CustomizableAppDAO<NationalOfficial> getDAO() {
		return nationalOfficialDAO;
	}

	@Override
	protected NationalOfficial getInstanceToSave() {
		
		Organization org = 	organizationDAO.findByPrimaryKey(new Long(6));

		NationalOfficial o = new NationalOfficial(org);
		o.setLastName("Chen");
		o.setStreetAddress("5400 Legay Dr");
		o.setCity("Plano");
		o.setState(vtkStateDAO.findByFIPSCode("48"));
		o.setZip("75024");
		o.setStdVAVSTitle(stdVAVSTitleDAO.findByLookup(StdVAVSTitleValue.DEPUTY_NATIONAL_REPRESENTATIVE));
		o.setNationalCommitteeMember(false);
		return o;
	}

	@Test
	public void testFindByCriteria() {
		List<NationalOfficial> officials = nationalOfficialDAO.findByCriteria(new Long(251), ZonedDateTime.now());
		Assert.assertFalse("Failed - 251 didn't return any results", officials.isEmpty());
	}
	
	/*@Test
	public void testfindByVAVSTitle() {
		NationalOfficial official = nationalOfficialDAO.findByVAVSTitle(new Long(2), StdVAVSTitleValue.NATIONAL_REPRESENTATIVE.getName());
		Assert.assertFalse("Failed - 2, National Representative didn't return any results", official == null);
	}*/

	@Override
	protected boolean testDelete() {
		return true;
	}

}
