package gov.va.vss.persistence;

import java.time.LocalDate;

import org.springframework.beans.factory.annotation.Autowired;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.Volunteer;
import gov.va.vss.model.VolunteerContactInfo;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.dao.VolunteerDAO;

public class TestVolunteerDAO extends AbstractTransactionalWebDAOTest<Volunteer> {

	@Autowired
	private VolunteerDAO volunteerDAO;

	@Override
	protected CustomizableAppDAO<Volunteer> getDAO() {
		return volunteerDAO;
	}

	@Override
	protected Volunteer getInstanceToSave() {
		Volunteer v = new Volunteer();
		v.setFirstName("Connor");
		v.setLastName("     ");
		v.setDateOfBirth(LocalDate.of(1950, 1, 1));
		v.setSexMF("M");
		VolunteerContactInfo vci = new VolunteerContactInfo();
		vci.setAddressLine1("658 Wild Ridge Cir");
		// v.setContactInfo(vci);
		return v;
	}

	@Override
	protected boolean testDelete() {
		return true;
	}

}
