package gov.va.shared.model.lookup;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;
import org.hibernate.annotations.Immutable;

import gov.va.shared.model.lookup.ActiveStatus.ActiveStatusType;

@Entity
@Immutable
@Table(name = "STD_ACTIVE_STATUS", schema = "CORE")
@Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
public class ActiveStatus extends AbstractLookup<ActiveStatus, ActiveStatusType> {
	private static final long serialVersionUID = 5354146485460768366L;

	@Transient
	public long getIEN() {
		return getId().equals(1) ? 1L : 0L;
	}

	@Transient
	public boolean isActive() {
		return getId() != null && getId() == ActiveStatusType.ACTIVE.getId();
	}

	public static enum ActiveStatusType implements LookupType {
		ACTIVE(1, "Active"), //
		INACTIVE(2, "Inactive");

		private long id;
		private String name;

		private ActiveStatusType(long id, String name) {
			this.id = id;
			this.name = name;
		}

		public String getName() {
			return name;
		}

		public long getId() {
			return id;
		}

		public static ActiveStatusType getById(long id) {
			for (ActiveStatusType type : values())
				if (type.getId() == id)
					return type;
			return null;
		}

	}

}
