package gov.va.shared.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import gov.va.shared.model.core.IdentifiedPersistent;
import gov.va.shared.persistence.usertype.CodedEnum;

public class PersistenceUtil {

	public static <T extends IdentifiedPersistent> Set<Long> translateObjectsToIds(Set<T> o) {
		Set<Long> ids = new HashSet<>(o.size());
		for (T item : o)
			ids.add(item.getId());
		return ids;
	}

	public static <T extends IdentifiedPersistent> List<Long> translateObjectsToIds(Collection<T> o) {
		List<Long> ids = new ArrayList<>(o.size());
		for (T item : o)
			ids.add(item.getId());
		return ids;
	}

	public static <T extends CodedEnum> Set<String> translateCodedEnumToCodes(Set<T> o) {
		Set<String> codes = new HashSet<>(o.size());
		for (T item : o)
			codes.add(item.getCode());
		return codes;
	}

	public static <T extends CodedEnum> List<String> translateCodedEnumToCodes(Collection<T> o) {
		List<String> ids = new ArrayList<>(o.size());
		for (T item : o)
			ids.add(item.getCode());
		return ids;
	}

}
