package gov.va.shared.util;

import javax.servlet.http.HttpSession;

import gov.va.shared.model.lookup.sds.VAFacility;

public class SessionUtil {

	private static String KEY_PREFIX = SessionUtil.class.getName();
	public static final String CONTEXT_SITE_KEY = KEY_PREFIX + ".SITE";

	// ---------------------------------------- Static helper methods

	public static HttpSession getHttpSession() {
		return ServletUtil.getThreadBoundServletRequest().getSession(true);
	}

	public static VAFacility getSiteContext() {
		return getSiteContext(getHttpSession());
	}

	/*
	 * These allow the data to be directly accessed if we know the HttpSession.
	 * We may need to remove the few methods that retrieve clinical data and
	 * force callers to use the instance methods below, since extra logic might
	 * go into determining whether the CCOW patient has changed. CPB
	 */

	public static VAFacility getSiteContext(HttpSession session) {
		return (VAFacility) session.getAttribute(CONTEXT_SITE_KEY);
	}

	public static void setSiteContext(VAFacility f) {
		setSiteContext(f, getHttpSession());
	}

	public static void setSiteContext(VAFacility f, HttpSession session) {
		session.setAttribute(CONTEXT_SITE_KEY, f);
		SecurityUtil.resetUserAuthoritiesForFacility(f != null ? f.getId() : -1);
	}

}
