package gov.va.vss.model.lookup;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;

import javax.persistence.Entity;
import javax.persistence.Table;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;
import org.hibernate.annotations.Immutable;

import com.fasterxml.jackson.annotation.JsonAutoDetect;

import gov.va.shared.model.lookup.AbstractLookup;
import gov.va.shared.model.lookup.LookupType;
import gov.va.vss.model.lookup.VtkOrganizationType.VtkOrganizationTypeValue;

@Entity
@Immutable
@Table(name = "VtkVolunteerOrganizationTypes", schema = "dbo")
@Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = NONE, isGetterVisibility = NONE)
public class VtkOrganizationType extends AbstractLookup<VtkOrganizationType, VtkOrganizationTypeValue> {
	private static final long serialVersionUID = -6332598924348883474L;

	public static enum VtkOrganizationTypeValue implements LookupType {
		// FIXVSS add when we have organization types, do we need to fill all?
		ACADEMIC(1);

		private long id;

		private VtkOrganizationTypeValue(long id) {
			this.id = id;
		}

		public long getId() {
			return id;
		}

	}

}
