package gov.va.vss.persistence.dao;

import java.time.ZonedDateTime;
import java.util.Collection;
import java.util.List;

import gov.va.vss.model.VistaStationData;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;

public interface VistaStationDataDAO extends CustomizableAppDAO<VistaStationData> {

	VistaStationData findByStationNumber(String stationNumber);

	List<VistaStationData> findByCriteria(Boolean cprsHeaderSyncProcessEnabled,
			ZonedDateTime cprsHeaderSyncLastExecutionDateBefore, Boolean patientInactivationProcessEnabled,
			QueryCustomization... customization);

	int updateWithFields(String stationNumber, Boolean cprsHeaderSyncProcessEnabled,
			ZonedDateTime cprsHeaderSyncLastExecutionDate, Boolean patientInactivationProcessEnabled,
			ZonedDateTime patientInactivationLastExecutionDate, Boolean staffUpdateProcessEnabled,
			ZonedDateTime staffUpdateLastExecutionDate, Boolean vistaCleanupProcessEnabled,
			ZonedDateTime vistaCleanupLastExecutionDate, Boolean vistaSyncProcessEnabled);

	void clearCache();

	int updateCPRSHeaderSyncLastExecutionDatesForEnabledStations(Collection<String> stationNumbers,
			ZonedDateTime executionDate);

}
