package gov.va.vss.persistence.dao.lookup;

import java.util.Collection;
import java.util.Map;
import java.util.SortedSet;

import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.vss.model.lookup.VtkInstitution;
import gov.va.vss.persistence.dao.CustomizableSortedDAO;

public interface VtkInstitutionDAO extends CustomizableSortedDAO<VtkInstitution> {

	VtkInstitution findBySDSFacility(long vaFacilityId);
	
	Map<Long, VtkInstitution> findBySDSFacilities(Collection<Long> vaFacilityId);

	VtkInstitution findByStationNumber(String stationNumber);

	SortedSet<VAFacility> findVAFacilitiesWithLinkToVtkInstitution();

	SortedSet<VtkInstitution> findWithLinkToVAFacility();

}
