package gov.va.vss.persistence.impl.lookup;

import java.util.List;

import org.springframework.stereotype.Repository;

import gov.va.vss.model.lookup.VtkDonorType;
import gov.va.vss.model.lookup.VtkDonorType.VtkDonorTypeValue;
import gov.va.vss.persistence.dao.lookup.VtkDonorTypeDAO;
import gov.va.vss.persistence.impl.GenericHibernateDAOImpl;

@Repository
public class VtkDonorTypeDAOImpl extends GenericHibernateDAOImpl<VtkDonorType> implements VtkDonorTypeDAO {

	@Override
	public VtkDonorType findByLookup(VtkDonorTypeValue lookup) {
		@SuppressWarnings("unchecked")
		List<VtkDonorType> results = query("from " + VtkDonorType.class.getName() + " where id = :id")
				.setParameter("id", lookup.getId()).getResultList();
		return results.isEmpty() ? null : results.get(0);
	}

}
