package gov.va.vss.persistence.impl.lookup;

import java.util.List;

import org.springframework.stereotype.Repository;

import gov.va.vss.model.lookup.VtkInstitutionType;
import gov.va.vss.model.lookup.VtkInstitutionType.VtkInstitutionTypeValue;
import gov.va.vss.persistence.dao.lookup.VtkInstitutionTypeDAO;
import gov.va.vss.persistence.impl.GenericHibernateDAOImpl;

@Repository
public class VtkInstitutionTypeDAOImpl extends GenericHibernateDAOImpl<VtkInstitutionType>
		implements VtkInstitutionTypeDAO {

	@Override
	public VtkInstitutionType findByLookup(VtkInstitutionTypeValue lookup) {
		@SuppressWarnings("unchecked")
		List<VtkInstitutionType> results = query("from " + VtkInstitutionType.class.getName() + " where id = :id")
				.setParameter("id", lookup.getId()).getResultList();
		return results.isEmpty() ? null : results.get(0);
	}

}
