package gov.va.vss.web.donation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;

import gov.va.vss.model.DonationSummary;
import gov.va.vss.web.AbstractAppValidator;

@Component
public class DonationValidator extends AbstractAppValidator<DonationCommand> {

	@Override
	public void doExtraValidations(DonationCommand command, Errors errors) {
		DonationSummary donationSummary = command.getDonationSummary();

		// for example: CPB

		if (donationSummary.getDonationDate() != null && (command.getCurrentFiscalYearStartDate()
				.isAfter(command.getDonationSummary().getDonationDate())
				|| command.getCurrentFiscalYearEndDate().isBefore(command.getDonationSummary().getDonationDate()))) {
			errors.rejectValue("donationSummary.donationDate", "donationSummary.error.donationDateNotWhthinFiscalYear");

		}
	}

}
