<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<script type="text/javascript">
	var isReadOnly = <c:out value="${FORM_READ_ONLY}" default="false"/>

	$(function() {

		var theDataTable = $('#donationDetailsList')
				.DataTable(
						{
							"dom" : '<"top">rt<"bottom"><"clear">',
							"stateSave" : false,
							"columnDefs" : [ {
								className : "dt-body-right dt-foot-right",
								"targets" : [ 1 ]
							} ],
							"footerCallback" : function(row, data, start, end,
									display) {
								var api = this.api();
								// Remove the formatting to get integer data for summation
								var intVal = function(i) {
									return typeof i === 'string' ? i.replace(
											/[\$,]/g, '') * 1
											: typeof i === 'number' ? i : 0;
								};
								// Total over all pages
								total = api.column(1).data().reduce(
										function(a, b) {
											return intVal(a) + intVal(b);
										}, 0);
								// Update footer
								$(api.column(1).footer())
										.html(
												'$'
														+ formatAndAddThousandSeparators(total));
							}
						})

		$([ '#donationDate', '#checkDate', '#acknowledgementDate' ]).each(
				function(index, o) {
					$(o).enableDatePicker({
						showOn : "button",
						buttonImage : imgHome + "/calendar.gif",
						buttonImageOnly : true
					})
					$(o).mask("${TWO_DIGIT_DATE_MASK}", {
						autoclear : false
					})
				})
		$("#submitFormButton").click(submitForm)

	})

	function refreshDonationDetailsData(r) {
		var table = $('#donationDetailsList').DataTable()
		table.clear()
		table.rows.add(r)
		table.draw()
	}

	function submitForm(evt) {
		if (!validate())
		    return

		if (evt != null)
			doubleClickSafeguard($(evt.currentTarget))
		$('#donationProfileForm').submit()

	}

	function deleteDonationDetail(donationDetailId) {
		var fullObj = donationDetailsList[donationDetailId]
		confirmDialog('Are you sure you want to delete this entry for ["'
				+ fullObj.donGenPostFund.generalPostFund + '"]?', function() {
			$.ajax({
				url : ajaxHomePath + '/deleteDonationDetail',
				dataType : 'json',
				data : {
					donationDetailId : donationDetailId
				},
				error : commonAjaxErrorHandler,
				success : function() {
					/* generated by inc_jqueryTable.jsp */
					refreshDonationDetails()
				}
			})
		})
	}

	function validate() {
		var errors = new Array()

		if ($('#donationDate').val() != ''
				&& !validateDate($('#donationDate').val())) {
			errors.push("Donation Date is invalid.")
		}

		if ($('#checkDate').val() != '' && !validateDate($('#checkDate').val())) {
			errors.push("Check Date is invalid.")
		}

		if ($('#donationDate').val() == '')
			errors.push("Donation Date is required.")

		if ($('#donationTypeSelect').val() == '')
			errors.push("Donation Type is required.")

		if ($('#checkNumber').val() == '')
			errors.push("Check Number is required.")

		if (!validateNumeric($('#checkNumber').val()))
			errors.push("Check Number is invalid.")

		if (errors.length > 0)
			displayAttentionDialog("Please correct the following errors: <ul><li>"
					+ errors.join("</li><li>") + "</li></ul>");

		return errors.length == 0
	}
</script>

<style>
div.donationInputFields {
	min-width: 750px;
	max-width: 750px;
}
</style>


<form:form method="post" action="${home}/donationSummarySubmit.htm"
	id="donationProfileForm">
	<div class="clearCenter donationInputFields">
		<fieldset>
			<legend>Donor</legend>
			<div class="leftHalf">
				<table>
					<tr>
						<td class='appFieldLabel' nowrap>Type:</td>
						<td><c:out
								value="${command.donor.vtkDonorType.donorType} - ${command.donorCategory}" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap><span
							style="padding-left: 30px">Name:</span></td>
						<td><c:out value="${command.displayName}" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Email:</td>
						<td><c:out value="${command.donor.email}" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Phone:</td>
						<td><c:out value="${command.donor.phone}" /></td>
					</tr>
				</table>
			</div>
			<div class="rightHalf">
				<table>
					<tr>
						<td class='appFieldLabel'>Address:</td>
						<td><span><pre><c:out value="${command.donor.addressMultilineDisplay}"/></pre></span></td>
					</tr>
				</table>
			</div>


			<div class="clearCenter">
				<td rowspan="2" width="110px">&nbsp;</td> <a id="changeDonor"
					class="buttonAnchor">Change Donor</a>
			</div>
		</fieldset>
	</div>

	<div class="clearCenter donationInputFields">
		<fieldset>
			<legend>Donation</legend>

			<table width="100%">
				<tr>
					<td class='appFieldLabel' nowrap><lable
							for='donationDateInput'>Donation Date:<span
							class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td><app:input path="donationSummary.donationDate"
							id="donationDate" size="15" /> <app:errors
							path="donationSummary.donationDate" cssClass="msg-error" /></td>

					<td class='appFieldLabel' nowrap><lable
							for='donationDateInput'>Donation Type:<span
							class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td nowrap><app:select id="donationTypeSelect"
							path="donationSummary.vtkDonationType" itemLabel="donationType"
							itemValue="id">
							<form:option value="-1" label="-- Select --" />
							<form:options items="${allDonationTypes}"
								itemLabel="donationType" itemValue="id" />
						</app:select> <app:errors path="donationSummary.vtkDonationType"
							cssClass="msg-error" /></td>
				</tr>

				<tr>
					<td class='appFieldLabel' nowrap><lable for='checkNumInput'>Check
						Number:<span class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td><app:input path="donationSummary.checkNumber"
							id="checkNumber" size="15" maxlength="15" /> <app:errors
							path="donationSummary.checkNumber" cssClass="msg-error" /></td>

					<td class='appFieldLabel' nowrap>Check Date:</td>
					<td></td>
					<td><app:input path="donationSummary.checkDate" id="checkDate"
							size="15" /> <app:errors path="donationSummary.checkDate"
							cssClass="msg-error" /></td>
				</tr>
			</table>

			<div align="center" style="margin-top: 25px">
				<c:if
					test="${not FORM_READ_ONLY and command.donationSummary.persistent}">
					<a class="buttonAnchor" id="createDonationButton"
						href="javascript:showDonationDetailsPopup()">Assign GPF</a>
				</c:if>
			</div>
			<div id="JQueryTable"
				style="max-width: 70%; margin: auto; margin-top: 10px; clear: both">

				<table class="formatTable" id="donationDetailsList" border="1"
					summary="List of Donations">
					<thead>
						<tr>
							<th>General Post Fund</th>
							<th>Amount</th>
							<c:if test="${not FORM_READ_ONLY}">
								<th>Action</th>
							</c:if>
						</tr>
					</thead>
					<tfoot>
						<tr>
							<td align="right">Total:</td>
							<td align="right"></td>
						</tr>
					</tfoot>
					<tbody>
					</tbody>

				</table>
			</div>

			<div style="margin-top: 20px">
				<table width="100%">
					<tr>
						<td class='appFieldLabel'>Field Service Receipt:</td>
						<td><app:input path="donationSummary.fieldServiceReceipt"
								id="fieldServiceReceiptId" size="20" maxlength="30" /> <app:errors
								path="donationSummary.fieldServiceReceipt" cssClass="msg-error" /></td>

						<td class='appFieldLabel' nowrap>Reference:</td>
						<td><app:select items="${allDonationReferences}"
								id="donationTypeSelect" path="donationSummary.donReference"
								itemLabel="donationReference" itemValue="id" /> <app:errors
								path="donationSummary.donReference" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Acknowledgement Date:</td>
						<td><app:input path="donationSummary.acknowledgementDate"
								id="acknowledgementDate" size="20" /> <app:errors
								path="donationSummary.acknowledgementDate" cssClass="msg-error" /></td>
						<td class='appFieldLabel' nowrap>Designation:</td>
						<td><app:input path="donationSummary.designation"
								id="designationId" size="20" maxlength="50" /> <app:errors
								path="donationSummary.designation" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Letter Salutation:</td>
						<td><app:input path="donationSummary.salutation"
								id="acknowledgementDate" size="20" maxlength="50" /> <app:errors
								path="donationSummary.salutation" cssClass="msg-error" /></td>
					</tr>
				</table>
			</div>

			<div class="clearCenter" style="margin-top: 10px">
				<table>
					<tr>
						<td nowrap>Donation Description (used in acknowledgement)</td>
					</tr>
					<tr>
						<td><app:textarea path="donationSummary.donationDescription"
								id="donationDescription" rows="3" cols="80" /></td>
					</tr>
					<tr>
						<td nowrap>Additional Information</td>
					</tr>
					<tr>
						<td><app:textarea path="donationSummary.additionalComments"
								id="comments" rows="3" cols="80" /></td>
					</tr>
				</table>
			</div>
		</fieldset>
	</div>

	<div class="clearCenter donationInputFields" style="margin-top: 10px">
		<fieldset>
			<legend>In Memory Of</legend>
			<table>
				<tr>
					<td class='appFieldLabel'>In Memory Of:</td>
					<td><app:input path="donationSummary.inMemoryOf"
							id="salutationId" size="40" maxlength="50" /> <app:errors
							path="donationSummary.inMemoryOf" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td style="font-weight: bold">Family Contact</td>
					<td></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>Name:</td>
					<td><app:input path="donationSummary.familyContact"
							id="familyContactId" size="40" maxlength="50" /> <app:errors
							path="donationSummary.familyContact" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>Street:</td>
					<td><app:input path="donationSummary.familyContactAddress"
							id="familyContactAddressId" size="40" maxlength="35" /> <app:errors
							path="donationSummary.familyContactAddress" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>City:</td>
					<td><app:input path="donationSummary.familyContactCity"
							id="familyContactCityId" size="20" maxlength="30" /> <app:errors
							path="donationSummary.familyContactCity" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>State:</td>
					<td nowrap><app:select id="stateSelect" path="state"
							itemLabel="postalName" itemValue="id">
							<form:option value="-1" label="-- Select --" />
							<form:options items="${allStates}" itemLabel="postalName"
								itemValue="id" />
						</app:select> <app:errors path="state" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>Zip:</td>
					<td><app:input path="donationSummary.familyContactZip"
							id="familyContactZipId" size="10" maxlength="10" /> <app:errors
							path="donationSummary.familyContactZip" cssClass="msg-error" /></td>
				</tr>
			</table>
		</fieldset>

	</div>

	<div class="clearCenter donationInputFields" style="margin-top: 10px">
		<fieldset>
			<legend>CC Fields</legend>
			<table aligh="center">
				<tr>

					<td><app:input path="donationSummary.cc1"
							id="fieldServiceReceiptId" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc1" cssClass="msg-error" /></td>
					<td><app:input path="donationSummary.cc2"
							id="fieldServiceReceiptId" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc2" cssClass="msg-error" /></td>

					<td><app:input path="donationSummary.cc3"
							id="fieldServiceReceiptId" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc3" cssClass="msg-error" /></td>

					<td><app:input path="donationSummary.cc4"
							id="fieldServiceReceiptId" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc4" cssClass="msg-error" /></td>

					<td><app:input path="donationSummary.cc5"
							id="fieldServiceReceiptId" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc5" cssClass="msg-error" /></td>
				</tr>
			</table>
		</fieldset>
	</div>
	<div class="clearCenter">
		<c:if test="${not FORM_READ_ONLY}">
			<a class="buttonAnchor" id="postPrintButton" tabIndex="0"
				disabled="true">Post & Print</a>
			<td rowspan="2" width="110px">&nbsp;</td>
			<a class="buttonAnchor" id="submitFormButton" href="#">Post</a>
			<td rowspan="2" width="110px">&nbsp;</td>
		</c:if>
		<a id="cancelOperationBtn" class="buttonAnchor"
			href="${most_recent_breadcrumb}">Cancel</a>
	</div>
</form:form>


<%@ include file="/WEB-INF/jsp/donation/donationDetail.jsp"%>


