<%@ include file="../shared/inc_header.jsp"%>

<portlet:renderURL  var="siteMapUrl" />

<script type="text/javascript">
	function submitForm() {
		if ($('#includeStationSpecificCheckbox').is(':checked') &&
				($('#stationCode').val() == "" || $('#stationCode').val() == null)) {
			displayAttentionDialog('Please select a facility or unselect the "specific facility" option before proceeding.')
			return false;
		}
		
		if (($.trim($('#startDateInput').val()).length != 0) && (!militaryZonedDateTimeRegex.test($('#startDateInput').val())) ) {
			displayAttentionDialog("Please specify a valid Start Date in <c:out value="${TWO_DIGIT_MILITARY_DATE_TIME}" /> format!");
			return false;
		}
		
		if (($.trim($('#endDateInput').val()).length != 0) && (!militaryZonedDateTimeRegex.test($('#endDateInput').val())) ) {
			displayAttentionDialog("Please specify a valid End Date in <c:out value="${TWO_DIGIT_MILITARY_DATE_TIME}" /> format!");
			return false;
		}
		
		$('#jobResultsSearchForm').submit()
	}

	$(function() {
		var stationSelect = $('#stationCode')[0];
		var myfilter = new filterlist(stationSelect);

		$("#submitFormButton").click(submitForm)

		$('#selectedStation').bind('keyup', function() {
			var typedInVal = $(this).val();
			myfilter.set(typedInVal);
		})

		$('#startDateInput').enableDateTimePicker({
			showOn : "button",
			buttonImage : "/images/calendar.gif",
			buttonImageOnly : true
		})

		$('#endDateInput').enableDateTimePicker({
			showOn : "button",
			buttonImage : "/images/calendar.gif",
			buttonImageOnly : true
		});

		<c:if test="${jobResultsSearchForm.includeStationSpecificJobs}">
			$("#selectedStation").removeAttr('disabled')
			$("#stationCode").removeAttr('disabled')
		</c:if>

		$("#includeStationSpecificCheckbox").on('change', function() {
			var isChecked = $(this).is(':checked')
			if (isChecked) {
				$("#selectedStation").removeAttr('disabled')
				$("#stationCode").removeAttr('disabled')
			} else {
				$("#selectedStation").attr('disabled', 'disabled')
				$("#stationCode").attr('disabled', 'disabled')
			}
		})
	})
</script>

<div id="appBodyDiv">
	<form:form method="POST" action="/searchJobResults.htm"
		commandName="jobResultsSearchForm">
		<table align="center">
			<tr>
				<td width="50%">
					<table>
						<tr>
							<td class='appFieldLabel appPadding'><label
								for='typeSelect'>Job Type:</label></td>
							<td><app:select id="typeSelect"
										path="jobExecutionType">
										<form:option value="" label="(Any)" />
										<form:options items="${allJobExecutionTypes}" itemValue="id"
											itemLabel="name" />
									</app:select> <br> <app:errors path="jobExecutionType"
										cssClass="msg-error" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel appPadding'><label
								for='startDateInput'>Job Started After:</label></td>
							<td style="padding: 4px" nowrap><app:input
									id="startDateInput" path="startDate" cssClass="dateTimePicker" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel appPadding'><label
								for='endDateInput'>Job Started Before:</label></td>
							<td style="padding: 4px" nowrap><app:input
									id="endDateInput" path="endDate" cssClass="dateTimePicker" /></td>
						</tr>
						<tr>
							<td align="right"><form:checkbox
									id="includeStationlessCheckbox" path="includeStationlessJobs"
									valign="center" /></td>
							<td class='appPadding' nowrap><label for='includeStationlessCheckbox'>Include jobs not associated to any facility</label></td>
						</tr>
						<tr>
							<td align="right"><form:checkbox
									id="includeStationSpecificCheckbox"
									path="includeStationSpecificJobs" valign="center" /></td>
							<td class='appPadding' nowrap><label for='includeStationSpecificCheckbox'>Include jobs linked to a specific facility</label></td>
						</tr>
					</table>
				</td>
				<td width="50%">
					<table id="stationSelectionTable">
						<tr valign="top">
							<td align="right" class="appFieldLabel"><label
								for='selectedStation'>Select Facility: <span
									class='requdIndicator'>*</span>
							</label></td>
							<td><input id='selectedStation' size="50" disabled="disabled"
								title="Enter some text here to filter the Facility List"><br />
								<i>(Enter some text to filter the list below)</i> <label
								for='hiddenCancelSubmit' style='display: none;'>(Enter
									some text to filter the list below)</label><input type='text'
								id='hiddenCancelSubmit' style='display: none;'></input></td>
						</tr>
						<tr align="center">
							<td><label for='stationCode' style='display: none;'>Select
									a facility</label></td>
							<td align='left'><select name="stationCode" id="stationCode"
								size='10' disabled="disabled">
									<c:forEach items="${vamcsList}" var="institution">
										<c:choose>
											<c:when
												test="${not empty jobResultsSearchForm.stationCode.code and fn:trim(jobResultsSearchForm.stationCode.code) == fn:trim(institution.stationNumber)}">
												<option value="${institution.stationNumber}" selected="selected">
													<c:out value="${institution.displayName}" />
												</option>
											</c:when>
											<c:otherwise>
												<option value="${institution.stationNumber}">
													<c:out value="${institution.displayName}" />
												</option>
											</c:otherwise>
										</c:choose>
									</c:forEach>
							</select><br> <app:errors path="stationCode"
									cssClass="msg-error" /></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr align="center">
				<td colspan="3"><a class="buttonAnchor" id="submitFormButton"
					tabIndex="0">Submit</a> <a id="cancelFormButton" class="buttonAnchor"
					href="${siteMapUrl}" tabIndex="0">Cancel</a></td>
			</tr>
		</table>
	</form:form>
</div>
<p>

	<c:if test="${empty jobResults}">
		<div align="center">
			<i>Sorry, no jobs were found with the specified search criteria.</i>
		</div>
	</c:if>

	<c:if test="${not empty jobResults}">
		<%--
		<c:if test="${fn:length(jobResults) >= 500}">
		<div align="center">
			<i>Results are limited to the first 500 matching items.</i>
		</div><p>
		</c:if>
		 --%>
		<table summary="Format table">
			<tr>
				<td>
					<table  id="jobResultsList" class="stripe"
						summary="List of Alerts">
						<thead>
							<tr>
								<td id="institutionFilter" class="noborder"
									title="Filter Team Name by selecting one of these options"></td>
								<td id="typeFilter" class="noborder"
									title="Filter Patient Name by selecting one of these options"></td>
								<td class="noborder"></td>
								<td class="noborder"></td>
								<td id="initiatorFilter" class="noborder"
									title="Filter Recipient Names by selecting one of these options"></td>
								<td class="noborder"></td>
							</tr>
							<tr>
								<th class="select-filter">Facility</th>
								<th class="select-filter">Type</th>
								<th>Start Time</th>
								<th>End Time</th>
								<th class="select-filter">Initiator</th>
								<th>Details</th>
							</tr>
						</thead>
						<tbody>
							<c:forEach items="${jobResults}" var="jr">
								<tr id="jr${jr.id}">
									<td><c:out value="${jr.referenceInstitution.displayName}" /></td>
									<td><c:out value="${jr.type.name}" /></td>
									<td><joda:format pattern="${MILITARY_DATE_TIME}"
											dateTimeZone="${userTimeZone.ID}" value="${jr.startTime}" /></td>
									<td><joda:format pattern="${MILITARY_DATE_TIME}"
											dateTimeZone="${userTimeZone.ID}" value="${jr.endTime}" /></td>
									<td><c:out value="${jr.initiator.displayName}" /> <c:if
											test="${empty jr.initiator}">System</c:if></td>
									<td><portlet:renderURL  var="jobResultDetailsUrl">
											<portlet:param name="jobexec-item-results-show" value="y" />
											<portlet:param name="jobExecutionResultId" value="${jr.id}" />
										</portlet:renderURL> <a class="detail" title="View job result details"
										href="${jobResultDetailsUrl}"></a></td>
								</tr>
							</c:forEach>
						</tbody>
					</table>
				</td>
			</tr>
		</table>

		<jsp:include page="/WEB-INF/jsp/shared/inc_jqueryTable.jsp">
			<jsp:param name="dataTableId" value="jobResultsList" />
			<jsp:param name="defaultSort" value="[[2,'desc']]" />
		</jsp:include>
	</c:if>