<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<script type="text/javascript">
	$(function() {
		$("#submitButton").click(function(evt) {
			if (evt != null)
				doubleClickSafeguard($(evt.currentTarget));

			/* if (!validate())
				return; */

			$('#letterTemplateForm').submit();
		})

		$.ajax({
			url : ajaxHomePath + "/assignedVtkInstitutions",
			data : {
				'showAllFacilities' : false
			},
			type : "GET",
			dataType : 'json',
			error : commonAjaxErrorHandler,
			success : function(responseList) {
				$('#facilitySelect').empty()
				$.each(responseList, function(index, item) {
					$('#facilitySelect').append($('<option>', {
						value : item.id,
						text : item.displayName
					}))
				})

				var theWidget = $('#facilitySelect').multiselect({
					multiple : false,
					selectedText : function(numChecked, numTotal, checkedItems) {
						return $(checkedItems[0]).next().text()
					},
					height : 350,
					minWidth : 450
				}).multiselectfilter()
			}
		})
	})
</script>

<style>
</style>

<form:form method="post" action="${home}/letterTemplateSubmit.htm"
	id="letterTemplateForm">
	<div class="clearCenter letterTemplateInputFields">
		<fieldset>
			<table>
				<tr>
					<td class='appFieldLabel'><label for='statusRadio'>Letter
							Template Type: <span class="invisibleRequiredFor508">*</span>
					</label></td>
					<td style="padding: 4px;"><span class='requdIndicator'>*</span></td>
					<td><app:select path="type">
							<form:option value="">--Please Select--</form:option>
							<form:options items="${allLetterTypes}" itemLabel="name"
								itemValue="code" />
						</app:select><br> <app:errors path="type" cssClass="msg-error" /></td>
					<td rowspan="2"></td>
				</tr>
				<tr>
					<td class='appFieldLabel'><label for='statusRadio'>Facility:
							<span class="invisibleRequiredFor508">*</span>
					</label></td>
					<td style="padding: 4px;"><span class='requdIndicator'>*</span></td>
					<td><app:select path="facility" id="facilitySelect">
						</app:select> <br> <app:errors path="facility" cssClass="msg-error" /></td>
				</tr>
			</table>
		</fieldset>
	</div>

	<c:if test="${not empty command.letterTemplate}">
		<div class="clearCenter letterTemplateInputFields">
			<fieldset>
				<legend>Body</legend>
				<app:textarea path="letterTemplate.body" rows="25" cols="120" />
			</fieldset>
		</div>
	</c:if>

	<div class="clearCenter centerContent">
		<c:if test="${not FORM_READ_ONLY}">
			<a id="submitButton" class="buttonAnchor" href="#">Submit</a>
		</c:if>
		<a id="cancelFormButton" class="buttonAnchor keepEnabledForInactive"
			href="${most_recent_breadcrumb}">Cancel</a>
	</div>

</form:form>