<%@ include file="../shared/inc_header.jsp"%>

<tiles:importAttribute name="topLeftImage" scope="page" ignore="true" />
<tiles:importAttribute name="extraHeadEntries" scope="page"
	ignore="true" />
<%--Allow these to be set either in the model or in the tiles config - CPB --%>
<c:if test="${empty pageTitle}">
	<tiles:importAttribute name="pageTitle" scope="page" ignore="true" />
</c:if>
<c:if test="${empty pageDescription}">
	<tiles:importAttribute name="pageDescription" scope="page"
		ignore="true" />
</c:if>

<!DOCTYPE html>
<html lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="X-UA-Compatible" content="IE=Edge">
<title>VSS</title>
<c:forEach items="${extraHeadEntries}" var="entry">
	<c:out value="${entry}" escapeXml="false" />
</c:forEach>
</head>
<body>
	<%@ include file="javascript/inc_common.jsp"%>
	<span class="noticeOfNonProdEnvironment">This is a TEST
		environment. Do NOT enter real Volunteer Data.</span>
	<div id="skip">
		<a href="#content"
			onClick="document.getElementById('content').focus()">Skip to Page
			Content</a>
	</div>
	<table cellpadding="0" cellspacing="0" width="100%">
		<tr valign="middle">
			<td background="${imgHome}/top-banner-middle.gif"><c:if
					test="${not empty pageScope.topLeftImage}">
					<a href="${home}/home.htm"><img
						src="${imgHome}/${pageScope.topLeftImage}" height="95" border="0"
						align="left" alt="Department of Veterans Affairs logo"></a>
				</c:if><img src="${imgHome}/volunteers.png" align="right"
				alt="Department of Veterans Affairs Voluntary Services System people"></td>
		</tr>
		<tr>
			<td align="center" class="blueBar" height="20" nowrap><table
					cellpadding="0" cellspacing="0" width="100%">
					<tr valign="middle">
						<td width="100%" class="stationHeaderText">&nbsp;</td>
						<c:if test="${not empty siteContext}">
							<td align="right" class="stationHeaderText" nowrap><img
								src="${imgHome}/spacer.gif" alt="" height="0"><strong>Facility:</strong>&nbsp;</td>
							<td align="left" class="stationHeaderText" width="0" nowrap
								id="dutyStationId"><div
									style="display: inline-block; background-color: white; padding: 2px; border-radius: 2px">
									<c:if
										test="${multipleStationsAssigned or hasNationalAdminRole}">
										<a class="changeStationLink" href="${home}/changeStation.htm"><c:out
												value="${siteContext.displayName}" /><img
											src="${imgHome}/uparrow.png" height="14" hspace="4"
											border="0" align="absmiddle" /></a>
									</c:if>
									<c:if
										test="${not multipleStationsAssigned and not hasNationalAdminRole}">
										<span class="changeStationText"><c:out
												value="${siteContext.displayName}" /></span>
									</c:if>
								</div></td>
						</c:if>
						<c:if test="${not empty currentUser}">
							<td align="right" class="stationHeaderText" nowrap><img
								src="${imgHome}/spacer.gif" alt="" height="0" width="20"><strong>User
									Name:</strong>&nbsp;<c:out value="${currentUser.displayName}" /></td>
						</c:if>
						<sec:authorize access="isAuthenticated()">
							<td align="right" nowrap><img src="${imgHome}/spacer.gif"
								alt="" height="0" width="20"><a
								href="javascript:logoutConfirm()" class="logoutLink">Log Out</a><img
								src="${imgHome}/spacer.gif" alt="" height="0" width="10"></td>
						</sec:authorize>
					</tr>
				</table></td>
		</tr>

		<tr>
			<td><tiles:importAttribute name="menu" scope="page"
					ignore="true" /> <c:if test="${not empty pageScope.menu}">
					<div style="width: 100%">
						<tiles:insertAttribute name="menu" />
					</div>
				</c:if></td>
		</tr>

		<tr>
			<td>
				<table width="100%">
					<tiles:importAttribute name="breadcrumbs" scope="page"
						ignore="true" />
					<c:if test="${not empty pageScope.breadcrumbs}">
						<tr>
							<td colspan="3"><tiles:insertAttribute name="breadcrumbs" /></td>
						</tr>
					</c:if>

					<tr valign="top" id="titleRow">
						<td width="26"><%@ include file="inc_contextualHelp.jsp"%></td>
						<td>
							<table align="center">
								<tr>
									<td>
										<div class="appTopper">
											<h1 id="appTitle" tabIndex="0">
												<a name="content" id="content"></a>
												<!--for 508 compliance "Skip to Page Content" -->
												<nobr>
													<span id="pageTitleSpan"><c:out value="${pageTitle}" /></span>
												</nobr>
											</h1>
											<span id='pageDescription' style='display: none;'><c:out
													value="${pageDescription}" /></span>
										</div>
									</td>
								</tr>
							</table>
						</td>
						<td width="26">&nbsp;</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>


	<c:if test="${not empty oneTimeUserNotification}">
		<div align="center">
			<span class="oneTimeUserNotification"> <c:out
					value="${oneTimeUserNotification}" />
			</span>
		</div>
	</c:if>
	<c:if test="${not empty systemNotification}">
		<div align="center" class="activeAlert">
			<c:out value="${systemNotification}" />
		</div>
	</c:if>
	<%-- Should match the value of ErrorUtil.COMMAND_OBJ_NAME_ATTRIBUTE --%>
	<c:if test="${empty commandObjectName}">
		<c:set var="commandObjectName" value="command" />
	</c:if>
	<spring:hasBindErrors name="${commandObjectName}">
		<%@ include file="inc_errors.jsp"%>
	</spring:hasBindErrors>
	<div id="appContainerDiv">
		<tiles:insertAttribute name="body" />
	</div>
	<p />
	<table cellpadding="0" cellspacing="0" width="90%" align="center">
		<tr>
			<td align="center">
				<table cellpadding="4" cellspacing="0">
					<tr class="bodyText">
						<td align="left" style="border: 1px solid gray">
							${footerContent}</td>
						<td valign="middle" align="left" width="180"><img
							src="${imgHome}/VA_Excellence_4C.gif" width="180" height="72"
							alt="VA Health Care| Defining Excellence in the 21st Century" /></td>
					</tr>
					<tr>
						<td colspan="2">&nbsp;</td>
					</tr>
					<c:if test="${not empty userTimeZoneName}">
						<tr class="bodyTextSmall">
							<td colspan="2" align="center" nowrap="nowrap">All dates
								&amp; times are in <c:out value="${userTimeZoneName}" />. <sec:authorize
									access="isAuthenticated()">
								 |
								<input type="checkbox" id="soundEnabled" value="true"
										onchange="javascript:setSounds(this)"> Sounds Enabled
								</sec:authorize>
							</td>
						</tr>
					</c:if>
					<tr class="bodyTextSmall">
						<td colspan="2" align="center" nowrap="nowrap">App Version: <c:out
								value="${appVersionNumber}" /> <c:if
								test="${not empty unattendedServerRunning}">| Background Processes
										<c:if test="${unattendedServerRunning != 'true'}">not</c:if> Running</c:if>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</body>
</html>