<%@ include file="../shared/inc_header.jsp"%>

<%--
	Expects the following params:
	
	- A "uniqueDonorSearchPopupId" param which should be a string of letters that
		uniquely identifies this donorSearchPopup among other donorSearchPopups on the same page
	- A "mode" param set to either "search", "add" or "duplicateCheck"
			If "search", search fields are shown and the callback is called as normal when the person clicks a result
			If "add", an "Add Donor" button will appear after the user has searched once, and the donor type will be
				hardcoded to Individual.
			If "duplicateCheck", an array of donor objects will be provided directly to the popup via the
				popupDonorSearch method.
				
		If "mode" is unspecified, it defaults to "search".
		
	- A "callbackMethod" param which specifies the name of a JavaScript method defined by the
		-including- page which the donor popup will activate when the user selects a donor. The
		required method signature looks like:
		function someMethodWithUniqueName(donorObj)
		
		The donorObj parameter sent to the callback method is a javascript object containing the
		properties
		{
			id : <the ID of the donor selected>,
			[... other attributes of the Donor class marked for JsonProperty]
		}
		
	To activate this popup, call the method popupDonorSearch(uid) and pass in the same
	uniqueDonorSearchPopupId String above.
--%>

<c:set var="uid"><c:out value="${param.uniqueDonorSearchPopupId}" /></c:set>

<script type="text/javascript">
$(function() {
	initDonorSearchPopup({
		uid: "${uid}",
		mode: "<c:out value="${param.mode}" default="search" />",
		maxResults: <fmt:message key="donorSearch.maxResults" />,
		callbackMethod: <c:out value="${param.resultCallbackMethod}" default="null" />,
		addButtonCallbackMethod: <c:out value="${param.addButtonCallbackMethod}" default="null" />,
		showDisclaimer: <c:out value="${not empty param.disclaimerText}" />
	})
})
</script>

<div id="donorSearchDialog${uid}" style="display: none"
	title="Search for Donor">
	<div align="center" id="donorSearchDisclaimer${uid}"
		style="display: none; font-weight: bold">
		<c:out value="${param.disclaimerText}" />
		<p />
	</div>

	<table align="center">
		<tr valign="top" class="donorSearchFields${uid}">
			<td>
				<table>
					<tr>
						<td align="right"><label for='donorSearchName${uid}'>Name:</label></td>
						<td><input type="text" id="donorSearchName${uid}"
							value="" title="Type a name in the format Last[, First Middle]"
							placeholder="Last[, First Middle]" /></td>
					</tr>
					<tr>
						<td align="right"><label for='donorSearchEmail${uid}'>Email:</label></td>
						<td><input type="text" id="donorSearchEmail${uid}"
							value="" title="Type all or part of an email" /></td>

					</tr>
				</table>
			</td>
			<td>
			<%-- <table>
					<tr>
						<td align="right"><label for='donorSearchType${uid}'>Search:</label></td>
						<td><input type="radio" id="donorSearchType${uid}"
							name="donorSearchIndividual${uid}" value="Individual" checked="checked">Individual
							<input type="radio"
							id="volunteerSearchOrganization${uid}"
							name="volunteerSearchType${uid}" value="Organization"
							style="margin-left: 50px">Organization</td>
					</tr>
				</table> --%>
			</td>
		</tr>
		<tr align="center">
			<td colspan="2"><a style="margin-left: 20px"
				class="buttonAnchor donorSearchLink${uid} donorSearchFields${uid}" tabIndex="0">Search</a>
				<a style="display: none" class="buttonAnchor donorAddLink${uid}"
				tabIndex="1">Add New Donor</a></td>
		</tr>
	</table>
	<div id="donorSearchNoResults${uid}" style="display: none">
		<table align="center" cellpadding="10">
			<tr>
				<td>Sorry, no donors were found that matched the specified
					criteria.</td>
			</tr>
		</table>
	</div>
	<div id="donorSearchMaxResults${uid}"
		style="display: none; padding: 10px" align="center">Your search
		exceeded the maximum results. Please enter additional search criteria.
	</div>
	<div id="donorSearchResultsTable${uid}" style="display: none">
		<table id="donorSearchResultsList${uid}" class="stripe"
			summary="List of Donors">
			<thead>
				<%-- <tr id="donorSearch${uid}FilterRow">
					<td class="noborder">Filters:</td>
					<td class="noborder"></td>
				<td class="noborder"></td>
					<td class="noborder"></td> 
				</tr>--%>
				<tr>
					
					<th width="40%" id="nameHeaderCol${uid}">Name</th>
					<th width="10%">Contact Info</th>
				<%--	<th width="10%" nowrap>Email</th>
					<th width="20%">Phone</th> --%>
				</tr>
			</thead>
		</table>
	</div>
</div>
