<%@ include file="../shared/inc_header.jsp"%>

<h4>
	Batch Job initiated on the request of:
	<c:if test="${not empty result.initiator}">
		<c:out value="${result.initiator.displayName}" />
		<jsp:include page="../shared/inc_emailLink.jsp">
			<jsp:param name="uid" value="closedBy${result.initiator.id}Id" />
			<jsp:param name="emailAddress" value="${result.initiator.email}" />
		</jsp:include></c:if>
	<c:if test="${empty result.initiator}">System</c:if>
</h4>
<table width="80%" align="center">
	<tr>
		<td>
			<c:if test="${fn:length(result.jobExecutionResultItems) > 500}">
			<div align="center">
				<i>Results are limited to the first 500 matching items.</i>
			</div><p>
			</c:if>
			
			<table  id="jobExecItemResultsList" class="stripe"
				summary="List of Notification Types and Settings" width="100%">
				<thead>
					<tr>
						<td class="noborder">Filters:</td>
						<td class="noborder"></td>
						<td class="noborder"></td>
						<td class="noborder" id="statusFilter"
							title="Filter Status by selecting one of these options"></td>
						<td class="noborder"></td>
						<td class="noborder"></td>
					</tr>
					<tr>
						<th>Patient</th>
						<th>Position</th>
						<th>Team</th>
						<th class="select-filter">Status</th>
						<th>Result Details</th>
						<th>Completion Time</th>
					</tr>
				</thead>
				<tbody>
					<c:forEach items="${result.jobExecutionResultItems}"
						var="itemResult" begin="0" end="499">
						<tr>
							<td><c:if test="${not empty itemResult.referencePatient}">
									<portlet:renderURL  var="patientDetailUrl">
										<portlet:param name="post-senstive-warning-create-form-show"
											value="y" />
										<portlet:param name="patientId"
											value="${itemResult.referencePatient.id}" />
									</portlet:renderURL>

									<c:choose>
										<c:when test="${itemResult.referencePatient.sensitivePatient}">
											<a class="appLink sensitivePatient"
												href="${patientDetailUrl}"><c:out
													value="${itemResult.referencePatient.displayNameLastFirst}" /></a>
										</c:when>
										<c:otherwise>
											<a class="appLink" href="${patientDetailUrl}"><c:out
													value="${itemResult.referencePatient.displayNameLastFirst}" /></a>
										</c:otherwise>
									</c:choose>


								</c:if></td>
							<td><c:if test="${not empty itemResult.referencePosition}">
									<portlet:renderURL  var="positionDetailUrl">
										<portlet:param name="position-detail-show" value="y" />
										<portlet:param name="positionId"
											value="${itemResult.referencePosition.id}" />
									</portlet:renderURL>
									<a href="${positionDetailUrl}"><c:out
											value="${itemResult.referencePosition.teamRole.name}" /></a>
								</c:if></td>
							<td><c:if test="${not empty itemResult.referenceTeam}">
									<portlet:renderURL  var="teamDetailUrl">
										<portlet:param name="team-detail-show" value="y" />
										<portlet:param name="id"
											value="${itemResult.referenceTeam.id}" />
									</portlet:renderURL>
									<a href="${teamDetailUrl}"><c:out
											value="${itemResult.referenceTeam.name}" /></a>
								</c:if></td>
							<td><c:choose>
									<c:when test="${itemResult.itemSuccessful}">Success</c:when>
									<c:otherwise>Failed</c:otherwise>
								</c:choose></td>
							<td><c:if
									test="${not empty itemResult.itemStatusMessageStr}">
									<c:out value="${itemResult.itemStatusMessageStr}" />
									<br />
								</c:if>
								
								<c:if test="${itemResult.serviceValidationException}">
									<spring:message message="${itemResult.statusException}" />
								</c:if>
								
								<c:if test="${not itemResult.serviceValidationException and not empty itemResult.statusExceptionTrace}">
									<textarea rows="8" cols="100" wrap="off"><c:out
											value="${itemResult.statusExceptionTrace}" /></textarea>
								</c:if></td>
							<td><joda:format pattern="${MILITARY_DATE_TIME}"
									dateTimeZone="${userTimeZone.ID}" value="${itemResult.endTime}" /></td>
						</tr>
					</c:forEach>
				</tbody>
			</table>
		</td>
	</tr>
</table>

<jsp:include page="/WEB-INF/jsp/shared/inc_jqueryTable.jsp">
	<jsp:param name="dataTableId" value="jobExecItemResultsList" />
	<jsp:param name="defaultSort" value="[[3,'asc']]" />
	<jsp:param name="drawCallBackFn"
		value="registerSensitivePatientsForWarnings" />
</jsp:include>

