$(function() {
	$("input:submit, a.buttonAnchor, a.submitAnchor, button").button()
	
	hideSpinner()
	$(document).ajaxStart(function() {
			if (!suppressAjaxSpinner) {
				showSpinner()
			}
		})
	$(document).ajaxStop(hideSpinner)
	$(document).ajaxError(hideSpinner)
		
	$(".confirm").easyconfirm()
	
	// Get all textareas that have a "maxlength" property.
    $('textarea[maxlength]').each(function() {
        // Store the jQuery object to be more efficient...
        var $textarea = $(this)
        // Store the maxlength and value of the field.
        var maxlength = $textarea.attr('maxlength')
        var val = $textarea.val()
        // Trim the field if it has content over the maxlength.
        $textarea.val(val.slice(0, maxlength))
        // Bind the trimming behavior to the "keyup" event.
        $textarea.bind('keyup', function() {
        	if ($textarea.val().length > maxlength) {
           		 $textarea.val($textarea.val().slice(0, maxlength))
        	}
        })
    })
    
	/* Wrap all selects whose current value is inactive - CPB */
	
	$('select.inactiveAppSelect').each(function() {
		var code = $(this).attr("inactiveAppLookupCode")
		/*
		 * If we're including the inactive value in the dropdown as a valid
		 * selection, don't wrap the select
		 */
		if ($(this).find("option[value='" + code + "']").length > 0)
			return
			
		var table = $('<table cellpadding="5" class="inactiveAppSelectWrapper"><tr>'+				
				'<td>' + $(this).attr("inactiveAppLookupName") + ' (inactive)</td>' +
			'</tr>' +
		'</table>')
		
		$(this).replaceWith(table)
	})
	
	/* Masks - autoclear = true means unless it matches the pattern below, it will set it to '' before form submission.
	 * These have to be paired with Javascript and/or Spring validation to ensure the entered value is acceptable before
	 * DB persistence. CPB */
   // formats text input in fax input fields
   $(".faxmask").mask("999-999-9999", {autoclear: false});
   // formats text input in phone input fields
   $(".phoneextmask").mask("999-999-9999? x99999" , {autoclear: false});
  
   $.fn.enableDateTimePicker = function(options) {
		this.datetimepicker(options)
		this.mask(twoDigitDateTimeMask)
		this.siblings('.ui-datepicker-trigger').attr('alt',
				'Please select a Date and time')
		this.siblings('.ui-datepicker-trigger').attr('title',
				'Click here to select a Date and time')
		this
				.attr('title',
						'Please specify a Date and Time in the MM/DD/YYYY HH:mm format')
	}
	$.fn.enableDatePicker = function(options) {
		this.datepicker(options)
		this.mask(twoDigitDateMask)
		this.siblings('.ui-datepicker-trigger').attr('alt',
				'Please select a Date')
		this.siblings('.ui-datepicker-trigger').attr('title',
				'Click here to select a Date')
		this
				.attr('title',
						'Please specify a Date in the MM/DD/YYYY format')
	}
})

function setFocus() {
	window.focus()
}

function scrollToTop() {
   window.scrollTo(0, 0);
}

function setDutyStation(dsName, parentName) {
	var dutyStationCell = document.getElementById("dutyStationId")
    if (dutyStationCell != null) {
    	/* Always show duty station field, even with an empty value */
    	dutyStationCell.innerHTML = dsName != null && dsName != "" ? dsName : "Not Selected"
    }
	
	var parentStationCell = document.getElementById("parentDutyStationId")
	var parentStationTitleCell = document.getElementById("parentDutyStationTitle")
	
	if (parentStationCell == null || parentStationTitleCell == null) return
	
	if (parentName != null && parentName != "") {
		parentStationCell.innerHTML = parentName;
		parentStationTitleCell.innerHTML = "Parent:"
	} else {
		parentStationCell.innerHTML = ""
		parentStationTitleCell.innerHTML = ""
	}
}

jQuery.fn.reverse = [].reverse
	
/*
 * Setting cache to false so that I   o s t fetch the content from the cache for
 * ajax requests (which it does by default on ajax get requests if response type
 * is jsonp or script)
 */
var csrfData = {}
csrfData[csrfParamName] = csrfValue

$.ajaxSetup({
  	cache:false,
  	data: csrfData
})

var militaryZonedDateTimeRegex = /^([0]\d|[1][0-2])\/([0-2]\d|[3][0-1])\/([2][01]|[1][6-9])\d{2}(\s([0]\d|[1]\d|[2][0-3])(\:[0-5]\d){1,2})*\s*$/;

suppressAjaxSpinner = false

function hideSpinner() {
	$("#spinner").hide()
	$("#spinner").css('z-index','1')
}

function showSpinner() {
	var topDomZIndex = $.topZIndex("div")
	$("#spinner").show()
	$("#spinner").css('z-index',topDomZIndex+1)
}

function logoutConfirm() {
	beep()
	confirmDialog("Changes that are not saved will be lost!\n\n Do you want to logout?", function() {
		document.location.href = homePath + '/logout.htm'
	})
}

function autoLogout() {
	document.logoutform.submit()
}

function showAll(idArray) {
	$.each(idArray,
		function(index, item) {
			$(item).show()
		})
}

function hideAll(idArray) {
	$.each(idArray,
		function(index, item) {
			$(item).hide()
		})
}

function escapeHTML(theVal) {
	if (theVal == null) return null
	theVal = $('<div />').text(theVal).html()
	theVal = theVal.replace(/\"/g,"&quot;")
	theVal = theVal.replace(/\'/g,"&#39;")
	return theVal
}

function convertLinefeedToBR(str) {
	return str.replace(/[\r?\n]/g, '<br />')
}

(function($) {
	$.fn.outerHtml = function() {
	  return $('<div />').append(this.eq(0).clone()).html()
	}
})(jQuery);

/*
(function($) {
 $.widget( "ui.dialog", $.ui.dialog, {
		 _setOption: function( key, value ) {
			// For title ensure that escapeHTML has been called before
			// setting it on the dialog
			 if (key=='title')  {
				value = escapeHTML(value);
			 }
			// call _super to call extended widget behavior
			 this._super( key, value );	
	  }
   })
})(jQuery)
*/

$('.inner').wrap(function() {
  return '<div class="' + $(this).text() + '" />';
})

function doubleClickSafeguard(jqueryObjToDisable, timeout, timeoutExpiredCallback) {
	jqueryObjToDisable.button("option", "disabled", true)
	var finalTimeout = timeout ? timeout : 2000
	setTimeout(function() { jqueryObjToDisable.button("option", "disabled", false) }, finalTimeout)
	if (timeoutExpiredCallback) {
		setTimeout(timeoutExpiredCallback, finalTimeout)
	}
}

function doubleSubmitFormSafeguard(form) {
	// if(form.data.submitted) {
	// alert("Form is already submitted!");
	// return false;
	// } else {
	// form.data.submitted=true;
		return true;
	// }
}

function applyFocusToFirstActiveField() {
	// Focus on the first enabled, visible, input or textarea on the form
	var enabledVisibleInputsSet = $("#AppContainerDiv")
			.find(
					':input:enabled:visible, textarea:enabled:visible, select:enabled:visible')
					
	var anyDialogVisible = $(".ui-dialog").is(":visible");
	if (enabledVisibleInputsSet.size() > 0) {
		if (!anyDialogVisible) {
				enabledVisibleInputsSet.first().focus()
		}
	} else {
		$('#homeLink').focus()
	}
}

function validateEmail(email) {
	var emailcheck = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
	return emailcheck.test(email);
}

function validatePhone(phone) {
	var phoneCheck = /^\(?(\d{3})\)?[-]?(\d{3})[-]?(\d{4})[ ]?(x)?(\d{1,5})?$/;
	return phoneCheck.test(phone);
}

function validateFax(fax) {
	var faxCheck = /^\(?(\d{3})\)?[-]?(\d{3})[-]?(\d{4})[ ]?$/;
	return faxCheck.test(fax);
}

function validateDate(date) {
	// validate date format mm/dd/yyyy
	var dateCheck = /^([0][1-9]|[1][0-2])\/([0][1-9]|[1-2]\d|[3][0-1])\/([2][01]|[1][6-9])\d{2}(\s([0]\d|[1]\d|[2][0-3])(\:[0-5]\d){1,2})*\s*$/
	return dateCheck.test(date);
}

function validateNumeric(numeric) {
	numericNum=removeCommas(numeric);
	var numericCheck = /^[1-9]\d*(\.\d+)*$/;
	return numericCheck.test(numericNum);
}

function formatAndAddThousandSeparators(nStr)
{
	nStr.toFixed(2); 
    nStr += '';
    var x = nStr.split('.');
    var x1 = x[0];
    var x2 = x.length > 1 ? '.' + x[1] : '.00';
    var rgx = /(\d+)(\d{3})/;
    while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2');
    }
    return x1 + x2;
}

function removeCommas(str) {
    while (str.search(",") >= 0) {
        str = (str + "").replace(',', '');
    }
    return str;
};

function getBoxEl(theHtml, addBorder) {
	var newEl = $("<div></div>")
		.css({'border' : addBorder ? '1px dashed black' : 'none',
			'text-align' : 'left',
			'padding' : '5px',
			'margin' : '2px',
			'display' : 'inline-block',
			'width' : '100%',
			'box-sizing' : 'border-box'
			}).html(theHtml)
	return newEl
}

function commonAjaxErrorHandler(jqXHR, textStatus, errorThrown) {
	var errorText = errorThrown
	var details = null
	if (jqXHR.status == 404 || jqXHR.status == 0) {
		errorText = 'The server is offline or could not be contacted.'
	} else if (jqXHR.status == 403) {
		errorText = 'Your request was denied, possibly due to a session timeout or server restart. Please logout and login again.'
	} else if (jqXHR.responseJSON) {
		var ar = jqXHR.responseJSON.ajaxResult
		if (ar) {
			errorText = ar.statusMessage
			details = ar.statusDetails
		}
	} else if (jqXHR.responseText) {
		details = jqXHR.responseText
	}
	
	if (errorText == null) errorText = 'Unknown error'
	
	displayAttentionDialog(errorText, details, 'Error')
}

function abbreviate(str, maxLen) {
	var oneThird = maxLen / 3
	var twoThirds = maxLen * 2 / 3
	if (str.length > maxLen)
	    return str.substr(0, twoThirds) + '...' + str.substr(str.length-oneThird, str.length);
	return str;
}

function setSounds(theCheckbox) {
	toggleSounds(theCheckbox.checked)
}

function showPageTitle() {
	$("#titleRow").show()
}
function hidePageTitle() {
	$("#titleRow").hide()
}
function setPageTitle(pageTitle) {
	$("#pageTitleSpan").text(pageTitle)
}

var monthIndexes = {
		'january' : 0,
		'february' : 1,
		'march' : 2,
		'april' : 3,
		'may' : 4,
		'june' : 5,
		'july' : 6,
		'august' : 7,
		'september' : 8,
		'october' : 9,
		'november' : 10,
		'december' : 11
}
function monthComparator(a, b) {
	if (a === b) return 0
	var aIndex = monthIndexes[a.toLowerCase()]
	var bIndex = monthIndexes[b.toLowerCase()]
	if (aIndex == bIndex) return 0
	if (!aIndex && bIndex) return -1
	if (!bIndex && aIndex) return 1
	return aIndex < bIndex ? -1 : 1
}

function getAsYYYYMMDD(MMDDYYYYString) {
	if (!MMDDYYYYString) return null
	
	var a = MMDDYYYYString.split('/').join('').split('-').join('')
	return a.substring(4, 8) + a.substring(2, 4) + a.substring(0, 2)
}

function getAsMMDDYYYY(YYYYMMDDString, optionalToken) {
	if (!YYYYMMDDString) return null
	
	var t = optionalToken || ''
	var a = YYYYMMDDString.split('/').join('').split('-').join('')
	return a.substring(4, 6) + t + a.substring(6, 8) + t + a.substring(0, 4)
}

function removeChars(val, charArray) {
	if (charArray.length) {
		for (var i = 0; i < charArray.length; i++)
			val = val.split(charArray[i]).join('')
	} else {
		val = val.split(charArray).join('')
	}
	return val
}

function saveAlertForLater() {
	$.get('/saveAlert.htm', function(response) {
		$('#activeAlertDiv').hide()
	})
}

function markActiveAlertAsComplete() {
	$.get('/alertMarkComplete.htm', function(response) {
		$('#activeAlertDiv').hide()
	})
}

function allValsEmpty(elementIdList) {
	for (var i = 0; i < elementIdList.length; i++)
		if ($.trim($("#" + elementIdList[i]).val()) != '')
			return false
	return true
}

function jumpToVolunteer(id) {
	document.location.href = homePath + '/volunteerEdit.htm?id=' + id
}

function menuVolunteerSelectedCallback(volunteerObj) {
	jumpToVolunteer(volunteerObj.id)
}

function jumpToOrganization(id) {
	document.location.href = homePath + '/organizationEdit.htm?id=' + id
}

function menuOrganizationSelectedCallback(organizationObj) {
	jumpToOrganization(organizationObj.id)
}

function menuVolunteerAddSelectedCallback() {
	document.location.href = homePath + "/volunteerCreate.htm"
}

function menuDonorAddSelectedCallback() {
	document.location.href = homePath + "/donorCreate.htm"
}

function jumpToDonor(id) {
	document.location.href = homePath + '/donorEdit.htm?id=' + id
}

function menuDonorSelectedCallback(donorObj) {
	jumpToDonor(donorObj.id)
}