package gov.va.vss.persistence;

import java.time.ZonedDateTime;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.jobExecution.JobExecutionResult;
import gov.va.vss.model.jobExecution.JobExecutionResultItem;
import gov.va.vss.model.lookup.JobExecutionType;
import gov.va.vss.model.lookup.JobExecutionType.JobExecutionTypeValue;
import gov.va.vss.persistence.dao.CustomizableAppDAO;

public class TestJobExecutionResultItemDAO extends AbstractTransactionalWebDAOTest<JobExecutionResultItem> {

	@Override
	protected CustomizableAppDAO<JobExecutionResultItem> getDAO() {
		return jobExecutionResultItemDAO;
	}

	@Override
	protected JobExecutionResultItem getInstanceToSave() throws Exception {
		return createItem();
	}

	public JobExecutionResultItem createItem() {
		JobExecutionType type = jobExecutionTypeDAO.findByLookup(JobExecutionTypeValue.LEIE);
		JobExecutionResult result = new JobExecutionResult();
		result.setType(type);
		result.setStartTime(ZonedDateTime.now());
		result = jobExecutionResultDAO.saveOrUpdate(result);

		JobExecutionResultItem resultItem = new JobExecutionResultItem(ZonedDateTime.now());
		resultItem.setJobExecutionResult(result);
		resultItem.setEndTime(ZonedDateTime.now());
		resultItem.setItemSuccessful(true);
		resultItem.setItemStatusMessageStr("testStatus");
		return resultItem;
	}

}
