package gov.va.vss.service.batch;

import java.util.List;

import org.junit.Assert;
import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.JobExecutionListener;
import org.springframework.stereotype.Component;

@Component
public class FailureOnExceptionListener implements JobExecutionListener {

	@Override
	public void beforeJob(JobExecution jobExecution) {
	}

	@Override
	public void afterJob(JobExecution jobExecution) {
		List<Throwable> failureExceptions = jobExecution.getAllFailureExceptions();
		if (failureExceptions.isEmpty())
			return;
		Throwable realCause = failureExceptions.get(0);
		realCause.printStackTrace();
		Assert.fail("The batch job did not complete successfully");
	}

}
