package gov.va.vss.service.batch;

import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import gov.va.vss.model.jobExecution.JobExecutionResult;
import gov.va.vss.model.jobExecution.JobExecutionResultItem;
import gov.va.vss.service.impl.JobExecutionResultServiceImpl;

@Service
@Profile({ "default" })
public class JobExecutionResultServiceForTestingImpl extends JobExecutionResultServiceImpl
		implements JobExecutionResultService {

	@Override
	public JobExecutionResult saveOrUpdate(JobExecutionResult result) {
		result = super.saveOrUpdate(result);
		if (JobExecutionResultItemServiceForTestingImpl.allowJobExecutionResultItemsWithExceptions)
			return result;

		for (JobExecutionResultItem item : result.getJobExecutionResultItems()) {
			Exception statusException = item.getStatusException();
			if (statusException != null)
				throw new RuntimeException(statusException);
		}
		return result;
	}

}
