package gov.va.shared.util;

import java.io.File;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class FileUtil {
	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(FileUtil.class);

	/**
	 * Checks the specified directory for a file with the specified name. If the
	 * file doesn't exist, return a new file with the specified directory &
	 * name. If it does exist, append an incrementing number to the end and
	 * continue until we arrive at a filename that is nonexistant (available).
	 * If the specified name has an extension, append the number to the portion
	 * before the extension (so test1.txt instead of test.txt1).
	 * 
	 * @param directory
	 *            The directory containing our files
	 * @param name
	 *            The desired original filename
	 * @return
	 */
	public static File getUniqueFile(String directory, String name) {
		String extension = "";
		int periodOffset = name.lastIndexOf(".");
		if (periodOffset != -1) {
			extension = name.substring(periodOffset);
			name = name.substring(0, periodOffset);
		}
		String newName = name;
		int i = 1;
		File result;
		while ((result = new File(directory, newName + extension)).exists()) {
			newName = name + i++;
		}
		return result;
	}

}