package gov.va.vss.config.containerOnly;

import javax.jms.ConnectionFactory;
import javax.naming.NamingException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.jndi.JndiObjectFactoryBean;

@Configuration
public class MessagingContainerConfig {

	@Autowired
	private Environment env;

	@Bean
	public ConnectionFactory jmsConnectionFactory() throws IllegalArgumentException, NamingException {
		JndiObjectFactoryBean b = new JndiObjectFactoryBean();
		b.setJndiName(env.getProperty("jndi.connectionFactory"));
		b.afterPropertiesSet();
		return (ConnectionFactory) b.getObject();
	}

}
