package gov.va.vss.model.organization;

import java.util.List;

import gov.va.shared.model.core.AuditedVersionedPersistent;
import gov.va.shared.model.lookup.sds.State;
import gov.va.vss.model.ScopeType;
import gov.va.vss.model.VolunteerOrganization;
import gov.va.vss.model.WorkEntry;
import gov.va.vss.model.facility.Facility;

public interface BasicOrganization extends AuditedVersionedPersistent, Comparable<BasicOrganization> {

	Organization getRootOrganization();
	
	boolean isActive();

	String getDisplayName();

	String getScale();

	ScopeType getScope();

	void setScope(ScopeType scopeType);

	Facility getFacility();

	void setFacility(Facility facility);

	String getAbbreviation();

	void setAbbreviation(String abbreviation);

	String getName();

	void setName(String name);

	String getFullName();

	void setFullName(String fullName);

	boolean isInactive();

	void setInactive(boolean inactive);

	List<VolunteerOrganization> getVolunteerOrganizations();

	void setVolunteerOrganizations(List<VolunteerOrganization> volunteerOrganizations);

	String getAddressLine1();

	void setAddressLine1(String address1);

	String getAddressLine2();

	void setAddressLine2(String address2);

	String getCity();

	void setCity(String city);

	State getState();

	void setState(State state);

	String getZip();

	void setZip(String zip);

	String getEmail();

	void setEmail(String email);

	String getPhone();

	void setPhone(String phone);

	List<WorkEntry> getWorkEntries();

	void setWorkEntries(List<WorkEntry> workEntries);

}