package gov.va.vss.persistence.dao;

import java.util.List;
import java.util.SortedSet;

import gov.va.vss.model.ScopeType;
import gov.va.vss.model.organization.AbstractBasicOrganization;
import gov.va.vss.model.organization.BasicOrganization;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;
import gov.va.vss.web.reports.OrgQuickSearchResult;

public interface OrganizationDAO extends CustomizableSortedDAO<AbstractBasicOrganization> {

	List<BasicOrganization> findByCriteria(String name, boolean includeNational, boolean includeLocalFacility,
			List<Long> localFacilityIds, Boolean activeStatus, Integer code, String abbreviation,
			QueryCustomization... customization);

	int findNextAvailableCode(ScopeType scope, Long localFacilityId);

	SortedSet<OrgQuickSearchResult> quickSearch(String searchValue, int length);

}
