package gov.va.vss.persistence.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import gov.va.vss.model.facility.Location;
import gov.va.vss.persistence.dao.LocationDAO;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;

@Repository
public class LocationDAOImpl extends GenericHibernateSortedDAOImpl<Location> implements LocationDAO {

	@Override
	public SortedSet<Location> findByCriteria(Long parentFacilityId) {
		if (parentFacilityId == null)
			throw new IllegalArgumentException("No criteria specified");

		StringBuilder sb = new StringBuilder("select v from ").append(Location.class.getName()).append(" v");

		/* Don't bother with this yet - CPB */
		QueryCustomization cust = new QueryCustomization();

		List<String> whereClauseItems = new ArrayList<>();
		Map<String, Object> params = new HashMap<>();

		if (parentFacilityId != null) {
			whereClauseItems.add("v.parent.id = :parentId");
			params.put("parentId", parentFacilityId);
		}

		Query q = constructQuery(em, sb, whereClauseItems, params, null, cust);

		int maxResults = -1;
		if (cust.getRowLimitation() != null)
			maxResults = cust.getRowLimitation();

		if (maxResults > 0)
			q.setMaxResults(maxResults);

		@SuppressWarnings("unchecked")
		List<Location> resultList = q.getResultList();
		return new TreeSet<>(resultList);
	}

}
