package gov.va.vss.service;

import gov.va.vss.model.DonationDetail;
import gov.va.vss.model.DonationSummary;
import gov.va.vss.service.validation.ServiceValidationException;

public interface DonationService {

	/**
	 * @param donationDetail
	 *            The donationDetail to save or update
	 * @return The updated donationDetail after it's been persisted / updated
	 * @throws ServiceValidationException
	 *             If a business-level validation exception occurred during the
	 *             save/update process
	 */
	DonationDetail saveOrUpdateDonationDetail(DonationDetail donationDetail) throws ServiceValidationException;

	/**
	 * @param donationSummary
	 *            The donationSummary to save or update
	 * @return The updated donationSummary after it's been persisted / updated
	 * @throws ServiceValidationException
	 *             If a business-level validation exception occurred during the
	 *             save/update process
	 */
	DonationSummary saveOrUpdateDonationSummary(DonationSummary donationSummay) throws ServiceValidationException;

	/**
	 * Deletes the DonationDetail with the specified volunteerId
	 * 
	 * @param donationDetailId
	 *            The ID of the donation detail to delete
	 */
	void deleteDonationDetail(long donationDetailId);
	
	/**
	 * Deletes the DonationDetail with the specified volunteerId
	 * 
	 * @param donationSummayId
	 *            The ID of the donation detail to delete
	 */
	void deleteDonationSummary(long donationSummaryId);
}
