package gov.va.vss.service;

import java.util.HashMap;
import java.util.Map;

import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.tools.generic.DateTool;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.ui.velocity.VelocityEngineUtils;

import gov.va.vss.model.lookup.TemplateType;

@Service
public class VelocityService {

	@Autowired
	private VelocityEngine velocityEngine;
	@Value("${emailTemplateEncoding}")
	private String emailTemplateEncoding;

	public String mergeTemplateIntoString(TemplateType templateType) {
		return mergeTemplateIntoString(templateType, new HashMap<String, Object>());
	}

	public String mergeTemplateIntoString(String templateName) {
		return mergeTemplateIntoString(templateName, new HashMap<String, Object>());
	}

	public String mergeTemplateIntoString(TemplateType templateType, HashMap<String, Object> model) {
		return mergeTemplateIntoString(templateType.getName(), model);
	}

	public String mergeTemplateIntoString(String templateName, Map<String, Object> model) {
		if (!model.containsKey("date"))
			model.put("date", new DateTool());

		String content = VelocityEngineUtils.mergeTemplateIntoString(velocityEngine, templateName,
				emailTemplateEncoding, model);
		return content;
	}

}
