package gov.va.vss.service.impl;

import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import gov.va.vss.model.ExcludedEntity;
import gov.va.vss.persistence.dao.ExcludedEntityDAO.ImportDataCallback;
import gov.va.vss.service.ExcludedEntityService;

@Service
public class ExcludedEntityServiceImpl extends AbstractServiceImpl implements ExcludedEntityService {
	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(ExcludedEntityServiceImpl.class);

	@Override
	public int refreshData() throws IOException {
		excludedEntityDAO.deleteAll();

		int numResults = excludedEntityDAO.importData(new ImportDataCallback() {
			@Override
			public void processRecord(ExcludedEntity e) {
				excludedEntityDAO.saveOrUpdate(e);
			}
		});
		
		return numResults;
	}

}
