package gov.va.vss.service.scheduledJobs;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import gov.va.shared.model.Role;
import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.shared.persistence.GrantableRoleDAO;
import gov.va.shared.persistence.lookup.RoleDAO;
import gov.va.shared.persistence.lookup.sds.VAFacilityDAO;

@Component
public class CacheAutoRefresher {

	@Autowired
	private GrantableRoleDAO grantableRoleDAO;
	@Autowired
	private RoleDAO roleDAO;
	@Autowired
	private VAFacilityDAO vaFacilityDAO;

	@Scheduled(initialDelayString = "${cache.autoRefresh.startupDelayMillis}", //
			fixedDelayString = "${cache.autoRefresh.fixedDelayMillis}")
	public void refresh() {
		List<VAFacility> all = vaFacilityDAO.findAll();
		for (VAFacility f : all) {
			f.getStationNumber();
			f.getCity();
		}
		vaFacilityDAO.findAllSorted();
		vaFacilityDAO.findAllThreeDigitStationsSorted();
		vaFacilityDAO.findAllActiveTreatingFacilities();

		List<Role> allRoles = roleDAO.findAll(true);
		for (Role r : allRoles) {
			grantableRoleDAO.findGrantableRolesForRole(r.getId());
		}

	}

}
