package gov.va.vss.web.donation;

import java.time.LocalDate;

import gov.va.shared.util.StringUtil;
import gov.va.vss.model.DonationDetail;
import gov.va.vss.model.DonationSummary;
import gov.va.vss.model.Donor;

public class DonationCommand {

	// -------------------------------- Fields

	private DonationSummary donationSummary;
	private Donor donor;
	private boolean isVolunteer = false;
	private String displayName;
	private String donorCategory;
	private DonationDetail donationDetail1;
	private DonationDetail donationDetail2;
	private DonationDetail donationDetail3;
	private DonationDetail donationDetail4;
	private LocalDate currentFiscalYearStartDate;
	private LocalDate currentFiscalYearEndDate;

	// -------------------------------- Constructors

	public DonationCommand() {
	}

	public DonationCommand(DonationSummary donationSummary) {
		this.donationSummary = donationSummary;
		this.donor = donationSummary.getDonor();
	}

	// -------------------------------- Accessor Methods

	public DonationSummary getDonationSummary() {
		if (donationSummary != null && donationSummary.getDonationDate() == null)
			donationSummary.setDonationDate(LocalDate.now());
		return donationSummary;
	}

	public void setDonationSummary(DonationSummary donationSummary) {
		this.donationSummary = donationSummary;
	}

	public Donor getDonor() {
		return donor;
	}

	public void setDonor(Donor donor) {
		this.donor = donor;
	}

	public boolean isVolunteer() {
		if (donor.getVolunteer() != null)
			isVolunteer = true;
		return isVolunteer;
	}

	public void setVolunteer(boolean isVolunteer) {
		this.isVolunteer = isVolunteer;
	}

	public String getDisplayName() {
		displayName = StringUtil.getDisplayName(true, donor.getFirstName(), donor.getMiddleName(), donor.getLastName(),
				donor.getSuffix());
		return displayName;
	}

	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}

	public String getDonorCategory() {
		if (donor.getVolunteer() != null)
			donorCategory = "Volunteer";
		else if (donor.getOrganization() != null)
			donorCategory = "Organization";
		else
			donorCategory = "Donor";
		return donorCategory;
	}

	public void setDonorCategory(String donorCategory) {
		this.donorCategory = donorCategory;
	}

	public DonationDetail getDonationDetail1() {
		return donationDetail1;
	}

	public void setDonationDetail1(DonationDetail donationDetail1) {
		this.donationDetail1 = donationDetail1;
	}

	public DonationDetail getDonationDetail2() {
		return donationDetail2;
	}

	public void setDonationDetail2(DonationDetail donationDetail2) {
		this.donationDetail2 = donationDetail2;
	}

	public DonationDetail getDonationDetail3() {
		return donationDetail3;
	}

	public void setDonationDetail3(DonationDetail donationDetail3) {
		this.donationDetail3 = donationDetail3;
	}

	public LocalDate getCurrentFiscalYearStartDate() {
		return currentFiscalYearStartDate;
	}

	public void setCurrentFiscalYearStartDate(LocalDate currentFiscalYearStartDate) {
		this.currentFiscalYearStartDate = currentFiscalYearStartDate;
	}

	public LocalDate getCurrentFiscalYearEndDate() {
		return currentFiscalYearEndDate;
	}

	public void setCurrentFiscalYearEndDate(LocalDate currentFiscalYearEndDate) {
		this.currentFiscalYearEndDate = currentFiscalYearEndDate;
	}

	public DonationDetail getDonationDetail4() {
		donationDetail4 = new DonationDetail();
		return donationDetail4;
	}

	public void setDonationDetail4(DonationDetail donationDetail4) {
		this.donationDetail4 = donationDetail4;
	}

}
