package gov.va.vss.web.facility;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;

import gov.va.vss.model.facility.Facility;
import gov.va.vss.web.AbstractAppValidator;

@Component
public class FacilityValidator extends AbstractAppValidator<FacilityCommand> {

	@Override
	public void doExtraValidations(FacilityCommand command, Errors errors) {
		Facility f = command.getFacility();
		if (!f.isLinkedToVAFacility()) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "facility.name", "facility.error.requiredField");
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "facility.addressLine1", "facility.error.requiredField");
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "facility.city", "facility.error.requiredField");
			ValidationUtils.rejectIfEmpty(errors, "facility.state", "facility.error.requiredField");
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "facility.zip", "facility.error.requiredField");
		}
	}

}
