<%@ include file="../shared/inc_header.jsp"%>

<jsp:include page="/WEB-INF/jsp/shared/inc_donorSearchPopup.jsp">
	<jsp:param name="uniqueDonorSearchPopupId" value="changeDonor" />
	<jsp:param name="mode" value="search" />
	<jsp:param name="resultCallbackMethod"
		value="changeDonorSelectedCallback" />
</jsp:include>


<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<script type="text/javascript">
	var isReadOnly = <c:out value="${FORM_READ_ONLY}" default="false"/>
	var valChanged = false

	$(function() {

		var theDataTable = $('#donationDetailsList')
				.DataTable(
						{
							"dom" : '<"top">rt<"bottom"><"clear">',
							"stateSave" : false,
							"columnDefs" : [ {
								className : "dt-body-right dt-foot-right",
								"targets" : [ 1 ]
							} ],
							"footerCallback" : function(row, data, start, end,
									display) {
								var api = this.api();
								// Remove the formatting to get integer data for summation
								var intVal = function(i) {
									return typeof i === 'string' ? i.replace(
											/[\$,]/g, '') * 1
											: typeof i === 'number' ? i : 0;
								};
								// Total over all pages
								total = api.column(1).data().reduce(
										function(a, b) {
											return intVal(a) + intVal(b);
										}, 0);
								// Update footer
								//Occasionally the total sum is not right for cents. The following line just a temporary fix
								total = Math.round(total*100)/100; 
								$(api.column(1).footer())
										.html('$'+ formatAndAddThousandSeparators(total));
							}
						})
				//resort the list
				
				var theDataTable = $('#donationDetailsForNewDonation')
				.DataTable(
						{
							"dom" : '<"top">rt<"bottom"><"clear">',
							"stateSave" : false,
							"columnDefs" : [ {
								"targets" : [ 1 ]
							} ],
							"aaSorting": [[ 1, "desc" ]]
						})		
						
				var theDataTable = $('#donationDetailsForNewDonation1')
				.DataTable(
						{
							"dom" : '<"top">rt<"bottom"><"clear">',
							"stateSave" : false,
					
						})		


		$([ '#donationDate', '#checkDate', '#acknowledgementDate' ]).each(
				function(index, o) {
					$(o).enableDatePicker({
						showOn : "button",
						buttonImage : imgHome + "/calendar.gif",
						buttonImageOnly : true
					})
					$(o).mask("${TWO_DIGIT_DATE_MASK}", {
						autoclear : false
					})
				})
		
		$("#donationTypeSelect").change(toggleTheFields)	
		$("#submitFormButton").click(submitForm)
		
		toggleTheFields()
		
		$(".donationInput").change(function() {
			valChanged = true
		})
	})
	
	var donationTypeVal 
	
	function changeDonor() {
		if (valChanged) {
			confirmDialog('Save changes before changing donor?', function() {
				$("#donationProfileForm").submit()
			}, function() {
				popupDonorSearch('changeDonor')
			})
		} else {
			popupDonorSearch('changeDonor')
		}
	}

	function toggleTheFields() {
        donationTypeVal = $("#donationTypeSelect").val()
        toggleDisplays(donationTypeVal)
        if (${command.donationSummary.persistent} && hasDonationDetailWithRealGPF &
        		(donationTypeVal == '3' // item
        				|| donationTypeVal == '4' // activity
        		)) {
        	displayAttentionDialog('Please remove all GPF entries whose fund is not "None" before saving.')
        }
   }

	function toggleDisplays(donationTypeVal) {
		$('.checkDonationType').toggle(shouldShowCheckFields(donationTypeVal));	
		$('.creditCardDonationType').toggle(shouldShowCreditCardFields(donationTypeVal));	
		$('.ePayDonationType').toggle(shouldShowEDonationFields(donationTypeVal));	
		$('.fieldServiceReceipt').toggle(shouldShowReceiptField(donationTypeVal));
		$('.noServiceReceipt').toggle(!shouldShowReceiptField(donationTypeVal));
		$('.hiddenFieldsForItemAndActivity').toggle(!shouldShowFieldsForItemAndActivity(donationTypeVal));
		$('.hiddenGpfTableForItemAndActivity').toggle(!shouldShowFieldsForItemAndActivity(donationTypeVal));
		$('.gpfTableForItemAndActivity').toggle(shouldShowFieldsForItemAndActivity(donationTypeVal));
	}
	
	
	function shouldShowCheckFields(donationTypeVal) {
		return 	donationTypeVal == '2'
	}
	
	function shouldShowCreditCardFields(donationTypeVal) {
		return 	donationTypeVal == '6'
	}
	
	function shouldShowEDonationFields(donationTypeVal) {
		return 	donationTypeVal == '5'
	}
	
	function shouldShowReceiptField(donationTypeVal) {
		if (donationTypeVal == '2' || donationTypeVal == '1' || donationTypeVal == '6')
			return true;
		else
			return false;	
	}
	
	function shouldShowFieldsForItemAndActivity(donationTypeVal) {
		if (donationTypeVal == '3' || donationTypeVal == '4' )
			return true;
		else
			return false;	
	}
	
	
	function refreshDonationDetailsData(r) {
					
		var table = $('#donationDetailsList').DataTable()
		table.clear()
		table.rows.add(r)
		table.draw()
	}

	function submitForm(evt) {
		if (!validate())
		    return

		if (evt != null)
			doubleClickSafeguard($(evt.currentTarget))
		$('#donationProfileForm').submit()

	}

	function deleteDonationDetail(donationDetailId) {
		var fullObj = donationDetailsList[donationDetailId]
		confirmDialog('Are you sure you want to delete this entry for ["'
				+ fullObj.donGenPostFund.generalPostFund + '"]?', function() {
			$.ajax({
				url : ajaxHomePath + '/deleteDonationDetail',
				dataType : 'json',
				data : {
					donationDetailId : donationDetailId
				},
				error : commonAjaxErrorHandler,
				success : function() {
					/* generated by inc_jqueryTable.jsp */
					refreshDonationDetails()
				}
			})
		})
	}

	function changeDonorSelectedCallback(donorObj) {
		
		var hasDonor = (typeof donorObj !== 'undefined')
		var changedDonorId = hasDonor? donorObj.id : ''
		
		$.ajax({
			url : ajaxHomePath + '/changeDonor',
			dataType : 'json',
			data : {
				donationSummaryId : ${(not empty command.donationSummary.id) ? command.donationSummary.id : 'undefined'} ,
				donorId: changedDonorId
			},
			error : commonAjaxErrorHandler,
			success : function() {
				document.location.href=homePath + "/donationEdit.htm?id=${command.donationSummary.id}"
			}
		})
	}   
	
		
	
	
	function validate() {
		var errors = new Array()

		if ($('#donationDate').val() != ''
				&& !validateDate($('#donationDate').val())) {
			errors.push("Donation Date is invalid.")
		}

		if ($('#checkDate').val() != '' && !validateDate($('#checkDate').val())) {
			errors.push("Check Date is invalid.")
		}

		if ($('#donationDate').val() == '')
			errors.push("Donation Date is required.")
					
		if ($('#donationTypeSelect').val() == '-1')
			errors.push("Donation Type is required.")
			
		if($("#donationTypeSelect").val() == '2') {
			if ($('#checkNumber').val() == '')
				errors.push("Check Number is required.")

			if ($('#checkNumber').val() != '' &&  !validateNumericWithoutCommas($('#checkNumber').val()))
				errors.push("Check Number needs to be numeric.")
		}
		
		if($("#donationTypeSelect").val() == '6') {
			if ($('#cardTypeSelect').val() == '-1')
				errors.push("Card Type is required.")

			if ($('#confirmatiomNumber').val() == '' )
				errors.push("Confirmation Number is required.")
		}
		
		if($("#donationTypeSelect").val() == '5') {
			if ($('#epayTrackingId').val() == '' )
				errors.push("E-Pay Tracking Number is required.")
		}
		
				
		if(!${command.donationSummary.persistent}  && $('#donationTypeSelect').val() != '3' && $('#donationTypeSelect').val() != '4') {
				
			if ($('#gpf1').val() == '-1')
				errors.push("General Post Fund is required.")
				
			if ($('#donationAmount1').val() == '')
				errors.push("Donation Amount is required.")
				
			if ($('#donationAmount1').val() != '' && $('#donationAmount1').val() > 9999999999.99 ) 
				errors.push("The maximun donation amount is 9999999999.99.")
					
			if ($('#donationAmount1').val() != ''
				&& !validateNumericWithoutCommas($('#donationAmount1').val())) 
				errors.push("Donation Amount is invalid [format should be ########## or ##########.##].") 
		
				
			if($('#gpf2').val() != '-1' && $('#donationAmount2').val() == '')
				errors.push("Donation Amount is required if General Post Fund is selected.")
				
			if($('#gpf2').val() == '-1' && $('#donationAmount2').val() != '')
				errors.push("General Post Fund required if Donation Amount is given.")
				
			if($('#gpf3').val() != '-1' && $('#donationAmount3').val() == '')
				errors.push("Donation Amount is required if General Post Fund is selected.")
				
			if($('#gpf3').val() == '-1' && $('#donationAmount3').val() != '')
				errors.push("General Post Fund required if Donation Amount is given.")
				
			if ($('#donationAmount2').val() != '' && $('#donationAmount2').val() > 9999999999.99 ) {
				errors.push("The maximun donation amount is 9999999999.99.")
			}
			
			if ($('#donationAmount2').val() != ''
				&& !validateNumericWithoutCommas($('#donationAmount2').val())) {
				errors.push("Donation Amount is invalid [format should be ########## or ##########.##].") 
			}
			if ($('#donationAmount3').val() != '' && $('#donationAmount3').val() > 9999999999.99 ) {
				errors.push("The maximun donation amount is 9999999999.99.")
			}
			
			if ($('#donationAmount3').val() != ''
				&& !validateNumericWithoutCommas($('#donationAmount3').val())) {
				errors.push("Donation Amount is invalid [format should be ########## or ##########.##].") 
			}
		}
		
			
		if (errors.length > 0)
			displayAttentionDialog("Please correct the following errors: <ul><li>"
					+ errors.join("</li><li>") + "</li></ul>");

		return errors.length == 0
	}
</script>

<style>
div.donationInputFields {
	min-width: 750px;
	max-width: 750px;
}

#normalTable2 > thead > tr > th[class*="sort"]::after{display: none}

</style>


<form:form method="post" action="${home}/donationSummarySubmit.htm"
	id="donationProfileForm">
	<c:if test="${empty command.donor.volunteer.id}">
		<div class="clearCenter donationInputFields">
			<fieldset>
				<legend>Donor</legend>
				<div class="leftHalf">
					<table>
						<tr>
							<td class='appFieldLabel' nowrap>Type:</td>
							<td><c:out
									value="${command.donor.vtkDonorType.donorType} - ${command.donorCategory}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap><span
								style="padding-left: 30px">Name:</span></td>
							<td><c:out value="${command.displayName}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap>Email:</td>
							<td><c:out value="${command.donor.email}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap>Phone:</td>
							<td><c:out value="${command.donor.phone}" /></td>
						</tr>
					</table>
				</div>
				<div class="rightHalf">
					<table>
						<tr>
							<td class='appFieldLabel'>Address:</td>
							<td><span><pre><c:out value="${command.donor.addressMultilineDisplay}"/></pre></span></td>
						</tr>
					</table>
				</div>
				<c:if
					test="${not FORM_READ_ONLY and command.donationSummary.persistent}">
					<div class="clearCenter">
						<td rowspan="2" width="110px">&nbsp;</td> <a
							href="javascript:changeDonor()" id="changeDonor"
							class="buttonAnchor">Change Donor</a>
					</div>
				</c:if>
			</fieldset>
		</div>
	</c:if>

	<%--- volunteer --%>
	<c:if test="${not empty command.donor.volunteer.id}">
		<div class="clearCenter volunteerDisplayFields">
			<fieldset>
				<legend> Volunteer </legend>
				<div class="leftHalf">
					<table>
						<tr>
							<td class='appFieldLabel' nowrap><span
								style="padding-left: 30px">Name:</span></td>
							<td><c:out value="${command.donor.displayName}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap>Email:</td>
							<td><c:out value="${command.donor.volunteer.email}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap>Phone:</td>
							<td><c:out value="${command.donor.volunteer.phone}" /></td>
						</tr>
					</table>
				</div>
				<div class="rightHalf">
					<table>
						<tr valign="top">
							<td class='appFieldLabel' nowrap>Address:</td>
							<td><span style="padding-right: 30px"><pre><c:out value="${command.donor.volunteer.addressMultilineDisplay}"/></pre></span></td>
						</tr>
					</table>
				</div>
				<c:if
					test="${not FORM_READ_ONLY and command.donationSummary.persistent}">
					<div class="clearCenter">
						<td rowspan="2" width="110px">&nbsp;</td> <a
							href="javascript:popupDonorSearch('changeDonor')"
							id="changeDonor" class="buttonAnchor">Change Donor</a>
					</div>
				</c:if>
			</fieldset>
		</div>
	</c:if>
	<%-- end volunteer --%>


	<div class="clearCenter donationInputFields">
		<fieldset>
			<legend>Donation</legend>

			<table width="100%">
				<tr>
					<td class='appFieldLabel' nowrap><lable
							for='donationDateInput'>Donation Date:<span
							class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td><app:input path="donationSummary.donationDate"
							id="donationDate" size="15" /> <app:errors
							path="donationSummary.donationDate" cssClass="msg-error" /></td>

					<td class='appFieldLabel' nowrap><lable
							for='donationDateInput'>Donation Type:<span
							class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td nowrap><app:select id="donationTypeSelect"
							path="donationSummary.vtkDonationType" itemLabel="donationType"
							itemValue="id">
							<form:option value="-1" label="-- Select --" />
							<form:options items="${allDonationTypes}"
								itemLabel="donationType" itemValue="id" />
						</app:select> <app:errors path="donationSummary.vtkDonationType"
							cssClass="msg-error" /></td>
				</tr>

				<tr class="checkDonationType" style="display: none">
					<td class='appFieldLabel' nowrap><lable for='checkNumInput'>Check
						Number:<span class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td><app:input path="donationSummary.checkNumber"
							id="checkNumber" size="15" maxlength="15" /> <app:errors
							path="donationSummary.checkNumber" cssClass="msg-error" /></td>

					<td class='appFieldLabel' nowrap>Check Date:</td>
					<td></td>
					<td><app:input path="donationSummary.checkDate" id="checkDate"
							size="15" /> <app:errors path="donationSummary.checkDate"
							cssClass="msg-error" /></td>
				</tr>



				<tr class="creditCardDonationType" style="display: none">
					<td class='appFieldLabel' nowrap><lable for='creditCardType'>Card
						Type: <span class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td nowrap><app:select id="cardTypeSelect"
							path="donationSummary.stdCreditCardType" itemLabel="name"
							itemValue="id">
							<form:option value="-1" label="-- Select --" />
							<form:options items="${allCreditCardTypes}" itemLabel="name"
								itemValue="id" />
						</app:select> <app:errors path="donationSummary.stdCreditCardType"
							cssClass="msg-error" /></td>

					<td class='appFieldLabel' nowrap><lable
							for='confirmationNumInput'>Confirmation Number:<span
							class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td><app:input path="donationSummary.creditCardTransactionId"
							id="confirmatiomNumber" size="20" maxlength="20" /> <app:errors
							path="donationSummary.creditCardTransactionId"
							cssClass="msg-error" /></td>
				</tr>

				<tr class="ePayDonationType" style="display: none">
					<td class='appFieldLabel' nowrap><lable
							for='epayTrackingIdInput'>E-Pay Tracking Number:<span
							class="invisibleRequiredFor508">*</span> </label></td>
					<td style="text-align: left"><span class='requdIndicator'>*</span></td>

					<td><app:input path="donationSummary.epayTrackingID"
							id="epayTrackingId" size="15" maxlength="15" /> <app:errors
							path="donationSummary.epayTrackingID" cssClass="msg-error" /></td>
				</tr>

			</table>

			<c:if test="${command.donationSummary.persistent}">
				<c:if test="${not FORM_READ_ONLY}">
					<div align="center" style="margin-top: 25px">
						<a class="buttonAnchor" id="createDonationButton"
							href="javascript:showDonationDetailsPopup()">Assign GPF</a>
					</div>
				</c:if>
				<div id="JQueryTable"
					style="max-width: 70%; margin: auto; margin-top: 10px; clear: both">

					<table class="formatTable" id="donationDetailsList" border="1"
						summary="List of Donations">
						<thead>
							<tr>
								<th>General Post Fund</th>
								<th>Donation Amount</th>
								<c:if test="${not FORM_READ_ONLY}">
									<th>Action</th>
								</c:if>
							</tr>
						</thead>
						<tfoot>
							<tr>
								<td align="right">Total:</td>
								<td align="right"></td>
								<c:if test="${not FORM_READ_ONLY}">
									<td></td>
								</c:if>
							</tr>
						</tfoot>
						<tbody>
						</tbody>

					</table>
				</div>
			</c:if>


			<c:if test="${not command.donationSummary.persistent}">
				<div class="hiddenGpfTableForItemAndActivity" id="normalTable"
					style="max-width: 70%; margin: auto; margin-top: 10px; clear: both; display: none">

					<table class="formatTable" id="donationDetailsForNewDonation"
						border="1" summary="List of Donations">
						<thead>
							<tr>
								<th>General Post Fund</th>
								<th>Donation Amount $</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><span class="invisibleRequiredFor508">*</span><span
									class="requdIndicator">*</span> <app:select id="gpf1"
										path="donationDetail1.donGenPostFund"
										itemLabel="generalPostFund" itemValue="id">
										<form:option value="-1" label="--Select--" />
										<form:options items="${allDonGenPostFunds}"
											itemLabel="generalPostFund" itemValue="id" />
									</app:select> <app:errors path="donationDetail1.donGenPostFund"
										cssClass="msg-error" /></td>
								<td align="left" nowrap><span
									class="invisibleRequiredFor508">*</span><span
									class="requdIndicator">*</span><app:input
										path="donationDetail1.donationValue" id="donationAmount1"
										class="currency" maxlength="13" />
							</tr>
							<tr>
								<td><span style="padding-left: 12px" /> <app:select
										id="gpf2" path="donationDetail2.donGenPostFund"
										itemLabel="generalPostFund" itemValue="id">
										<form:option value="-1" label="--Select--" />
										<form:options items="${allDonGenPostFunds}"
											itemLabel="generalPostFund" itemValue="id" />
									</app:select> <app:errors path="donationDetail2.donGenPostFund"
										cssClass="msg-error" /></td>
								<td><span style="padding-left: 8px" /><app:input
										path="donationDetail2.donationValue" id="donationAmount2"
										class="currency" maxlength="13" />
							</tr>
							<tr>
								<td><span style="padding-left: 12px" /> <app:select
										id="gpf3" path="donationDetail3.donGenPostFund"
										itemLabel="generalPostFund" itemValue="id">
										<form:option value="-1" label="--Select--" />
										<form:options items="${allDonGenPostFunds}"
											itemLabel="generalPostFund" itemValue="id" />
									</app:select> <app:errors path="donationDetail3.donGenPostFund"
										cssClass="msg-error" /></td>
								<td><span style="padding-left: 8px" /><app:input
										path="donationDetail3.donationValue" id="donationAmount3"
										class="currency" maxlength="13" />
							</tr>
						</tbody>

					</table>
				</div>
			</c:if>

			<c:if test="${not command.donationSummary.persistent}">
				<div class="gpfTableForItemAndActivity" id="normalTable2"
					style="max-width: 60%; margin: auto; margin-top: 10px; clear: both; display: none">

					<table class="formatTable" id="donationDetailsForNewDonation1"
						border="1" summary="List of Donations" >
						<thead>
							<tr>
								<th>Donation Amount $</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><span style="padding-left: 12px" /><app:input
										path="donationDetail4.donationValue" id="donationAmount4"
										class="currency" maxlength="13" />
							</tr>
						</tbody>

					</table>
				</div>
			</c:if>

			<div style="margin-top: 20px">
				<table width="100%">
					<tr>
						<td class="appFieldLabel fieldServiceReceipt"
							style="display: none">Field Service Receipt:</td>
						<td><app:input path="donationSummary.fieldServiceReceipt"
								id="fieldServiceReceiptId"
								class="fieldServiceReceipt donationInput" style="display: none"
								size="20" maxlength="12" /> <app:errors
								path="donationSummary.fieldServiceReceipt" cssClass="msg-error" /></td>
						<td class="noServiceReceipt" style="display: none">
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Acknowledgement Date:</td>
						<td><app:input path="donationSummary.acknowledgementDate"
								id="acknowledgementDate" size="20" /> <app:errors
								path="donationSummary.acknowledgementDate" cssClass="msg-error" /></td>
						<td class='appFieldLabel' nowrap>Reference:</td>
						<td><app:select items="${allDonationReferences}"
								id="donationReferenceSelect" path="donationSummary.donReference"
								itemLabel="donationReference" itemValue="id" /> <app:errors
								path="donationSummary.donReference" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel' nowrap>Letter Salutation:</td>
						<td><app:input path="donationSummary.salutation"
								id="acknowledgementDate" size="20" maxlength="50" /> <app:errors
								path="donationSummary.salutation" cssClass="msg-error" /></td>

						<td class='appFieldLabel' nowrap>Designation:</td>
						<td><app:input path="donationSummary.designation"
								id="designationId" size="20" maxlength="50" /> <app:errors
								path="donationSummary.designation" cssClass="msg-error" /></td>
					</tr>
				</table>
			</div>

			<div class="clearCenter" style="margin-top: 10px">
				<table>
					<tr>
						<td nowrap>Donation Description (used in acknowledgement)</td>
					</tr>
					<tr>
						<td><app:textarea path="donationSummary.donationDescription"
								id="donationDescription" rows="3" cols="80" maxlength="250" /></td>
					</tr>
					<tr>
						<td nowrap>Additional Information</td>
					</tr>
					<tr>
						<td><app:textarea path="donationSummary.additionalComments"
								id="comments" rows="3" cols="80" maxlength="250" /></td>
					</tr>
				</table>
			</div>
		</fieldset>
	</div>

	<div
		class="clearCenter donationInputFields hiddenFieldsForItemAndActivity"
		style="margin-top: 10px; display: none">
		<fieldset>
			<legend>In Memory Of</legend>
			<table>
				<tr>
					<td class='appFieldLabel'>In Memory Of:</td>
					<td><app:input path="donationSummary.inMemoryOf"
							id="salutationId" size="40" maxlength="50" /> <app:errors
							path="donationSummary.inMemoryOf" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td style="font-weight: bold">Family Contact</td>
					<td></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>Name:</td>
					<td><app:input path="donationSummary.familyContact"
							id="familyContactId" size="40" maxlength="50" /> <app:errors
							path="donationSummary.familyContact" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>Street:</td>
					<td><app:input path="donationSummary.familyContactAddress"
							id="familyContactAddressId" size="40" maxlength="35" /> <app:errors
							path="donationSummary.familyContactAddress" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>City:</td>
					<td><app:input path="donationSummary.familyContactCity"
							id="familyContactCityId" size="20" maxlength="30" /> <app:errors
							path="donationSummary.familyContactCity" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>State:</td>
					<td nowrap><app:select id="stateSelect"
							path="donationSummary.familyContactState" itemLabel="postalName"
							itemValue="id">
							<form:option value="-1" label="   " />
							<form:options items="${allStates}" itemLabel="postalName"
								itemValue="id" />
						</app:select> <app:errors path="donationSummary.familyContactState"
							cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'>Zip:</td>
					<td><app:input path="donationSummary.familyContactZip"
							id="familyContactZipId" size="10" maxlength="10" /> <app:errors
							path="donationSummary.familyContactZip" cssClass="msg-error" /></td>
				</tr>
			</table>
		</fieldset>

	</div>

	<div
		class="clearCenter donationInputFields hiddenFieldsForItemAndActivity"
		style="margin-top: 10px; display: none">
		<fieldset>
			<legend>CC Fields</legend>
			<table aligh="center">
				<tr>

					<td><app:input path="donationSummary.cc1"
							id="fieldServiceReceiptId1" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc1" cssClass="msg-error" /></td>
					<td><app:input path="donationSummary.cc2"
							id="fieldServiceReceiptId2" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc2" cssClass="msg-error" /></td>

					<td><app:input path="donationSummary.cc3"
							id="fieldServiceReceiptId3" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc3" cssClass="msg-error" /></td>

					<td><app:input path="donationSummary.cc4"
							id="fieldServiceReceiptId4" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc4" cssClass="msg-error" /></td>

					<td><app:input path="donationSummary.cc5"
							id="fieldServiceReceiptId5" size="16" maxlength="50" /> <app:errors
							path="donationSummary.cc5" cssClass="msg-error" /></td>
				</tr>
			</table>
		</fieldset>
	</div>
	<div class="clearCenter">
		<c:if test="${not FORM_READ_ONLY}">
			<a class="buttonAnchor" id="postPrintButton" tabIndex="0"
				disabled="true">Post & Print</a>
			<td rowspan="2" width="110px">&nbsp;</td>
			<a class="buttonAnchor" id="submitFormButton" href="#">Post</a>
			<td rowspan="2" width="110px">&nbsp;</td>
		</c:if>
		<a id="cancelOperationBtn" class="buttonAnchor"
			href="${home}/donorEdit.htm?id=${command.donor.id}">Cancel</a>
	</div>
</form:form>


<%@ include file="/WEB-INF/jsp/donation/donationDetail.jsp"%>


