<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<jsp:include page="/WEB-INF/jsp/shared/inc_volunteerSearchPopup.jsp">
	<jsp:param name="uniqueVolunteerSearchPopupId" value="linkToDonor" />
	<jsp:param name="resultCallbackMethod"
		value="linkVolunteerSelectedCallback" />
</jsp:include>

<jsp:include page="/WEB-INF/jsp/shared/inc_organizationSearchPopup.jsp">
	<jsp:param name="uniqueOrganizationSearchPopupId" value="linkToDonor" />
	<jsp:param name="resultCallbackMethod"
		value="linkOrganizationSelectedCallback" />
	<jsp:param name="includeInactiveOption" value="false" />
	<jsp:param name="mode" value="donorLink" />
</jsp:include>

<script type="text/javascript">
	$(function() {
		$("#submitButton").click(submitForm)
		$("input[name='donor.vtkDonorType']:radio").on('change', function() {	
			toggleDisplays($(this).val());
		}) 
		
		initializeFields();
	})
	
	function linkVolunteerSelectedCallback(volunteerObj) {
		
		$.ajax({
			url : ajaxHomePath + '/donor/donorLinkVolunteer',
			dataType : 'json',
			data : 
			{
				donorId: ${(not empty command.donor.id) ? command.donor.id : 'undefined'},
				volunteerId: volunteerObj.id
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				document.location.href = homePath + '/donorEdit.htm?id=' + response.id
			}
		})
	}
	
	function unlinkVolunteer() {	
		confirmDialog('Are you sure you want to remove the volunteer link from this donor?'	, function() {
			$("#desiredIndividualType").val('individual');
			toggleDisplays('1')
			$("#cancelFormButton").attr('href', 'donorEdit.htm?id=${command.donor.id}')
		})

	}
	
	function linkOrganizationSelectedCallback(orgObj) {
		$.ajax({
			url : ajaxHomePath + '/donor/donorLinkOrganization',
			dataType : 'json',
			data : {
				donorId : ${(not empty command.donor.id) ? command.donor.id : 'undefined'},
				orgId: orgObj.id
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				document.location.href = homePath + '/donorEdit.htm?id=' + response.id
			}
		})
	}
	
	function initializeFields() {
		<c:if test="${not command.donor.persistent}">	
			$("input[name='donor.vtkDonorType'][value=1"+ "]").prop("checked", true)
		</c:if>
			
		toggleDisplays(1);	
	}
	
	function toggleDisplays(selectdDonorTypeVal) {
		$('.individualInputFields').toggle(shouldShowIndividualSection(selectdDonorTypeVal))
		$('.volunteerDisplayFields').toggle(shouldShowVolunteerSection(selectdDonorTypeVal))
		$('.organizationDisplayFields').toggle(shouldShowOrgSection(selectdDonorTypeVal))		
		$('#submitButton').toggle(shouldShowIndividualSection(selectdDonorTypeVal))	
	}

	function shouldShowIndividualSection(selectdDonorTypeVal) {
		if (${not command.donor.persistent}) {
			// If creating new record, display individual data if donor type selected is individual
			return selectdDonorTypeVal == '1';
		} else {
			// If editing existing record, and the volunteer link had just been unlinked, display individual 
			if ($("#desiredIndividualType").val() == 'individual') {
				return true;
			} else {
				// otherwise if neither volunteer nor organization is linked, display individual
				return (${empty command.donor.volunteer.id && empty command.donor.organization.id});
			}
		}		
	}

	function shouldShowVolunteerSection(selectdDonorTypeVal) {
		if (${not command.donor.persistent}) {
			// If creating new record, display just individual data
			return false;
		} else {
			// If editing existing record, and the volunteer link had just been unlinked, display individual 
			if ($("#desiredIndividualType").val() == 'individual') {
				return false;
			} else {
				// otherwise if volunteer is linked, display volunteer
				return ${not empty command.donor.volunteer.id};
			}
		}		
	}

	
	function shouldShowOrgSection(selectdDonorTypeVal) {
		if (${not command.donor.persistent}) {
			return 	(selectdDonorTypeVal == '4')
		} else {
			return ${not empty command.donor.organization.id}
		}
	}

	function shouldShowSubmitButton(selectdDonorTypeVal) {
			if (${not command.donor.persistent}) {
				// If creating new record, display submbit button just for individual type
				return 	selectdDonorTypeVal == '1'	
			} else {
				// If editing existing record, and the volunteer link had just been unlinked, display submit button 
				if ($("#desiredIndividualType").val() == 'individual') {
					return true;
				} else {
					// otherwise if neither linked to volunteer nor organizationk, allow to submit
					return ${empty command.donor.volunteer.id && empty command.donor.organization.id}
				}
			}		
	}

	
	function deleteDonation(donationId, donorId) {
	
		confirmDialog('Are you sure you want to delete this donation?'	, function() {
			document.location.href = homePath + '/donationDelete.htm?donationSummaryId=' + donationId + 
					'&donorId=' + donorId
		})
	}
	
	function submitForm(evt) {
		if (evt != null) {
			doubleClickSafeguard($(evt.currentTarget));
		}

		if (!validate())
			return;

		$('#donorForm').submit();
	}

	function validate() {
		var errors = new Array();
		
		// if donor type is individual and donor is not of type volunteer then last name is required
		if ((${not command.donor.persistent} && $("input[name='donor.vtkDonorType']:checked").val() == '1') ||
			(${command.donor.persistent} && ${command.donor.vtkDonorType.id == '1'})) {

			if ($.trim($("#lastNameInput").val()) == '') {
				errors.push("Last Name is required.")
			}
			if ($.trim($("#firstNameInput").val()) == '') {
				errors.push("First Name is required.")
			}
		}

		<c:if test="${not command.donor.persistent}">	
			if ($("input[name='donor.vtkDonorType']:checked").length == 0) {
				errors.push("Donor Type is required.")
	
			}
		</c:if>

		if (errors.length > 0) {
			displayAttentionDialog("Please correct the following errors: <ul><li>" + errors.join("</li><li>")
					+ "</li></ul>");
		}

		return errors.length == 0;
	}
</script>

<style>
.ui-autocomplete-category {
	font-weight: bold;
	padding: .2em .4em;
	margin: .8em 0 .2em;
	line-height: 1.5;
}

div.donorInputFields, div.individualInputFields {
	min-width: 680px;
}

div.volunteerDisplayFields, div.organizationDisplayFields {
	min-width: 430px;
}
</style>

<form:form method="post" action="${home}/donorSubmit.htm" id="donorForm">
	<div class="clearCenter donorInputFields">
		<fieldset>
			<table>
				<tr>
					<td class='appFieldLabel'><label for='statusRadio'>Donor
							Type: <span class="invisibleRequiredFor508">*</span>
					</label></td>
					<c:if test="${not command.donor.persistent}">
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><form:radiobutton
								id="donorTypeRadioId1" path="donor.vtkDonorType" value="1" />Individual
							<form:radiobutton id="donorTypeRadioId2"
								path="donor.vtkDonorType" value="4" />Organization <app:errors
								path="donor.vtkDonorType" cssClass="msg-error" /></td>
					</c:if>

					<c:if test="${command.donor.persistent}">
						<td></td>
						<td style="text-align: left"><c:out
								value="${command.donor.vtkDonorType.donorType}" />
						<form:hidden path="desiredIndividualType" id="desiredIndividualType"/>
					</c:if>
				</tr>
			</table>
		</fieldset>
	</div>

	<div class="clearCenter individualInputFields">
		<div class="clearCenter centerContent">
			<c:if test="${not FORM_READ_ONLY}">
				<a id="linkVolunteerButton" class="buttonAnchor"
					href="javascript:popupVolunteerSearch('linkToDonor')">Link
					Volunteer</a>
			</c:if>
		</div>
		<p>
		<fieldset>
			<legend> Donor </legend>
			<table>
				<tr>
					<td class='appFieldLabel' nowrap><label for='lastNameInput'>Last
							Name: <span class="invisibleRequiredFor508">*</span>
					</label></td>
					<td style="padding: 4px; text-align: left" nowrap><span
						class='requdIndicator'>*</span></td>
					<td style="text-align: left" nowrap><app:input
							id="lastNameInput" path="donor.lastName" size="25" maxLength="30" />
						<app:errors path="donor.lastName" cssClass="msg-error" /></td>
					<td class='appFieldLabel' nowrap><label for='suffixInput'>Suffix:</label></td>
					<td></td>
					<td text-align: left" nowrap><app:input id="suffixInput"
							path="donor.suffix" size="6" maxLength="10" /> <app:errors
							path="donor.suffix" cssClass="msg-error" /></td>
				</tr>
				<tr>
					<td class='appFieldLabel'><label for='prefixInput'>Salutation:</label></td>
					<td></td>
					<td text-align: left" nowrap><app:input id="prefixInput"
							path="donor.prefix" size="6" maxLength="10" /> <app:errors
							path="donor.prefix" cssClass="msg-error" /></td>

					<td class='appFieldLabel' nowrap><label for='firstNameInput'>First
							Name: <span class="invisibleRequiredFor508">*
					</label></td>
					<td style="padding: 4px; text-align: left" nowrap><span
						class='requdIndicator'>*</span></td>
					<td text-align: left" nowrap><app:input id="firstNameInput"
							path="donor.firstName" size="20" maxLength="30" /> <app:errors
							path="donor.firstName" cssClass="msg-error" /></td>
					<td class='appFieldLabel' nowrap><label for='middleNameInput'>Middle
							Name/Initial:</label></td>
					<td style="text-align: left" nowrap><app:input
							id="middleNameInput" path="donor.middleName" size="10"
							maxLength="20" /> <app:errors path="donor.middleName"
							cssClass="msg-error" /></td>
				</tr>
			</table>

		</fieldset>
	</div>

	<div class="clearCenter individualInputFields">
		<fieldset>
			<legend> Mailing Address </legend>
			<div class="leftHalf">
				<table>
					<tr>
						<td class='appFieldLabel'><label for='address1Input'>Street
								Address 1:</label></td>
						<td></td>
						<td style="text-align: left"><app:input id="address1Input"
								path="donor.addressLine1" size="35" maxLength="35" /> <app:errors
								path="donor.addressLine1" cssClass="msg-error" /></td>
					</tr>
					<tr>
						<td class='appFieldLabel'><label for='address2Input'>Street
								Address 2:</label></td>
						<td></td>
						<td style="text-align: left"><app:input id="address2Input"
								path="donor.addressLine2" size="35" maxLength="35" /> <app:errors
								path="donor.addressLine2" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'><label for='cityInput'>City:</label></td>
						<td></td>
						<td style="text-align: left"><app:input id="cityInput"
								path="donor.city" size="30" maxLength="30" /> <app:errors
								path="donor.city" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'>State:</td>
						<td></td>
						<td nowrap><app:select id="stateSelect" path="donor.state"
								itemLabel="postalName" itemValue="id">
								<form:option value="-1" label="  " />
								<form:options items="${allStates}" itemLabel="postalName" itemValue="id" />
								</app:select>
								
								 <app:errors
								path="donor.state" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'><label for='zipInput'>Zip
								Code:</label></td>
						<td></td>
						<td style="text-align: left"><app:input id="zipInput"
								path="donor.zip" size="10" maxLength="10" /> <app:errors
								path="donor.zip" cssClass="msg-error" /></td>
					</tr>
				</table>
			</div>
			<div class="rightHalf">
				<table>
					<tr>
						<td class='appFieldLabel'>Email:</td>
						<td></td>
						<td><app:input path="donor.email" size="35" maxLength="250" />
							<app:errors path="donor.email" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'>Phone:</td>
						<td></td>
						<td><app:input cssClass="phoneextmask" path="donor.phone" />
							<app:errors path="donor.phone" cssClass="msg-error" /></td>
					</tr>
				</table>
			</div>
		</fieldset>
	</div>


	<%--- volunteer --%>
	<c:if test="${not empty command.donor.volunteer.id}">
		<div class="clearCenter volunteerDisplayFields">
			<fieldset>
				<legend> Volunteer </legend>
				<div class="leftHalf">
					<table>
						<tr>
							<td class='appFieldLabel' nowrap><span
								style="padding-left: 30px">Name:</span></td>
							<td><c:out value="${command.donor.displayName}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap>Email:</td>
							<td><c:out value="${command.donor.volunteer.email}" /></td>
						</tr>
						<tr>
							<td class='appFieldLabel' nowrap>Phone:</td>
							<td><c:out value="${command.donor.volunteer.phone}" /></td>
						</tr>
					</table>
				</div>
				<div class="rightHalf">
					<table>
						<tr valign="top">
							<td class='appFieldLabel' nowrap>Address:</td>
							<td><span style="padding-right: 30px"><pre><c:out value="${command.donor.volunteer.addressMultilineDisplay}"/></pre></span></td>
						</tr>
					</table>
				</div>
				<div class="clearCenter">
					<c:if test="${not FORM_READ_ONLY}">
						<td><a id="unlinkVolunteerButton" class="buttonAnchor"
							href="javascript:unlinkVolunteer()">Unlink Volunteer</a></td>
						<td><a id="editVolunteerButton" class="buttonAnchor"
							href="${home}/volunteerEdit.htm?id=${command.donor.volunteer.id}">Edit
								Volunteer</a></td>
					</c:if>
				</div>

			</fieldset>
		</div>
	</c:if>
	<%-- end volunteer --%>

	<%--- organization --%>
	<div class="clearCenter organizationDisplayFields">
		<fieldset>
			<legend> Organization </legend>
			<div class="clearCenter centerContent">
				<c:if test="${empty command.donor.organization.id}">
					<a id="linkOrganizationButton" class="buttonAnchor"
						href="javascript:popupOrganizationSearch('linkToDonor')">Link
						Organization</a>



				</c:if>
			</div>

			<c:if test="${not empty command.donor.organization.id}">
				<div class="clearCenter">
					<table width="100%">

						<tr>
							<td class='appFieldLabel' nowrap><span
								style="padding-left: 30px">Display Name:</span></td>
							<td><c:out value="${command.donor.displayName}" /></td>
						</tr>
					</table>
				</div>
				<div class="clearCenter">
					<table width="100%">

						<tr>
							<c:if test="${not FORM_READ_ONLY}">
								<td><a id="editOrganizationButton" class="buttonAnchor"
									href="${home}/organizationEdit.htm?id=${command.donor.organization.id}">Edit
										Organization</a></td>
							</c:if>
						</tr>
					</table>
				</div>
			</c:if>
		</fieldset>
	</div>

	<%-- end organization --%>



	<div class="clearCenter centerContent">
		<c:if test="${not FORM_READ_ONLY}">
			<a id="submitButton" class="buttonAnchor" href="#">Submit</a>
		</c:if>
		<a id="cancelFormButton" class="buttonAnchor keepEnabledForInactive"
			href="${most_recent_breadcrumb}">Cancel</a>
	</div>
</form:form>

<p>
	<c:if test="${command.donor.persistent}">
		<div class="clearCenter donorInputFields">
			<fieldset>
				<legend>Donations</legend>

				<div align="center">
					<c:if test="${not FORM_READ_ONLY}">
						<a class="buttonAnchor" id="createButton"
							href="${home}/donationCreate.htm?donorId=${command.donor.id}">Add
							Donation</a>
					</c:if>
				</div>
				<table id="donationsList" class="stripe" summary="List of Donations">
					<thead>
						<tr id="donationListFilterRow">
							<td class="noborder" title="Filter by Donation Date"></td>
							<td class="noborder" title="Filter by Donation Type"></td>
							<td class="noborder"></td>
							<td class="noborder" title="Filter by Acknowledgement Date"></td>
							<td class="noborder"></td>
							<c:if test="${command.donor.vtkDonorType.id == '1'}">
								<td class="noborder"></td>
							</c:if>
							<td class="noborder"></td>
						</tr>

						<tr>
							<th class="select-filter"
								selectFilterSortFunction="reverseCompareDates">Donation
								Date</th>
							<th class="select-filter">Donation Type</th>
							<th>Amount</th>
							<th class="select-filter">Acknowledgement Date</th>
							<th>Donation Description</th>
							<c:if test="${command.donor.vtkDonorType.id == '1'}">
								<th>On Behalf Of</th>
							</c:if>
							<c:if test="${not FORM_READ_ONLY}">
								<th>Action</th>
							</c:if>
						</tr>
					</thead>
					<tbody>
						<c:forEach items="${donationMap}" var="entry">
							<c:set var="donation" value="${entry.key}" />
							<c:set var="donationEditable" value="${entry.value}" />
							
							<tr id="dn${donation.id}">
								<td><a class="appLink"
									href="${home}/donationEdit.htm?id=${donation.id}"> <c:out
											value="${donation.donationDate}" />
								</a></td>
								<td><c:out value="${donation.vtkDonationType.donationType}" /></td>
								<td style="text-align: right"><c:set var="totalValue"
										value="0" /> <c:forEach items="${donation.donationDetails}"
										var="donationDetail">
										<c:set var="totalValue"
											value="${totalValue + donationDetail.donationValue}" />
									</c:forEach> <fmt:formatNumber type="currency" maxFractionDigits="2"
										value="${totalValue}" /></td>
								<td style="text-align: center"><c:out
										value="${donation.acknowledgementDate}" /></td>
								<td><c:out value="${donation.donationDescription}" /></td>
								<c:if test="${command.donor.vtkDonorType.id == '1'}">
									<td></td>
								</c:if>
								<c:if test="${not FORM_READ_ONLY and donationEditable}">
									<td><div style="margin: 0 auto; text-align: center">
											<a
												href="javascript:deleteDonation('${donation.id}', '${command.donor.id}')"
												title="Are you sure you want to delete this donation?">
												<img src="${imgHome}/permanently_delete_18x18.png"
												border="0" hspace="5" align="center" />
											</a>
										</div></td>
								</c:if>
							</tr>
						</c:forEach>
					</tbody>
				</table>
			</fieldset>
		</div>

		<jsp:include page="/WEB-INF/jsp/shared/inc_jqueryTable.jsp">
			<jsp:param name="dataTableId" value="donationsList" />
			<jsp:param name="defaultSort" value="[[0,'desc']]" />
		</jsp:include>

	</c:if>