
<%@ include file="../shared/inc_header.jsp"%>

<c:if test="${FORM_READ_ONLY}">
	<%@ include file="../shared/inc_modifyToView.jsp"%>
</c:if>

<c:set var="organizationNotBranch" value="${command.organization.scale == 'Organization'}" />

<c:if test="${organizationNotBranch}">
<script type="text/javascript">
$(function() {
	<c:if test="${command.organization.scope == 'NATIONAL'}">
	
		<c:if test="${command.organization.id != null}">
			refreshOfficialsTable();
		</c:if>
	
		if (${command.organization.onNationalAdvisoryCommittee == 'false'}) {
			setupNACFields("false");
		}
		
		$("input[name='organization.onNationalAdvisoryCommittee']:radio").on('change', function() {	
			setupNACFields($(this).val());
		}) 
	</c:if>
})

	var officialsList = new Object()
	
	function refreshOfficialsTable() {
	 	officialsList = new Object()
		
		$.ajax({
			url : ajaxHomePath + '/nationalOfficialList',
			dataType : 'json',
			data : {
				 orgId: '${command.organization.id}'
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				/* array of rows */
				
				var rArray = new Array()
				var curDate = new Date()
				for (var i = 0; i < response.length; i++) {
					officialsList[response[i].id] = response[i]
					
					/* array of columns for current row */
					rArray[rArray.length] = new Array(									
							'<a href="javascript:showOfficialDetailsPopup(' + response[i].id + ', ${command.organization.id}' + ')">'+ 
							escapeHTML(response[i].stdVAVSTitle ? response[i].stdVAVSTitle.name : 'None') +'</a>',
										escapeHTML(response[i].prefix),
						escapeHTML(response[i].lastName), 
						escapeHTML(response[i].firstName), 
						escapeHTML(response[i].middleName), 
						escapeHTML(response[i].certifyingOfficial ? 'Yes' : 'No'), 
						'<div style="margin:0 auto; text-align:center"><a class="confirm" alt="Delete Entry" title="Are you sure you want to delete this official?" href="javascript:deleteOfficial(' + response[i].id + ')"><img src="'+ imgHome + '/permanently_delete_18x18.png" border="0" hspace="5" aligh="center"/></a></div>')
				}

				/* generated by inc_jqueryTable.jsp, see below */
				officialsRefreshData(rArray)
			}
		})
	}
	
	function deleteOfficial(officialId) {
		var fullObj = officialsList[officialId]
	
		confirmDialog('Are you sure you want to delete this National Official ' + fullObj.lastName + ', ' + fullObj.firstName + '?',
		function() {
			$.ajax({
				url : ajaxHomePath + '/nationalOfficialDelete',
				dataType : 'json',
				data : {
					officialId: officialId
				 },
				
				error : commonAjaxErrorHandler,
				success : function() {
					/* generated by inc_jqueryTable.jsp, see below */
					refreshOfficialsTable()
			    }
			})
		})
	}  

	function setupNACFields(isNACVal) {
		if (isNACVal == "true") {
			$("#nacExecutiveMemberRadioButtonId1").prop("disabled", false);
			$("#nacExecutiveMemberRadioButtonId2").prop("disabled", false);
			$("#nacStatusSelect").val("-1");
			$("#nacStatusSelect").prop("disabled", false);
			$("#ajrMonthSelect").prop("disabled", false);
		} else {
			$("#nacExecutiveMemberRadioButtonId2").prop('checked', true);
			$("#nacExecutiveMemberRadioButtonId1").prop("disabled", true);
			$("#nacExecutiveMemberRadioButtonId2").prop("disabled", true);
			$("#nacStatusSelect").val("12");
			$("#nacStatusSelect").prop("disabled", true);
			$("#ajrMonthSelect").prop("disabled", true);
		}
	
	}
</script>
</c:if>

<script type="text/javascript">
	var wasFullNamePopulated = ("${command.organization.fullName}".length > 0);

	$(function() {
		$("#submitButton").click(submitForm);
		
		$("#displayNameInput").change(function() {
			if (!wasFullNamePopulated) {
				$("#fullNameInput").val($("#displayNameInput").val());
			}
		})

		$("#displayNameInput").autocomplete({
			source : function(request, response) {
				var theVal = $.trim($("#displayNameInput").val())
				if (theVal == '') return
				
				var ajaxParms = []
				ajaxParms.push({name: 'wt', value: 'json'})
				ajaxParms.push({name: 'omitHeader', value: 'true'})
				ajaxParms.push({name: 'fl', value: 'name'})
				ajaxParms.push({name: 'fl', value: 'scope'})
				ajaxParms.push({name: 'fl', value: 'id'})
				ajaxParms.push({name: 'q', value: 'name:' + theVal.match(/\S+/g).join(' name:')})
				
				$.ajax({
					url : "${solrBaseURL}/organizations/select/",
					data : $.param(ajaxParms),
					dataType : 'jsonp',
					jsonp : 'json.wrf',
					success : function(data) {
						var docs = JSON.stringify(data.response.docs)
						var jsonData = JSON.parse(docs)
						response($.map(jsonData, function(value, key) {
							return {
								label : value.name,
								// replace this with value.id if needed
								value : value.name
								// , category : value.scope == 'L' ? 'Local' : 'National',
							}
						}))
					},
					error: function() {
						console.log("Couldn't communicate with SOLR.")
					}
				})
			},
			minLength : 1
		})

		<c:if test="${command.organization.id != null && command.organization.inactive == 'true' }">
			// When editing an inactive org, the record is readonly except for the Status field
			$('.organizationInputFields input', '#appContainerDiv').not(".keepEnabledForInactive").attr(
				'disabled', 'disabled')
			$('.nacInputFields input', '#appContainerDiv').attr(
				'disabled', 'disabled')
			$('#organizationForm select', '#appContainerDiv').each(
					function() {
						var selectedVal = $(this).find("option:selected").val();
						if (selectedVal == "-1" || selectedVal == "") {
							$(this).replaceWith("None")
						} else {
							$(this).replaceWith(
									escapeHTML($(this).find("option:selected")
											.text()))
						}
					})
			$('.requdIndicator', '#appContainerDiv').remove()
		</c:if>
		
		
		<c:if test="${command.organization.scope == 'LOCAL'}">
			$("#nacRadioButtonId1").attr("disabled", "disabled");
			$("#nacRadioButtonId2").attr("disabled", "disabled");
			$("#nacExecutiveMemberRadioButtonId1").attr("disabled", "disabled");
			$("#nacExecutiveMemberRadioButtonId2").attr("disabled", "disabled");
			$("#nacStatusSelect").attr("disabled", "disabled");
			$("#ajrMonthSelect").attr("disabled", "disabled");
		</c:if>
	})

	function submitForm(evt) {
		if (evt != null) {
			doubleClickSafeguard($(evt.currentTarget));
		}
		
	    if (!validate()) return;
	    
	    $('#organizationForm').submit();
	}
	
	function validate() {
	    var errors = new Array();
	 
	   	if ($.trim($("#displayNameInput").val()) == '') {
			errors.push("Display Name is required.")
		}
	       
	   	if ($.trim($("#fullNameInput").val()) == '') {
			errors.push("Full Name is required.")
		}

	   	if ($.trim($("#typeSelect").val()) == '-1') {
			errors.push("Type is required.")
		}
	   	
	   	<c:if test="${organizationNotBranch}">
	   	if ($("input[name='organization.onNationalAdvisoryCommittee']:checked").val() == "true") {
		  if ($('#nacStatusSelect').val() == "-1") {
		   errors.push("Membership Status is required for NAC Members.");
		  }
		}
		</c:if>
		
		if (errors.length > 0) {
		   displayAttentionDialog("Please correct the following errors: <ul><li>"
		                 + errors.join("</li><li>") + "</li></ul>");                   
		}
		
		return errors.length == 0;
	}
</script>

<style>
.ui-autocomplete-category {
	font-weight: bold;
	padding: .2em .4em;
	margin: .8em 0 .2em;
	line-height: 1.5;
}
</style>

<form:form method="post" action="${home}/organizationSubmit.htm"
	id="organizationForm">
	<div class="clearCenter">
		<div class="organizationInputFields">
			<fieldset>
				<legend>Organization</legend>
				<table>
					<tr>
						<td class='appFieldLabel' nowrap>Scope:</td>
						<td></td>
						<td style="text-align: left"><c:out
								value="${command.organization.scope}" /> <c:if
								test="${command.organization.scope == 'LOCAL'}">
								-- <c:out
									value="${command.organization.facility.displayName}" />
							</c:if></td>
					</tr>
					<c:if test="${organizationNotBranch}">
					<tr>
						<td class='appFieldLabel' nowrap>Code:</td>
						<td></td>
						<td style="text-align: left"><c:if
								test="${command.organization.code != 0}">
								<fmt:formatNumber pattern="00000"
									value="${command.organization.code}" />
							</c:if>
					</tr>
					</c:if>
					
					<tr>
						<td class='appFieldLabel' nowrap><label
							for='displayNameInput'>Display Name: <span
								class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><app:input id="displayNameInput"
								path="organization.name" size="35" maxLength="35" /> <app:errors
								path="organization.name" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'><label for='fullNameInput'>Full
								Name: <span class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><app:input id="fullNameInput"
								path="organization.fullName" size="45" /> <app:errors
								path="organization.fullName" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'><label for='abbreviationInput'>Abbreviation:</label></td>
						<td></td>
						<td style="text-align: left"><app:input
								id="abbreviationInput" path="organization.abbreviation" size="6"
								maxLength="6" /> <app:errors path="organization.abbreviation"
								cssClass="msg-error" /></td>
					</tr>
					<c:if test="${organizationNotBranch}">
					<tr>
						<td class='appFieldLabel'><label for='typeSelect'>Type:
								<span class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><app:select id="typeSelect"
								path="organization.type" itemLabel="name" itemValue="id">
								<form:option value="-1" label="-- Select --" />
								<form:options items="${allTypes}" itemValue="id"
									itemLabel="name" />
							</app:select> <app:errors path="organization.type" cssClass="msg-error" /></td>
					</tr>
					</c:if>
					
					<tr>
						<td class='appFieldLabel'><label for='statusRadio'>Status:
								<span class="invisibleRequiredFor508">*</span>
						</label></td>
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><form:radiobutton
								id="statusRadioId1" cssClass="keepEnabledForInactive"
								path="organization.inactive" value="false" />Active <form:radiobutton
								id="statusRadioId2" cssClass="keepEnabledForInactive"
								path="organization.inactive" value="true" />Inactive <app:errors
								path="organization.inactive" cssClass="msg-error" /></td>
					</tr>

				</table>
			</fieldset>
		</div>
		
		<c:if test="${organizationNotBranch}">
		<div class="nacInputFields">
			<fieldset>
				<legend> National Advisory Committee </legend>
				<table>
					<tr>
						<td class='appFieldLabel' nowrap>Member? <span
							class="invisibleRequiredFor508">*</span>
						</td>
						<td style="padding: 4px; text-align: left"><span
							class='requdIndicator'>*</span></td>
						<td style="text-align: left"><form:radiobutton
								id="nacRadioButtonId1"
								path="organization.onNationalAdvisoryCommittee" value="true" />Yes
							<form:radiobutton id="nacRadioButtonId2"
								path="organization.onNationalAdvisoryCommittee" value="false" />No
							<app:errors path="organization.onNationalAdvisoryCommittee"
								cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel' nowrap>Executive Member?</td>
						<td></td>
						<td style="text-align: left"><form:radiobutton
								id="nacExecutiveMemberRadioButtonId1"
								path="organization.nacExecutiveMember" value="true" />Yes <form:radiobutton
								id="nacExecutiveMemberRadioButtonId2"
								path="organization.nacExecutiveMember" value="false" />No <app:errors
								path="organization.nacExecutiveMember" cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'>Membership Status:</td>
						<td></td>
						<td style="text-align: left"><app:select id="nacStatusSelect"
								path="organization.nacMembershipStatus">
								<form:option value="-1" label="-- Select --" />
								<form:options items="${allNacStatuses}" itemValue="id"
									itemLabel="membershipStatus" />
							</app:select> <app:errors path="organization.nacMembershipStatus"
								cssClass="msg-error" /></td>
					</tr>

					<tr>
						<td class='appFieldLabel'>Annual Joint Review (AJR) Month:</td>
						<td></td>
						<td style="text-align: left"><app:select id="ajrMonthSelect"
								path="organization.annualJointReviewMonth">
								<form:option value="" label="-- Select --" />
								<form:options items="${allMonths}" itemValue="value" />
							</app:select> <app:errors path="organization.annualJointReviewMonth"
								cssClass="msg-error" /></td>
					</tr>
				</table>
			</fieldset>
		</div>
		</c:if>
		
		<div align="center">
			<c:if test="${not FORM_READ_ONLY}">
				<a id="submitButton" class="buttonAnchor keepEnabledForInactive"
					href="#">Submit</a>
			</c:if>
			<a id="cancelFormButton" class="buttonAnchor keepEnabledForInactive"
				href="${most_recent_breadcrumb}">Cancel</a>
		</div>
	</div>
</form:form>

<c:if
	test="${organizationNotBranch && command.organization.scope == 'NATIONAL' && command.organization.id != null}">
	<div class="clearCenter">
		<div class="nationalOfficialInputFields">
			<fieldset>
				<legend>National Officials</legend>

				<div align="center">
					<c:if test="${not FORM_READ_ONLY}">
						<a class="buttonAnchor" id="createButton"
							href="javascript:showOfficialDetailsPopup('',  ${command.organization.id} )">Add</a>
					</c:if>
				</div>
				<table id="officialsList" class="stripe"
					summary="List of National Officials">
					<thead>
						<tr>
							<th width="30%">VAVS Title</th>
							<th width="12%">Salutation</th>
							<th width="12%">Last Name</th>
							<th width="12%">First Name</th>
							<th width="12%">Middle Name</th>
							<th width="12%">National Certifying Official</th>
							<c:if test="${not FORM_READ_ONLY}">
								<th width="10%">Action</th>
							</c:if>
						</tr>
					</thead>
					<tbody>
					</tbody>
				</table>
			</fieldset>
		</div>

		
			<jsp:include page="/WEB-INF/jsp/shared/inc_jqueryTable.jsp">
				<jsp:param name="dataTableId" value="officialsList" />
				<jsp:param name="refreshDataMethod" value="officialsRefreshData" />
			</jsp:include>
		
		<%@ include
			file="/WEB-INF/jsp/organization/nationalOfficialDetail.jsp"%>
	</div>
</c:if>