<%@ include file="../shared/inc_header.jsp"%>

<%--
	Expects the following params:
	
	- A "uniqueId" param which should be a string of letters that
		uniquely identifies this facilityAssignmentSelectPopup among other facilityAssignmentSelectPopups on the same page
	- A "callbackMethod" param which specifies the name of a JavaScript method defined by the
		-including- page which this popup will activate when the user selects a facility assignment. The
		required method signature looks like:
		function someMethodWithUniqueName(facilityAssignmentObj)
		
		The facilityAssignmentObj parameter sent to the callback method is a javascript object containing the
		properties
		{
			id : <the ID of the facility assignment selected>,
			[... other attributes of the FacilityAssignment class marked for JsonProperty]
		}
		
	To activate this popup, call the method popupFacilityAssignmentSelect(uid) and pass in the same
	uniqueId String above.
--%>

<c:set var="uid">
	<c:out value="${param.uniqueId}" />
</c:set>

<script type="text/javascript">
	$(function() {
		initFacilityAssignmentSelectPopup({
			uid : "${uid}",
			callbackMethod : <c:out value="${param.resultCallbackMethod}" default="null" />,
			volunteerEditPermission: "<c:out value="${PERMISSION_TYPE_VOLUNTEER_CREATE}" />"
		})
	})
</script>

<div id="facilityAssignmentSelectDialog${uid}"
	title="Select Facility Assignment">
	<table>
		<tr>
			<td class='appFieldLabel'>Facility:<span
				class="invisibleRequiredFor508">*</span></td>
			<td><span class='requdIndicator'>*</span></td>
			<td><div id="assignmentFacilityWrapper">
					<select id="assignmentFacilityId">
						<c:if test="${not empty facilityContext}">
							<option value="${facilityContext.id}" selected="selected"><c:out
									value="${facilityContext.displayName}" /></option>
						</c:if>
					</select>
				</div></td>
		</tr>
	</table>
	
	<div id="facilityAssignmentSelectTable${uid}">

		<table id="facilityAssignmentSelectList${uid}" class="stripe"
			summary="List of Facility Assignments">
			<thead>
				<tr id="facilityAssignmentSelect${uid}FilterRow">
					<td width="30%" class="noborder"></td>
					<td width="35%" class="noborder"></td>
					<td width="35%" class="noborder"></td>
				</tr>
				<tr>
					<th width="30%" id="facilityHeaderCol${uid}" class="select-filter">Location</th>
					<th width="35%">Benefiting Service</th>
					<th width="35%">Role</th>
				</tr>
			</thead>
		</table>
	</div>
</div>
