var confirmationDialogInitialized = false
var confirmationDialogCallback = null

function initializeConfirmationDialog() {
	if (confirmationDialogInitialized)
		return
	
	$("#confirmationDialog").dialog({
		autoOpen: false,
		modal: true,
		show: 'slide',
		draggable: true,
		resizable:true,
		width: 550,
		buttons: {
			OK : function() {
				$(this).dialog('close')
				confirmationDialogCallback()
			},
			Cancel: function() {
				$(this).dialog('close')
				if (confirmationDialogCancelCallback)
					confirmationDialogCancelCallback()
			}
		}
	})
	
	confirmationDialogInitialized = true
}

/**
 *  Displays Confirmation Dialog 
 */
function confirmDialog(messageToDisplay, acceptanceCallback, cancelCallback, title) {
	initializeConfirmationDialog()
	confirmationDialogCallback = acceptanceCallback
	confirmationDialogCancelCallback = cancelCallback
	
	$("#confirmationDialogMessage").empty().html(messageToDisplay)
	
	$('#confirmationDialog').dialog('option', 'title', title ? escapeHTML(title) : 'Confirmation')
	$("#confirmationDialog").dialog("open")
}