function popupDonorSearch(uid, donorListToShow) {
	$("#donorSearchNoResults" + uid).hide()
	$("#donorSearchResultsTable" + uid).hide()
	$('#donorSearchName' + uid).focus()
	$("#donorSearchDialog" + uid).dialog('open')
	
	if (donorListToShow) {
		processDonorSearchResults(uid, donorListToShow)
	}
}

function donorSearchPopupItemSelected(uid, donorId) {
	var donorObj = donorSearchResults[uid]['' + donorId]
	var theDialog = $("#donorSearchDialog" + uid)
	theDialog.dialog('close')
	theDialog.data('callbackMethod')(donorObj)
}

function initDonorSearchPopup(options) {
	var mode = options.mode
	var uid = options.uid
	var maxResults = options.maxResults
	var callbackMethod = options.callbackMethod
	var addButtonCallbackMethod = options.addButtonCallbackMethod
	var showDisclaimer = options.showDisclaimer
	
	if (mode != 'add' && mode != 'search' && mode != 'duplicateCheck') {
		alert('Invalid mode for donor search popup with id "' + uid + '": ' + mode)
		return
	}
	
	var parms = {
		"columnDefs" : [
				{
					"targets" : 0,
					"data" : function(row, type, val, meta) {
						var donorNameEscaped = escapeHTML(row.displayName)
						if (type === 'display') {
							return '<a class="appLink" href="javascript:donorSearchPopupItemSelected(\''
									+ uid + '\', ' + row.id + ')">'
									+ donorNameEscaped /*+ '</a><br><i>Code:</i> ' + escapeHTML(row.identifyingCode) __JC_TODO__*/
						} else {
							return donorNameEscaped
						}
					}
				},
				{
					"targets" : 1,
					"data" : function(row, type, val, meta) {
						var contactInfoHtml = getDonorDashedBoxEl(row).outerHtml()
						return contactInfoHtml
					}
				} ],
		"dom" : '<"top"fi>rt<"bottom"pl><"clear">',
		"pagingType" : "full_numbers",
		"pageLength" : 10,
		"lengthMenu" : [ [ 10, -1 ], [ 10, "All" ] ],
		"stateSave" : false
	}

	var theDataTable = $('#donorSearchResultsList' + uid).DataTable(parms)

	var dialogEl = $("#donorSearchDialog" + uid)
	
	var buttonConfig = {}
	if (mode == 'duplicateCheck') {
		buttonConfig['Create Anyway'] = function() {
			$(this).dialog('close')
			addButtonCallbackMethod()
		}
	}
	buttonConfig['Cancel'] = function() { $(this).dialog('close') }
	
	dialogEl.dialog({
		autoOpen : false,
		modal : false,
		width : 600,
		height : 500,
		closeOnEscape : true,
		draggable : true,
		resizable : true,
		buttons : buttonConfig
	})
	//dialogEl.data('stationsPopulated', false)
	dialogEl.data('mode', mode)
	dialogEl.data('maxResults', maxResults)
	dialogEl.data('callbackMethod', callbackMethod)
	
	if (mode == 'add' || mode == 'search') {
		$("#donorSearchName" + uid).keypress(function(event) {
			if (event.which == 13) {
				submitDonorSearchForm(uid)
			}
		})
	
		$(".donorSearchLink" + uid).click(function(evt) {
			submitDonorSearchForm(uid)
		})
		
	/*	$('#donorSearchScopeLocal' + uid).click(function() {
			$("#donorSearchFacilityWrapper" + uid).show()
		})
		$('#donorSearchScopeNational' + uid).click(function() {
			$("#donorSearchFacilityWrapper" + uid).hide()
		})
		
		$("#donorSearchDOB" + uid).enableDatePicker({
			showOn : "button",
			buttonImage : imgHome + "/calendar.gif",
			buttonImageOnly : true
		})
		$("#donorSearchDOB" + uid).mask(twoDigitDateMask, {
			autoclear : false
		})
		
		var facilityEl = $("#donorSearchScopeFacilitySta3n" + uid)
		facilityEl.multiselect({
			selectedText : function(numChecked, numTotal, checkedItems) {
				return abbreviate($(checkedItems[0]).next().text())
			},
			beforeopen: function(){
				if (dialogEl.data('stationsPopulated')) return
				var curVal = facilityEl.val()
				
				$.ajax({
					url : ajaxHomePath + "/getDonorSearchStations",
					type : "POST",
					dataType : 'json',
					error : commonAjaxErrorHandler,
					success : function(results) {
						facilityEl.empty()
						var newHtml = []
						$.each(results, function(index, item) {
							var selectedText = (item.sta3n == curVal) ? ' selected="selected"' : ''
							newHtml.push('<option value="' + item.sta3n + '"' + selectedText + '>' + item.displayName + '</option>')
						})
						facilityEl.html(newHtml.join())
						
						facilityEl.multiselect("refresh")
						facilityEl.val(curVal)
						dialogEl.data('stationsPopulated', true)
						
						facilityEl.multiselect("open")
					}
				})
				
				return false
		   },
			multiple : false,
			minWidth : 400
		}).multiselectfilter()*/
	}
	
	if (mode == 'add') {  // __JC_TODO__
		//$('#donorSearchScopeNational' + uid).click()
		//$('input[type=radio][name="donorSearchScope' + uid + '"]').prop('disabled', true)
		//$("#donorSearchIncludeInactive" + uid).prop('checked', true)
		//$("#donorSearchIncludeInactive" + uid).prop('disabled', true)
		$(".donorAddLink" + uid).click(addButtonCallbackMethod)
	}
	
	if (mode == 'duplicateCheck')
		$(".donorSearchFields" + uid).hide()
		
	if (showDisclaimer)
		$('#donorSearchDisclaimer' + uid).show()
		
	dialogEl.show()
}

var donorSearchResults = new Object()

function submitDonorSearchForm(uid) { 
	if (allValsEmpty(["donorSearchName" + uid,
	                  "donorSearchCity" + uid,
	                  "donorSearchState" + uid,
	                  "donorSearchZip" + uid,
	                  "donorSearchEmail" + uid,
	                  "donorSearchPhone" + uid])) {
		displayAttentionDialog('Please enter at least one piece of search criteria.')
		return
	}
	
	$('#donorSearchDisclaimer' + uid).hide()
	var dialogEl = $("#donorSearchDialog" + uid)
	var theType = $(
			"input[type='radio'][name='donorSearchType" + uid
					+ "']:checked").val()

	$.ajax({
		url : ajaxHomePath + "/findDonors",
		type : "POST",
		dataType : 'json',
		data : {
			donorType : theType,
			name : $("#donorSearchName" + uid).val(),
			city : $("#donorSearchCity" + uid).val(),  
			state : $("#donorSearchState" + uid).val(),  
			zip : $("#donorSearchZip" + uid).val(),
			email : $("#donorSearchEmail" + uid).val(),
			phone : $("#donorSearchPhone" + uid).val()
		},
		error : commonAjaxErrorHandler,
		success : function(results) {
			processDonorSearchResults(uid, results)
		}
	})
}

function processDonorSearchResults(uid, results) {
	var dialogEl = $("#donorSearchDialog" + uid)
	
	$("#donorSearchNoResults" + uid).hide()
	$("#donorSearchResultsTable" + uid).hide()

	var resultMap = new Object()

	var table = $('#donorSearchResultsList' + uid).DataTable()
	table.clear()

	for (var i = 0; i < results.length; i++) {
		resultMap['' + results[i].id] = results[i]
		table.row.add(results[i])
	}

	donorSearchResults[uid] = resultMap

	$("#donorSearchMaxResults" + uid).toggle(results.length == dialogEl.data('maxResults'))
	
	if (results.length > 0) {
		$("#donorSearchResultsTable" + uid).show()
		rebuildTableFilters('donorSearchResultsList' + uid)

		/* Reset all filters every time they do a search */
		table.columns('.select-filter').every(function() {
			this.search('', true, false)
		})
	} else {
		$("#donorSearchNoResults" + uid).show()
	}
	table.draw()

	var mode = dialogEl.data('mode')
	if (mode == 'add') {
		$(".donorAddLink" + uid).show()
	}
	
	$('#donorSearchName' + uid).focus()
}


function getDonorDashedBoxEl(donor) {
	var theHtml = '<table width="100%" class="addressBox">'
	theHtml += '<tr valign="top"><td nowrap width="99%">'

	var phoneHtml = "";
	if (donor.phone)
		phoneHtml = escapeHTML(donor.phone) + '<br>'
	var emailHtml = ""
	if (donor.email)
		emailHtml = escapeHTML(donor.email) + '<a href="mailto:'
				+ escapeHTML(donor.email)
				+ '"><img alt="Click to email '
				+ escapeHTML(donor.email) + '"' + 'src="' + imgHome
				+ '/envelope.jpg" height="14"'
				+ ' width="18" border="0" align="absmiddle"'
				+ ' style="padding-left: 4px; padding-right: 4px" /></a>'
	var addressHtml = ""
	if (donor.addressMultilineDisplay)
		addressHtml = escapeHTML(donor.addressMultilineDisplay)

	theHtml += phoneHtml + emailHtml + '</td>' + '<td width="10">&nbsp;</td>'
			+ '<td width="1%" nowrap>' + convertLinefeedToBR(addressHtml)
			+ '</td></tr></table>'
	return getBoxEl(theHtml, false)
}