function popupFacilityAssignmentSelect(uid) {
	$("#facilityAssignmentSelectDialog" + uid).dialog('open')
	
	refreshFacilityAssignmentsTable(uid)
}

function refreshFacilityAssignmentsTable(uid) {
	$.ajax({
		url : ajaxHomePath + "/findFacilityAssignments",
		type : "POST",
		dataType : 'json',
		data : {
			facilityId : $("#assignmentFacilityId").val()
		},
		error : commonAjaxErrorHandler,
		success : function(results) {
			processFacilityAssignmentSelectResults(uid, results)
		}
	})
}

function facilityAssignmentSelectPopupItemSelected(uid, facilityAssignmentId) {
	var facilityAssignmentObj = facilityAssignmentSelectResults[uid]['' + facilityAssignmentId]
	var theDialog = $("#facilityAssignmentSelectDialog" + uid)
	theDialog.dialog('close')
	theDialog.data('callbackMethod')(facilityAssignmentObj)
}

function initFacilityAssignmentSelectPopup(options) {
	var uid = options.uid
	var callbackMethod = options.callbackMethod
	var volEditPermission = options.volunteerEditPermission
	
	var parms = {
		"columnDefs" : [
				{
					"targets" : 0,
					"data" : function(row, type, val, meta) {
						return row.location
					}
				},{
					"targets" : 1,
					"data" : function(row, type, val, meta) {
						var displayNameEscaped = escapeHTML(row.benefitingService ? row.benefitingService.displayName : '')
						if (type === 'display') {
							return '<a class="appLink" href="javascript:facilityAssignmentSelectPopupItemSelected(\''
									+ uid + '\', ' + row.id + ')">'
									+ displayNameEscaped + '</a>'
						} else {
							return displayNameEscaped
						}
					}
				},{
					"targets" : 2,
					"data" : function(row, type, val, meta) {
						return escapeHTML(row.benefitingServiceRole ? row.benefitingServiceRole.displayName : '')
					}
				}],
		"dom" : '<"top"fi>rt<"bottom"pl><"clear">',
		"pagingType" : "full_numbers",
		"pageLength" : 10,
		"lengthMenu" : [ [ 10, -1 ], [ 10, "All" ] ],
		"stateSave" : false
	}

	var theDataTable = $('#facilityAssignmentSelectList' + uid).DataTable(parms)
	var dialogEl = $("#facilityAssignmentSelectDialog" + uid)
	
	var facilityEl = $("#assignmentFacilityId")
	facilityEl.change(function() {
		refreshFacilityAssignmentsTable(uid)
	})
	facilityEl.multiselect({
		selectedText : function(numChecked, numTotal, checkedItems) {
			return abbreviate($(checkedItems[0]).next().text())
		},
		beforeopen: function(){
			if (dialogEl.data('stationsPopulated')) return
			var curVal = facilityEl.val()
			
			$.ajax({
				url : ajaxHomePath + "/getFacilitiesWithUserPermission",
				type : "POST",
				data : {
					permission : volEditPermission
				},
				dataType : 'json',
				error : commonAjaxErrorHandler,
				success : function(results) {
					facilityEl.empty()
					var newHtml = []
					$.each(results, function(index, item) {
						if (item.id == centralOfficeId) return
						
						var selectedText = (item.sta3n == curVal) ? ' selected="selected"' : ''
						newHtml.push('<option value="' + item.id + '"' + selectedText + '>' + item.displayName + '</option>')
					})
					facilityEl.html(newHtml.join())
					
					facilityEl.multiselect("refresh")
					facilityEl.val(curVal)
					dialogEl.data('stationsPopulated', true)
					
					facilityEl.multiselect("open")
				}
			})
			
			return false
	   },
		multiple : false,
		minWidth : 400
	}).multiselectfilter()
	
	dialogEl.dialog({
		autoOpen : false,
		modal : false,
		width : 800,
		height : 600,
		closeOnEscape : true,
		draggable : true,
		resizable : true,
		buttons : {
			'Cancel' :  function() { $(this).dialog('close') }
		}
	})
	dialogEl.data('callbackMethod', callbackMethod)
	dialogEl.show()
}

var facilityAssignmentSelectResults = new Object()

function processFacilityAssignmentSelectResults(uid, results) {
	var dialogEl = $("#facilityAssignmentSelectDialog" + uid)
	
	var resultMap = new Object()

	var table = $('#facilityAssignmentSelectList' + uid).DataTable()
	table.clear()

	for (var i = 0; i < results.length; i++) {
		resultMap['' + results[i].id] = results[i]
		table.row.add(results[i])
	}

	facilityAssignmentSelectResults[uid] = resultMap

	rebuildTableFilters('facilityAssignmentSelectList' + uid)

	/* Reset all filters every time they do a search */
	table.columns('.select-filter').every(function() {
		this.search('', true, false)
	})
	table.draw()
}