package gov.va.vss.persistence;

import org.springframework.beans.factory.annotation.Autowired;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.Donor;
import gov.va.vss.model.lookup.VtkDonorType.VtkDonorTypeValue;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.dao.DonorDAO;
import gov.va.vss.persistence.dao.lookup.VtkDonorTypeDAO;

public class TestDonorDAO extends AbstractTransactionalWebDAOTest<Donor> {

	@Autowired
	private DonorDAO donorDAO;
	@Autowired
	protected VtkDonorTypeDAO vtkDonorTypeDAO;

	@Override
	protected CustomizableAppDAO<Donor> getDAO() {
		return donorDAO;
	}

	@Override
	protected Donor getInstanceToSave() {
		Donor d = new Donor();
		d.setVtkDonorType(vtkDonorTypeDAO.findByLookup(VtkDonorTypeValue.INDIVIDUAL));
		d.setLastName("Chen");
		d.setAddressLine1("5400 Legay Dr");
		d.setCity("Plano");
		d.setState(stateDAO.findStateByPostalCode("TX"));
		d.setZip("75024");

		return d;
	}

	/*
	 * @Test public void testFindByCriteria() { List<NationalOfficial> officials
	 * = nationalOfficialDAO.findByCriteria(new Long(251), ZonedDateTime.now());
	 * Assert.assertFalse("Failed - 251 didn't return any results",
	 * officials.isEmpty()); }
	 */

	@Override
	protected boolean testDelete() {
		return true;
	}

}
