package gov.va.vss.persistence;

import java.time.LocalDate;
import java.util.List;

import org.junit.Assert;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.VoluntaryServiceStaff;
import gov.va.vss.model.VtkUser;
import gov.va.vss.model.facility.Facility;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.dao.VoluntaryServiceStaffDAO;

public class TestVoluntaryServiceStaffDAO extends AbstractTransactionalWebDAOTest<VoluntaryServiceStaff> {

	@Autowired
	private VoluntaryServiceStaffDAO voluntaryServiceStaffDAO;

	@Override
	protected CustomizableAppDAO<VoluntaryServiceStaff> getDAO() {
		return voluntaryServiceStaffDAO;
	}

	@Override
	protected VoluntaryServiceStaff getInstanceToSave() {
		VoluntaryServiceStaff v = new VoluntaryServiceStaff();
		v.setAppUser(user);
		v.setReportOrder(1);
		Facility facility = findFacility("442");
		v.setFacility(facility);
		VtkUser vtkUser = new VtkUser();
		vtkUser.setFirstName("Stacey");
		vtkUser.setLastName("Zhang");
		vtkUser.setPrimaryInstitution(facility);
		vtkUser = vtkUserDAO.saveOrUpdate(vtkUser);
		v.setVtkUser(vtkUser);
		return v;
	}

	@Test
	public void testFindByCriteria() {
		long staffId = 1825;
		VoluntaryServiceStaff staffsFor442 = voluntaryServiceStaffDAO.findByPrimaryKey(staffId);					
		Assert.assertFalse("Failed - 442 didn't return any results", staffsFor442 == null );

		}

	protected Facility findFacility(String stationNum) {
		return facilityDAO.findByStationNumber(stationNum);
	}

	@Override
	protected boolean testDelete() {
		return true;
	}

}
