package gov.va.vss.persistence;

import java.time.LocalDate;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import gov.va.shared.model.lookup.sds.Gender.GenderType;
import gov.va.vss.AbstractTransactionalWebDAOTest;
import gov.va.vss.model.Volunteer;
import gov.va.vss.persistence.dao.CustomizableAppDAO;
import gov.va.vss.persistence.dao.VolunteerDAO;

public class TestVolunteerDAO extends AbstractTransactionalWebDAOTest<Volunteer> {

	@Autowired
	private VolunteerDAO volunteerDAO;

	@Override
	protected CustomizableAppDAO<Volunteer> getDAO() {
		return volunteerDAO;
	}

	@Override
	protected Volunteer getInstanceToSave() {
		Volunteer v = new Volunteer();
		v.setFirstName("Connor");
		v.setLastName("     ");
		v.setDateOfBirth(LocalDate.of(1950, 1, 1));
		v.setZip("80026");
		v.setCity("Lafayette");
		v.setState(stateDAO.findStateByPostalCode("CO"));
		v.setGender(genderDAO.findByLookup(GenderType.MALE));
		v.setAddressLine1("658 Wild Ridge Cir");
		// v.setContactInfo(vci);
		return v;
	}

	@Override
	protected boolean testDelete() {
		return true;
	}

	@Test
	public void testGetTimeSummary() {
		Volunteer instanceToSave = getInstanceToSave();
		if (instanceToSave != null)
			instanceToSave = getDAO().saveOrUpdate(instanceToSave);

		volunteerDAO.getTimeSummary(instanceToSave.getId());
	}

}
